/* dcc.c - control program for C compiler */
/* -o outfile              -c (don't link)     -P (stop after ppc)
 * -S (stop after parse)   -Dxxx[=yyy]         -Uxxx
 * -L (don't link stuff)   -86 (unimplemented 8086 code)
 * -Y[p02alIT],path (ppc,parse,psas,asm,dln,include dir, temp dir)
 * file.c file.i file.p file.o   or file.a file.o
 */
/*#define malloc testmalloc
#define realloc testrealloc
#define free testfree
int yylineno;
int inchar='~';
memmove(out,in,sz) char *out,*in;
{ if(out<in)
    while(sz--) *out++ = *in++;
  else
  { out+=sz; in+=sz;
    while(sz--) *--out = *--in;
  }
}
*/
#include <stdio.h>
#define E_MEM (-2)
char *malloc(),*realloc();
#define AL(place,size,type) { (place)=(type *)malloc((unsigned)(sizeof(type)\
  *(size)));\
 if ((char *)(place)==NULL)\
  yyerror("AL() can't get enough memory"),exit(E_MEM); }
#define RAL(place,size,type) { (place)=(type *)realloc((char *)(place)\
  ,(unsigned)(sizeof(type)*(size)));\
 if ((char *)(place)==NULL)\
  yyerror("RAL() can't get enough memory"),exit(E_MEM); }
#ifndef ISUNIX
FILE *batchfile;
#endif

#define setdelete(str) catstring(&delete,(str))

main(argc,argv) int argc; char *argv[];
{ char *parser,*psas,*link,temp[1024],*eparse,*epsas,*eln,*ending,*easm,*oasm;
  char *eppc,*ppc,*ppcargs,*psasargs,*delete;
  char *tempdir="",*precommand;
  int len,a,ln2,first;
  int stopbeforedln=0,stopatppc=0,stopatparse=0,autolink=1;

#ifndef ISUNIX /* this section is ***DOS*** */
  batchfile=fopen(/*"tempbat.bat" */ "d:\\tempbat.bat","w");
  if(!batchfile)
  { fprintf(stderr,"can't open batch file\n");
   exit(-1);
  }
  eppc="d:\\exec\\ppc.386"; eparse="d:\\exec\\parse.386 1244448";
  epsas="d:\\exec\\psas.386"; eln="d:\\exec\\dln.386";
  easm="d:\\exec\\asm.386 386";
  ending="out.386";
  precommand="386 ";
#else  /* this section is ***UNIX*** */
  eppc="ppc"; eparse="parse 1244448"; epsas="psas"; eln="dln";
  easm="asm 386";
  ending="out.386";
  precommand="";
#endif

  AL(ppc,1,char);      *ppc='\0';
  AL(parser,1,char);   *parser='\0';
  AL(psas,1,char);     *psas='\0';
  AL(link,1,char);     *link='\0';
  AL(oasm,1,char);     *oasm='\0';
  AL(ppcargs,1,char);  *ppcargs='\0';
  AL(psasargs,1,char); *psasargs='\0';

  AL(delete,1,char);   *delete='\0';
  for(a=1;a<argc;a++)
  { len=strlen(argv[a]);
    if(*argv[a]=='-')
    { switch(argv[a][1])
      { case 'o': /* output file */
         if(len!=2) break;
         if(++a<argc) ending=argv[a];
        continue;
        case 'c': /* stop before link */
         if(len!=2) break;
         stopbeforedln=1;
        continue;
        case 'P': /* stop at ppc */
         if(len!=2) break;
         stopatppc=1;
        continue;
        case 'S': /* stop at parse */
         if(len!=2) break;
         stopatparse=1;
        continue;
        case 'Y':
         if(argv[a][3]!=',') break;
         switch(argv[a][2])
         { case 'p': /* ppc's path */
            eppc=argv[a]+4;
           continue;
           case '0': /* parse's path */
            eparse=argv[a]+4;
           continue;
           case '2': /* psas's path */
            epsas=argv[a]+4;
           continue;
           case 'a': /* asm's path */
            easm=argv[a]+4;
           continue;
           case 'l': /* dln's path */
            eln=argv[a]+4;
           continue;
           case 'T': /* store temp files in this dir. instead of def. dir */
            if(a!=1)
            { yyerror("-YT,file should be first argument"); exit(-1); }
            tempdir=argv[a]+4;
            if(tempdir[strlen(tempdir)-1]!='\\')
            { sprintf(temp,"%s\\",tempdir);
              Scp(&tempdir,temp);
            }
            sprintf(temp,"-T%stemppsas",tempdir);
            catstring(&psasargs,temp);
           continue;
           case 'I': /* include dir */
            argv[a][2]='-'; argv[a][3]='I';
            catstring(&ppcargs,argv[a]+2);
           continue;
         }
        break;
        case 'D': /* like #define */
        case 'U': /* disable first #define of this object */
         catstring(&ppcargs,argv[a]);
        continue;
        case 'L': /* disable auto linking of default dirs */
         if(len!=2) break;
         autolink=0;
        continue;
        case '8':
         if(!strcmp(argv[a],"-86"))
         { eparse="parse 1224448"; epsas="psas86"; eln="dln86 ";
           easm="asm 86";
fprintf(stderr,"don't support 8086\n");
exit(-1);
           if(!strcmp(ending,"out.386")) ending="out.com";
         }
         else break;
        continue;
      }
      printf("warning: not treated as a switch: [%s]\n",argv[a]);
    }
    if(argv[a][len-2]!='.')
    { sprintf(temp,"unknown ending \"%s\"",argv[a]); yyerror(temp); exit(-1); }
    else
    { first=1;
      if(*tempdir)
      { FILE *in,*out;
        int b,c;

        first=0;

        in=fopen(argv[a],"r");
        sprintf(temp,"%s%s",tempdir,argv[a]);
        out=fopen(temp,"w");
        if(!in||!out)
        {copyerror:
          fprintf(stderr,"can't copy file \"%s\" to temporary \"%s\"\n"
            ,argv[a],temp);
         exit(-1);
        }
        do
        { b=fread(temp,1,1024,in);
          c=fwrite(temp,1,b,out);
          if(c!=b) goto copyerror;
        } while(b==1024);
        fclose(in); fclose(out);
      }
      sprintf(temp,"%s%s",tempdir,argv[a]);
      len+=strlen(tempdir);
      switch(temp[len-1])
      { default:
         yyerror("illegal postfix; compilation FAILED");
        exit(-1);
        case 'c':
         catstring(&ppc,temp);
         if(!first) setdelete(temp);
         first=0;
         if(stopatppc) break;
        case 'i':
         temp[len-1]='i';
         catstring(&parser,temp);
         if(!first) setdelete(temp);
         first=0;
         if(stopatparse) break;
        case 'p':
         temp[len-1]='p';
         catstring(&psas,temp);
         if(!first) setdelete(temp);
         first=0;
        goto object;
        case 'a':
         catstring(&ppc,"-asm");
         catstring(&ppc,temp);
         catstring(&ppc,"-noasm");
         if(!first) setdelete(temp);
         first=0;
         if(stopatppc) break;

         temp[len-1]='i';
         catstring(&oasm,temp);
         if(!first) setdelete(temp);
         first=0;
        object:
        case 'o':
         if(stopbeforedln) break;
         temp[len-1]='o';
         catstring(&link,temp);
         if(!first) setdelete(temp);
         first=0;
      }
    }
  }
  if(*ppc)
  { sprintf(temp,"%s%s%s",precommand,eppc,ppcargs);
    doexec(temp,ppc);
  }
  if(stopatppc) goto finishup;
  if(*parser)
  { sprintf(temp,"%s%s",precommand,eparse);
    doexec(temp,parser);
  }
  if(stopatparse) goto finishup;
  if(*psas)
  { sprintf(temp,"%s%s%s",precommand,epsas,psasargs);
    doexec(temp,psas);
  }
  if(*oasm)
  { sprintf(temp,"%s%s",precommand,easm);
    doexec(temp,oasm);
  }
  if(stopbeforedln) goto finishup;
  if(*link)
  { sprintf(temp,"%s%s %s",precommand,eln,ending);
#ifndef ISUNIX /* is DOS */
    if(autolink) catstring(&link,"d:\\exec\\lib3.o d:\\exec\\inclib.o");
#else /* UNIX */
    if(autolink) catstring(&link,"lib3.o inclib.o");
#endif
    doexec(temp,link);
  }
 finishup: ;
#ifndef ISUNIX
  fprintf(batchfile,"goto done\n:error\necho COMPILATION FAILED\n:done\n");
  fclose(batchfile);
#endif
/*  printf("delete list: [%s]\n",delete);
/*MERE: delete files */
}

catstring(out,in) char **out,*in;
{ int sz;
  sz=strlen(*out);
  RAL(*out,sz+2+strlen(in),char);
  sprintf(*out+sz," %s",in);
}

yyerror(s) char *s;
{ fprintf(stderr,"dcc control: %s: cannot trace further\n",s);
}

#ifdef ISUNIX
doexec(s,args) char *s,*args;
{ sprintf(s+strlen(s),"%s",args);
  printf("%s\n",s);
  if(system(s)) { yyerror("compilation FAILED"); exit(-1); }
}
#else
doexec(s,args) char *s,*args; /* assumes that s has lots of spare room */
{ fprintf(batchfile,"%s%s\nif errorlevel 1 goto error\n",s,args);
}
#endif
