/* header file for C compiler */
#ifndef NOFUNCTIONS
# include "headfunc.h"
#endif

/*
#define malloc testmalloc
#define realloc testrealloc
#define free testfree
/* */

#include "genhead.h"
struct vardefs
{ int cnt;
  int size; /* for struct */
  struct namedtype *pt;
} ;
struct pseudo /* pseudocode with special ptrs to breaks&continues */
{ flong l,bcnt,ccnt,*bd,*cd,*cspos,defpos,cscnt;
  int *csval,defcnt;
  char *d;
} ;
/* l,d- pseudocode
 * bd,bcnt- locations of labels for break's jmp
 * cd,ccnt- locations of labels for continue's jmp
 * cscnt,cspos,csval- location and value of case labels.
 * defpos,defcnt- location and existence of default: label
 */
struct pseudo allocprecode;
struct prevalue /* stores whole set of values */
{ int cnt; /* if cnt=0 no prevalue */
  struct intpval *s;
} ;

struct funcargspec
{ struct namedtype *args;
  short argcnt;
  char only; /* if only==1 then check sent arguments */
} ;
struct modstuff
{ union
  { flong arr;
    struct funcargspec fn;
  } u;
  char mod,null;
} ;
#define MSTAR   0 /* for mod */
#define MAR_ELE 1 /* null==1 if arr is not valid */
#define MFUNC   2 /* null==1 if types need to be filled after statement */

/* if argcnt=0 then only argument was (void); no args should be allowed. */
struct type /* type, include struc&union */
{ flong size;
  struct modstuff *mod;
  union
  { struct { short l;/*level*/ int o;/*offset*/ } p;
    char tp;
    char *nm; /* if body of structure not specified */
  } u;
  char curtp,modlev,modpos,field,scope;
  uchar treg,tvolatile,ptr,tp;
} ;
/*tp/u-   0- exact; structure-1 union-2 (see below)
 *size-   size of this type's storage requirements
 *curtp,cursz- specify type and size like psas
 *mod-    describe pointer/array/func specifiers.
 *fn-     function args with mod
 *arr-    array sizes with mod
 *treg/tvolotile/field- register/volatile/:size specifiers.
 *scope-  extern/static
 *ptr-    for & operator.
 */
#define STRUCT 1
#define UNION  2
#define NOTYPE 3 /* 4-unspec. struct 5-us. union */

struct intpval
{ uchar t; /* type */
  union
  { struct prevalue p;
    struct str { char *stf; flong len; } s; /*len includes NULL on end*/
    struct cptr { char sect; flong len,off,boff; } ptr; /*MERE: define these*/
    struct 
    { struct pseudo p;
      struct type t;
    } cd;
    flong l; double d;
  } u;
};
#define PRPREV     0
#define PRLONG     5
#define PRDOUBLE   7
#define PRPOINTER  8
#define PRSTRING   9 /* string/don't know weather to put in strcnst or extern*/
#define PRCODE    10

struct expr /* expression inc. true&false pointers */
{ struct type t;
  struct pseudo p; /* code for this expression */
  struct intpval c; /* prevalue internal struct */
  uchar const,lval,tcnt,fcnt,pconst; /* MERE: define const/pconst */
  flong *fpoint,*tpoint;
} ;
/* pconst- if 0, not a chance. If 2, then its something that can be &(expr)
 *  to get a constant pointer.  If 1, then it is a constant pointer. */
struct namedtype/*2*/
{ char *nm,bitoff/*,Didsexist,*Dids*/;
  int byteoff;
  struct type t;
  struct prevalue p;
  char sect;
  flong off;
} /*curnmt2*/;
/* byteoff/bitoff only used with struct element definitions.
 * nm,t,p- name, type, init stuff of variable; no init with struct element
 * sect,off- section, offset of variable
 * funcargs,funcargcnt- if type is SFUNC, then these specify arguments
/* stores namedtypes that don't have predefined values */
struct vds /* vardefS */
{ int tpdcnt,vdcnt,soudcnt,lvdcnt,ssn;
  struct namedtype *vd;
  struct namedtype/*2*/ *soud,*tpd;
  struct vardefs/*2*/ *lvd; /* each lvd[a] goes to one struct */
} *vds; /* all vds go here */
/* soud-stores names and corosponding types of struct/unions
 * tpd - 6"'s typedefs
 * lvd -stores definitions of all struct elements
 * vd  -stores definitions of all identifiers
 *  vds stores all identifiers that have been defined
 *  tvds temporarily stores identifiers until it is known where they go.
 */
struct varloadstack
{ char tp,rtn; /* type (VDT...), restrictions (VDR...)*/
  union
  { int num; /* indx into vds */
    struct vardefs vdfs;
  } u;
} *vldstack;
int vldscnt,vldAL;
#define VDTVD    1 /* use num and index vd */
#define VDTLOC   2 /* use vdfs */
#define VDTTPDEF 3 /* use num and index tpd */

#define VDRALLOC  1 /* allocvardefs for compound statements */
#define VDRARG    2 /* for argument defs. between func proto and compoundstat*/
#define VDRTPARG  3 /* for argument defs. within func proto. */
#define VDREXTERN 4 /* means these are global vars and should be allocated */
#define VDRLVD    5 /* lvd restrictions */
#define VDRTPDEF  6 /* typedef restrictions (only with func call; not stack)*/

char **elimmods;
int elimcnt;
char *autin; /* for allocvardefs */
int autincnt,ssn;

short int nextaddress,vdscnt; /* vdefs cnt, accesable vdefS, acc. cnt */
flong totssn;
char *strcnsts;
flong strclen;

int alignstructintern; /* 1- align each by 1,2 or 4 bytes */
int alignstructextern; /* 1- by 2 or 4;     2- to a power of 2 size */
int alignauto;         /* 1- only at end;   2- each piece by 2 or 4 */
