/* some string IO stuff (including printf's core) */
/*#define OS_EMULATE  /* */

#include <ctype.h>
#define EOF (-1)

/*#define TESTING /* */
#ifdef TESTING
# define LBERROR(args,func) do  \
   { fprintf  args;             \
     func;                      \
   } while(0)
#else
# define LBERROR(str,func) func
/*# define OPTIMIZED
*/
#endif

/* FILE IO definitions */

typedef struct _dccfiletp
{ int start,end,al;
  char *buf;
  struct _dccfiletp *next,*prev;
  int handle;
  char read,write,type,bufcntrl,err,lastch,eof;
} FILE;
/* al,buf,start,end- specify que for buffer total size al
 *   for input, end must be STDFILEAL/2 or 0; or EOF encountered. unless stdin
 *   leave room for ungetc.;
 * next,prev- linked list that tracks files
 *  (needed to close files when prog. ends)
 * handle- DOS's handle for the file.
 * read,write- permission
 * type- INBUF or OUTBUF
 * bufcntrl- NORMALBUF, UNUBUF
 * err- if 1 an error has occured.
 * */
#define INBUF      0 /* for type */
#define OUTBUF     1

#define NORMALBUF   0 /* for bufcntrl */
#define EDITBUF     1 /* for input */
#define OUTFLUSHBUF 2 /* cause stdout flush before input */
#define CONSTFLUSHBUF 4 /* never leave anything in buffer */

#define STDFILEAL 1024 /* default buffer size. When inputting, get 512 */
#define DIRINPUT  0x3f00 /* directions for _dccftransfer */
#define DIROUTPUT 0x4000

#define bufflush(file) (file->type==OUTBUF&&file->bufcntrl==CONSTFLUSHBUF\
   &&fflush(file))
int _dccftransfer(char *ptr,int *size,int handle,int direct);

char *_dccftransferarea;
static FILE start;
FILE *stdin,*stdout,*stderr;


/* miscellaneous */
putstr(s) char *s;
{ int a=0;
  while(s[a]) putchar(s[a++]);
}

getstr(s) char *s;
{ int a=0,c;
  while(c=getchar(),c!='\n'&&c!='\r')
  { if (c=='\b')
    { putstr(" \b");
      if(a>0) a--;
    }
    else s[a++]=c;
  }
  s[a]='\0';
}

#define BCDLEN 17

static padd0(strfunc,size) int (*strfunc)();
{ int err=0;
  for(;size>0;size-=10) err|=(*strfunc)("0000000000",(size>10?10:size));
 return err;
}

static paddspace(strfunc,size) int (*strfunc)();
{ int err=0;
  for(;size>0;size-=20)
    err|=(*strfunc)("                    ",(size>20?20:size));
 return err;
}

static inttobasestr(s,n,precision,shift,mask,tensvalue)
 char *s;
 unsigned n;
{ int e=0,f,maxdigits;
  char t[64];
  for(;n;n>>=shift)
  { f=(n&mask);
    t[e++]=(f<10?f+'0':f+tensvalue);
  }
  maxdigits=e;
  if(e<precision) e=precision;
  s[e]='\0'; f=0;
  while(f<maxdigits) s[--e]=t[f++];
  while(e) s[--e]='0';
}

_dcc_printf(charfunc,stringfunc,argsptr,stopchar)
   char *argsptr; int (*charfunc)(),(*stringfunc)(),stopchar;
/* this function assumes that int,long, and unsigned counterparts are
 *   all same size, and that when a short is pushed onto stack, it becomes int.
 *   also, assumes that stack image is push last first when calling
 *   so *argstr=fist argument; argstr[+something]=later arguments.
 * (*charfunc)(x) - output char x to appropriate place
 * (*stringfunc)(str,len) - output string str of length len
 * stopchar - stringfunc can't print this char correctly
 *   (used as $,\n in int 21 function ah=9)
 *    assume %s and %c and control string only places char might occur
 * argstr - pointst to stack image
 */
{ char *out,*original,*control,*lstcontrol,temp[1500]; /* printfdefs */
    /* temp big enough for '%lf' */
  int padwith0,width,usespace,usesign,alternateform,dash,err=0,len;
  int totalchar=0,val,islong,isshort,point,precision,a,exponent,Eore;
  int negative,removezeros;
  double dbl;
  original=control=lstcontrol= *(char **)argsptr; argsptr+=sizeof(char *);
  for(;*control;)
  { if(*control=='%')
    { err|=(*stringfunc)(lstcontrol,control-lstcontrol);
      totalchar+=control-lstcontrol;
      width= -1; padwith0=usespace=usesign=alternateform=dash=0;
     gotnonpointsoswitchagain: /* all calls chould let following inc control*/
      control++;
      switch(*control)
       /* all of this is before . in %[-](*|[0-9]*)(.(*|[0-9]*))?X*/
      { case '-':
#ifndef OPTIMIZED
         if(dash) puts("multiple '-' in printf format string/ using one only");
#endif
         dash^=1;
        goto gotnonpointsoswitchagain;
        case '*':
         width= *(int *)(argsptr); argsptr+=sizeof(int);
         if(width<0)
         { dash^=1;
           width= -width;
         }
         control++;
        case '.':
        break;
        case ' ':
         usespace=1;
        goto gotnonpointsoswitchagain;
        case '+':
         usesign=1;
        goto gotnonpointsoswitchagain;
        case '#':
         alternateform=1;
        goto gotnonpointsoswitchagain;
        case '0':
         padwith0=1;
        goto gotnonpointsoswitchagain;
        default:
         if(!isdigit(*control)) break; /* let 2nd switch check it */
         width=atoi(control);
         while(isdigit(*control)) control++;
      }
      point=isshort=islong=0; precision= -1;
     donepartbutswitch2:
      switch(*control) /* this handles stuff after . in format specifier */
      { case '.':
#ifndef OPTIMIZED
         if(point) puts("multiple . in printf format string");
#endif
         point=1;
         switch(*++control)
         { case '*':
            precision= *(int *)(argsptr); argsptr+=sizeof(int);
            if(precision<0) precision=0;
            control++;
           break;
           default:
            if(!isdigit(*control)) break;
            precision=atoi(control);
            while(isdigit(*control)) control++;
         }
        goto donepartbutswitch2;
        case '%': /* don't update so this will be printed */
         lstcontrol=control++; /* string on this (second) %; don't process it*/
        continue; /* main search loop */
        case 'i':
        case 'd':/*in this version, isshort and islong can be ignored*/
         dbl=(double)*(int *)(argsptr);
         argsptr+=sizeof(int);
         out=temp+1;
         if(precision<0) precision=1+(dbl<0);
         else precision+=(dbl<0);
         _dcc_inttostring(out,dbl,precision);
         if(dbl>=0)
         { if(usesign) *(out=temp)='+';
           else if(usespace) *(out=temp)=' ';
         }
        printitout:
         len=strlen(out);
         totalchar+=(len>width?len:width);
         if(padwith0&&!dash&&(*out=='-'||*out=='+'||*out==' '))
         { err|(*charfunc)(*out);
           width--; len--;
           out++;
         }
         if(!dash)
         { if(padwith0) err|=padd0(stringfunc,width-len);
           else err|=paddspace(stringfunc,width-len);
         }
         err|=(*stringfunc)(out,len);
         if(dash) err|=paddspace(stringfunc,width-len);
         control++;
        break;
        case 'o':
         out=temp+1;
         if(precision<0) precision=1;
         inttobasestr(out,*(int *)(argsptr),precision,3,7,'a');
         argsptr+=sizeof(int);
         if(*out!='0'&&alternateform) *(out=temp)='0';
        goto printitout;
        case 'x':
        case 'X':
         out=temp+2;
         if(precision<0) precision=1;
         inttobasestr(out,(val= *(int *)(argsptr)),precision
           ,4,15,(*control+('A'-'X'-10)));
         argsptr+=sizeof(int);
         if(val&&alternateform) { *(out=temp)='0'; temp[1]= *control; }
        goto printitout;
        case 'u':
         if(precision<0) precision=1;
         _dcc_inttostring((out=temp),(double)*(unsigned *)(argsptr),precision);
         argsptr+=sizeof(unsigned);
        goto printitout;
        case 'c':
         err|=(*charfunc)(*(int *)(argsptr)); argsptr+=sizeof(int);
         control++; totalchar++;
        break;
        case 's':
         out= *(char **)(argsptr); argsptr+=sizeof(char *);
         len=strlen(out);
         if(precision>=0&&len>precision)
         { val=out[precision];
           out[precision]='\0';
         }
         else precision=len;
         totalchar+=(precision>width?precision:width);
         if(!dash)
         { if(padwith0) err|=padd0(stringfunc,width-precision);
           else err|=paddspace(stringfunc,width-precision);
         }
         for(a=0;out[a];a++)
          if(out[a]==stopchar)
          { err|=(*stringfunc)(out,a);
            err|=(*charfunc)(out[a]);
            out+=a+1; a= -1;/* will be incremented to 0 */
          }
         err|=(*stringfunc)(out,a);
         if(precision>=0&&len>precision) out[a]=val;
         if(dash) err|=paddspace(stringfunc,width-precision);
         control++;
        break;
        case 'f':
        case 'F':
         removezeros=0;
         out=temp+1; /* room for [ +];below for decimal point */
         if(precision<0) precision=6; /* 6 digits after . */
         val=_dcc_dbltostring(out+1,(dbl= *(double *)(argsptr)),precision,-1);
         /* val is exponent; out[1] is first digit or '-' */
         argsptr+=sizeof(double);
        usef:
           /*?-0.XXXXX OR ?-XXX.XXX*/
         exponent=val;
         negative=(out[1]=='-');
         if(negative) out++; /* out[1] is first numeric digit */
         for(len=BCDLEN+1;len<=precision+exponent+1;len++) out[len]='0';
          /* the +1 and <= are a result of the first digit being in out[1] */
          /* second +1 is for the fact that you need a digit before the '.' */
         len=exponent;
         if(exponent<0)
         { len= -exponent;
           if(precision>=len) memmove(out+len+1,out+1,precision-len+1);
           for(;len>0;len--) out[len]='0'; /* fill out[1] through out[len] */
           /* note: len=0; */
         }
         len++; /* for first digit ... (exponent+1 digits before point) */
         memmove(out-1,out,len+1); /* make room for '.' ; insure '-' */
         out[len]='.';
         if(removezeros)
         { while(out[len+precision]=='0') precision--;
           if(alternateform||out[len+precision]!='.') precision++;
         }
         else len+=(alternateform||precision); /* cc for '.' */
         out[len+precision]='\0';
         if(!negative)
         { if(usesign) *(out=temp)='+';
           else if(usespace) *(out=temp)=' ';
         }
         else out--;
        goto printitout;
        case 'e':
        case 'E':
         removezeros=0;
         /*val becomes exponent*/
         /*?X.XXXXXXXXXXXXXXXXXX*/
         if(precision<0) precision=6; /* 6 digits after . */
         out=temp+1;
         val=_dcc_dbltostring(out+1,(dbl= *(double *)(argsptr)),-1,precision);
         argsptr+=sizeof(double);
         /* make temp[precision]='E' */
         Eore= *control;
        use_eorE:
         negative=(out[1]=='-');
         if(negative) *out++='-';
         *out=out[1]; out[1]='.';
         if(precision!=0||alternateform) precision+=2; /* 'X.' */
         else precision=1; /* just 'X' */
         if(precision>100) precision=100;
         for(len=BCDLEN+1;len<=precision;len++) out[len]='0';
          /* +1 and <= result of out[1] being first digit */
         if(removezeros)
         { while(out[precision]=='0') precision--;
           if(alternateform||out[precision]!='.') precision++;
         }
         out[precision++]=Eore;
         if(val>=0) out[precision++]='+';
         _dcc_inttostring(out+precision,(double)val,2+(val<0));
         if(!negative)
         { if(usesign) *(out=temp)='+';
           else if(usespace) *(out=temp)=' ';
         }
         else out--;
        goto printitout;
        case 'g':
        case 'G':
         removezeros=(alternateform^1);
         if(precision<0) precision=6; /* 6 digits after . */
         if(--precision<0) precision=0;
         out=temp+1;
         dbl= *(double *)(argsptr);
         argsptr+=sizeof(double);
         val=_dcc_dbltostring(out+1,dbl,-1,precision);
         if(val<-4||val>precision||precision<0)
         { Eore= *control+('E'-'G');
          goto use_eorE;
         }
         precision-=val;
         if(precision<0) precision=0;
        goto usef;
        case 'l':
#ifndef OPTIMIZED
         if(isshort||islong)
         { putstr("multiple [lh] in printf specifier ");
           puts(original);
         }
#endif
         islong=1;
         control++;
        goto donepartbutswitch2;
        case 'h':
#ifndef OPTIMIZED
         if(isshort||islong)
         { putstr("multiple [lh] in printf specifier ");
           puts(original);
         }
#endif
         isshort=1;
         control++;
        goto donepartbutswitch2;
#ifndef OPTIMIZED
        default:
         putstr("unknown character in ");
         puts(original);
#endif
      }
      lstcontrol=control;
    }
    else if(*control==stopchar)
    { err|=(*stringfunc)(lstcontrol,control-lstcontrol);
      err|=(*charfunc)(*control++);
      totalchar+=control-lstcontrol;
      lstcontrol=control;
    }
    else control++;
  }
  err|=(*stringfunc)(lstcontrol,control-lstcontrol);
  totalchar+=control-lstcontrol;
 return err?EOF:totalchar;
}

/* scanf stuff starts here */
double atof();
long atol();
#define SZDEFAULT 0  /* used in scanf for tracking %lx %hx */
#define SZLONG    1
#define SZSHORT   2
#define MAXSZ  512  /* maximum size of array (MUST be >=256 so temp with [])*/
static int ridspace(func,total) int (*func)(),*total;
{ int c;
  do
  { c=(*func)();
    (*total)++;
  } while(c==' '||c=='\t'||c=='\n');
 return c;
}

_dcc_scanf(getfunc,ungetfunc,argsptr)
   char **argsptr; int (*getfunc)(),(*ungetfunc)();
/* getfunc obtains a character; ungetfunc(c) ungets character c
 *   (requires its last getchar?)
 * *argsptr is assumed to be a pointer to the control string
 *  argsptr[x] ; 1<=x<=#args   ARE pointers to the places things are stored
 * assumptions similar to printf above; assume that int and long the same
 * assume that atoi will convert unsigned integers
 * assume ascii codes '0'<'9'<'A'<'F'<'a'<'f'
 *   and that '0'-'9','A'-'F','a'-'f' are continuous
 */
{ long longout;  /*scanfdefs*/
  int width,dontassign,totalchar=0,convcnt=0,tsz,size,a,c,endch,negate;
  int gotdigit,nullterminate;
  double dblout;
  char temp[MAXSZ],*control,*stringdst;
/*MERE: if bufferring ever done, then flush output buffer */
  control= *argsptr; argsptr++;
  while(*control)
  { switch(*control)
    { case '%':
       width= -1; dontassign=0; size=SZDEFAULT;
       control++;
      continuescanning:
       switch(*control++)
       { case '*':
#ifndef OPTIMIZED
          if(dontassign||size!=SZDEFAULT)
            puts("recoverable syntax error in for scanf");
#endif
          dontassign=1;
         goto continuescanning;
         case 'l':
#ifndef OPTIMIZED
          if(size!=SZDEFAULT)
            puts("multiple l's and h's in scanf control string");
#endif
          size=SZLONG;
         goto continuescanning;
         case 'h':
#ifndef OPTIMIZED
          if(size!=SZDEFAULT)
            puts("multiple l's and h's in scanf control string");
#endif
          size=SZSHORT;
         goto continuescanning;
         case '%':
          control--;
         goto expectcharacter;
         case 'd':
         case 'u':
          c=ridspace(getfunc,&totalchar);
          if(width<0||width>MAXSZ-2) width=MAXSZ-2; /* -1 for '\0' */
          tsz=0;
         isdecimal:
          if(c=='-') goto negative_d_start;
          while(isdigit(c)&&tsz<width)
          {negative_d_start: /* for negative; c is set to '-'; tsz=0 */
            temp[tsz++]=c;
            c=(*getfunc)(); totalchar++;
          }
          temp[tsz]='\0';
          longout=atol(temp);
         integerout: /* longout with value; c contains thing to unget */
          totalchar--;
          if(c!=EOF) (*ungetfunc)(c);
          if(tsz==1&&*temp=='-')
          { (*ungetfunc)('-'); c='-';
           goto condreturn;
          }
          if(tsz==0) goto condreturn;
          if(dontassign) break;
          switch(size)
          { case SZDEFAULT:
            case SZLONG:
             *(int *)*(argsptr++)=longout;
            break;
            default:
             puts("bad size");
            break;
            case SZSHORT:
             *(short *)*(argsptr++)=longout;
          }
          convcnt++;
         break;
         case 'o':
          c=ridspace(getfunc,&totalchar);
          tsz=0; *temp=c;
          if(negate=(c=='-'))
          { c=(*getfunc)(c); totalchar++;
            tsz++;
          }
          if(width<0||width>MAXSZ-2) width=MAXSZ-2; /* -1 for '\0' */
         octalnumber: /* nothing in c ; tsz=1 to always OK; negate set*/
          longout=0;
          while(c>='0'&&c<='7'&&tsz<width)
          { longout<<=3; longout+=c-'0'; tsz++;
            c=(*getfunc)();
            totalchar++;
          }
          if(negate) longout= -longout;
         goto integerout;
         case 'x':
          c=ridspace(getfunc,&totalchar);
          tsz=0; *temp=c;
          if(negate=(c=='-'))
          { c=(*getfunc)(c); totalchar++;
            tsz++;
          }
          if(width<0||width>MAXSZ-2) width=MAXSZ-2; /* -1 for '\0' */
         hexnumber: /* nothing in c ; tsz=1 to always OK; negate set*/
          longout=0;
          while(isxdigit(c)&&tsz<width)
          { longout<<=4;
            if(c<='9') longout+=c-'0';
            else if(c<='F') longout+=c+(10-'A');
            else longout+=c+(10-'a');
            tsz++;
            c=(*getfunc)();
            totalchar++;
          }
          if(negate) longout= -longout;
         goto integerout;
         case 'i':
          if(width<0||width>MAXSZ-2) width=MAXSZ-2; /* -1 for '\0' */
          c=ridspace(getfunc,&totalchar);
          tsz=0; *temp=c;
          negate=(c=='-');
          if(negate)
          { if(tsz>=width)
            { (*ungetfunc)(c); /* totalchar-- not needed */
             goto condreturn;
            }
            c=(*getfunc)(); totalchar++;
            tsz++;
          }
          if(c=='0'&&tsz<width)
          { c=(*getfunc)(); totalchar++; tsz++;
            if(c=='x'||c=='X')
            { a=(*getfunc)(); totalchar++; tsz++;
                 /* totalchar uneffected by these 2 lines */
              if(!isxdigit(a)||tsz>=width)
              { (*ungetfunc)(a); (*ungetfunc)(c); c='0'; totalchar-=2; tsz-=2;
               goto integerdecimal;
              }
              c=a;
             goto hexnumber;
            }
            else
            { if(c!=EOF) (*ungetfunc)(c);
              totalchar--; tsz--; c='0';
             goto octalnumber;
            }
          }
         integerdecimal:
          if(isdigit(c))
          { if(negate)
            { (*ungetfunc)(c); c='-'; totalchar--; tsz--;
            }
           goto isdecimal;
          }
          if(c!=EOF) /* tsz doesn't matter here because of goto condreturn */
          { (*ungetfunc)(c); /* totalchar--; not needed */
          }
          if(negate)
          { (*ungetfunc)('-'); c='-'; /* totalchar--; not needed */
          }
         goto condreturn;
         case 'n':
          switch(size)
          { case SZDEFAULT:
            case SZLONG:
             *(int *)*(argsptr++)=totalchar;
            break;
            default:
             puts("bad size");
            break;
            case SZSHORT:
             *(short *)*(argsptr++)=totalchar;
          }
          /* HERE: dontassign here? dontassign convcnt?*/
         break;
         case 'e':
         case 'f':
         case 'g': /*[+-][0-9]*[.][0-9]*E[+-][0-9]*/
          c=ridspace(getfunc,&totalchar);
          gotdigit=tsz=0;
          if(width<0||width>MAXSZ-2) width=MAXSZ-2; /* -1 for '\0' */
          if(!isdigit(c)&&c!='+'&&c!='-') goto nostartdigits;
          do
          { temp[tsz++]=c;
            if(!gotdigit&&isdigit(c)) gotdigit=1;
            c=(*getfunc)();
            totalchar++;
          } while(isdigit(c)&&tsz<width);
         nostartdigits:
          if(tsz>=width) goto dofloatnow;
          switch(c)
          { case '.':
             temp[tsz++]='.';
             while((c=(*getfunc)()),totalchar++,isdigit(c)&&tsz<width)
             { temp[tsz++]=c;
               if(!gotdigit&&isdigit(c)) gotdigit=1;
             }
             if(tsz>=width||toupper(c)!='E') goto dofloatnow;
            case 'E':
            case 'e':
             if(!gotdigit) break;
             temp[tsz++]=c;
             c=(*getfunc)();
             totalchar++;
             if((!isdigit(c)&&c!='+'&&c!='-')||tsz>=width) goto dofloatnow;
             do
             { temp[tsz++]=c;
               c=(*getfunc)();
               totalchar++;
             } while(isdigit(c)&&tsz<width);
          }
         dofloatnow: /* c=character to unget; tsz is size of it */
          temp[tsz]='\0';
          totalchar--;
          if(c!=EOF) (*ungetfunc)(c);
          if(!gotdigit)
          { if(tsz)
            { c= *temp;
              while(tsz) (*ungetfunc)(temp[--tsz]);
            }
           goto condreturn;
          }
          if(dontassign) break;
          dblout=atof(temp);
          switch(size)
          { case SZDEFAULT:
            case SZSHORT:
             *(float *)(*argsptr++)=dblout;
            break;
            case SZLONG:
             *(double *)(*argsptr++)=dblout;
          }
          convcnt++;
         break;
         case 's':
          nullterminate=1;
          c=ridspace(getfunc,&totalchar);
          for(a=0;a<256;a++) temp[a]=1; /* enable all chars */
          temp[' ']=temp['\t']=temp['\n']=0;
         stringjmp: /* c is first character */
              /* temp[0..255] are use/don't use for each ascii code */
          tsz=0;
          if(!dontassign) stringdst= *argsptr++;
          while(c!=EOF&&temp[c]&&(width<0||tsz<width))
          { if(!dontassign) *stringdst++=c;
            tsz++;
            c=(*getfunc)();
            totalchar++;
          }
          totalchar--;
          if(c!=EOF) (*ungetfunc)(c);
          if(tsz==0) goto condreturn;
          if(!dontassign)
          { if(nullterminate) *stringdst='\0';
            convcnt++;
          }
         break;
         case 'c':
          nullterminate=0;
          if(width<0) width=1;
          c=(*getfunc)();
          totalchar++;
          for(a=0;a<256;a++) temp[a]=1; /* enable all chars */
         goto stringjmp;
         case '[':
          nullterminate=1;
          for(a=0;a<256;a++) temp[a]=0; /* disable all chars */
          c= *control++;
          negate=(c=='^');
          if(negate) c= *control++;
          do   /* create list of legal chars */
          { endch=c;
            if(*control=='-')
            { control++;
              switch(*control)
              { case ']':
                 control--;
                break;
                default:
                 endch= *control++;
              }
            }
            for(;c<=endch;c++) temp[c]=1;
            c= *control++;
          } while(c!=']');
          if(negate) for(a=0;a<256;a++) temp[a]^=1;
          c=(*getfunc)();
          totalchar++;
         goto stringjmp;
#ifndef OPTIMIZED
         case '\0':
          puts("unexpected end of scanf control string");
         break;
#endif
         default:
          control--;
          if(isdigit(*control))
          { width=atoi(control);
            while(isdigit(*control)) control++;
          }
#ifndef OPTIMIZED
          else puts("syntax err in control string");
          if(size!=SZDEFAULT) puts("syntax error in scanf control string");
#endif
         goto continuescanning;
       }
      break;
      case ' ':
      case '\t':
      case '\n':
       control++;
       while(totalchar++,c=(*getfunc)(),c==' '||c=='\n'||c=='\t');
       totalchar--;
       if(c!=EOF) (*ungetfunc)(c);
      break;
      default:
      expectcharacter:
       c=(*getfunc)();
       totalchar++;
       if(c==EOF) goto eofreturn;
       if(c!= *control)
       { (*ungetfunc)(c); /* totalchar-- not needed! */
        goto normalreturn;
       }
       control++;
    }
  }
 /* note that the main loop exits here when the null is encountered */
 normalreturn: /* totalchar doesn't need to be correct here. */
     /* character buffer properly arranged; return convcnt */
 return convcnt;

 condreturn:
  if(c==EOF) goto eofreturn;
 return convcnt;

 eofreturn: /* nothing in c; just return */
  if(convcnt>0) goto normalreturn;
 return EOF;
}


/* memory allocation junk. */
static char spacefound;
#define MALLOC_BASIC 1
#define MALLOC_BTREE 2

static char *maxposition,*firstchunk;
char *_dccgetstacklocn(),*_dccgettopofprogram(),*_dccgetextendstart();
char *_dccgetextendend();
/* each chunk allocated as follows:
 *size          4  ; SIZEPIECE
 *pointertonext 4  ; NEXTPIECE
 *pointertoprev 4  ; PREVPIECE
 *userspace     sz ; located at byte offset HEADSZ
 */
#define SIZEPIECE(ptr) (*((int *)(ptr)))
#define NEXTPIECE(ptr) (((char **)(ptr))[1])
#define PREVPIECE(ptr) (((char **)(ptr))[2])
#define HEADSZ 12
#define NULL 0

/*FILE *stderr;
printmalloc()
{ char *chunk;
  int a;
fprintf(stderr,"firstchunk %#x alloccnt %d\n",firstchunk,alloccnt);
  for(chunk=firstchunk,a=0;a<=alloccnt;a++,chunk=NEXTPIECE(chunk))
    fprintf(stderr,"a %d chunk %#x NEXTPIECE %#x PREVPIECE %#x SIZE %d\n",a
       ,chunk,NEXTPIECE(chunk),PREVPIECE(chunk),SIZEPIECE(chunk));
}
*/

#ifdef OS_EMULATE

void _dccinitmem()
{ firstchunk=(char *)(((int)_dccgetextendstart()+3)&0xfffffffc);
  SIZEPIECE(firstchunk)=HEADSZ;
  NEXTPIECE(firstchunk)=NULL;
  maxposition=_emulators_get_loadlocn();
  spacefound=MALLOC_BASIC;
}

#else /*OS_EMULATE*/

void _dccinitmem()
/* Initialize (non-Btree, slow form) */
{ firstchunk=(char *)(((int)_dccgettopofprogram()+3)&0xfffffffc);
  maxposition=_dccgetstacklocn()-65536;
  SIZEPIECE(firstchunk)=HEADSZ;
  NEXTPIECE(firstchunk)=maxposition;
  SIZEPIECE(maxposition)=_dccgetextendstart()-maxposition;
  NEXTPIECE(maxposition)=NULL;
  PREVPIECE(maxposition)=firstchunk;
  maxposition=_dccgetextendend()-4;
  spacefound=MALLOC_BASIC;
}

#endif /*OS_EMULATE*/

static char *_dccmalloc(int sz)
/* malloc() that doesn't use Btree.  This is included so that
 * stuff initialized by _dccmain() doesn't cause the large (300 line)
 * Btree junk to be linked into the even the smallest programs. */
{ char *chunk,*startptr,*endptr;
  int cont,fullsize;

  if(!spacefound) _dccinitmem();

  sz=((sz+(HEADSZ+3))&0xfffffffc);
  for(chunk=firstchunk,cont=1;cont;chunk=NEXTPIECE(chunk))
  { startptr=chunk+SIZEPIECE(chunk);
    endptr=NEXTPIECE(chunk);
    if(!endptr)
    { cont=0; endptr=maxposition; }
    fullsize=endptr-startptr;
    if(fullsize<0) return NULL;
    if(fullsize>=sz)
    { NEXTPIECE(startptr)=NEXTPIECE(chunk);
      NEXTPIECE(chunk)=startptr;
      if(NEXTPIECE(startptr)!=NULL) PREVPIECE(NEXTPIECE(startptr))=startptr;
      PREVPIECE(startptr)=chunk;
      SIZEPIECE(startptr)=sz;
     return startptr+HEADSZ;
    }
  }
 return NULL;
}

static void _dccfree(char *ptr)
{ if(!spacefound) return;
  ptr-=HEADSZ;
  NEXTPIECE(PREVPIECE(ptr))=NEXTPIECE(ptr);
  if(NEXTPIECE(ptr)!=NULL) PREVPIECE(NEXTPIECE(ptr))=PREVPIECE(ptr);
}

void free(char *ptr);
static char *(*filemalloc)(int sz)=_dccmalloc;
static void (*filefree)()=_dccfree;
char *malloc(int sz);

   /* Btree stuff for malloc() */

#define N        32
#define SIZE     (N*2)
#define MININSSZ HEADSZ

typedef struct memnode NODE;

struct node_ele
{ int space;
  char *pptr;
  NODE *child;
};

struct memnode
{ int sz;
  struct node_ele elem[SIZE+2];
};
/* elem[0].child,elem[0].stf,...,elem[sz-1].stuff,elem[sz].child */

static int memdepth;
static NODE *memtree;

#define MAXDEPTH 7 /* actually, 6 + 1 spare */

static int nodecnt,neednodecnt;
NODE **topnode;
static char newmalloc_disallow;

static NODE *nodealloc()
{ NODE *ptr;
  if(nodecnt)
  { nodecnt--;
    ptr=(NODE *)topnode;
    topnode=(NODE **)*topnode;
   return ptr;
  }
  else
    LBERROR((stderr,"ERR nodealloc() memdepth %d nodecnt %d neednodecnt %d\n"
      ,memdepth,nodecnt,neednodecnt),return NULL);
}

static void nodefree(NODE *ptr)
{ nodecnt++;
  *(NODE ***)ptr=topnode;
  topnode=(NODE **)ptr;
}

static int alloc_cnt;

#define adjustneednodecnt() (neednodecnt=memdepth*2+MAXDEPTH+(alloc_cnt/64))

static void checknodecnt()
{ static adjustingnode;
  NODE *ptr;

  if(!adjustingnode)
  { adjustingnode=1;
    newmalloc_disallow=0;
    do
    { adjustneednodecnt();
      while(nodecnt<neednodecnt) /*Reset space */
      { ptr=(NODE *)malloc(sizeof *ptr);
        if(!ptr)
        { adjustingnode=0;
          newmalloc_disallow=1;
         return;
        }
        nodefree(ptr); /* Add this ptr to pool. */
      }
      while(nodecnt>neednodecnt+MAXDEPTH) /*Reset space */
      { ptr=nodealloc(); /* retreive ptr from pool. */
        if(!ptr)
        { adjustingnode=0;
          newmalloc_disallow=1;
         return;
        }
        free(ptr);
      }
    } while(nodecnt<neednodecnt); /* no way it could be > */
    adjustingnode=0;
  }
}

static void Bcreate(NODE **tree)
/* Be very carefull that _dccmalloc() and _dccinitmem()
 * don't allocate too many items to put in 1 node of memtree */
{ int i;
  (*tree)=(NODE *)nodealloc();
  if(!(*tree))
  { printf("can't get enough memory\n");
   exit(-1);
  }
  (*tree)->sz=0;
  (*tree)->elem->child=NULL;
}

static int Bbinsearch(struct node_ele *elem,int sz,int space,char *pptr)
{ int low,high,mid;
  struct node_ele *ptr;

  low=0; high=sz-1;

  while(1)
  { if(low>high) break;
    mid=(low+high)/2;
    ptr=elem+mid;
    if(ptr->space<space) low=mid+1;
    else if(ptr->space>space) high=mid-1;
    else if(ptr->pptr<pptr) low=mid+1;
    else if(ptr->pptr>pptr) high=mid-1;
    else /* they are equal */
      return mid;
  }
 return -1-low;
}

static int Binsert(NODE **tree,NODE *parent,int psplit,int space,char *pptr)
{ int split,success,newparent;
  NODE *temp;

  if(!pptr) LBERROR((stderr,"ERR Binsert() NULL pptr\n"),return 0);
     /* NULL pointers mess up deletion routine */

  if(space<MININSSZ) return 1;

  split=Bbinsearch((*tree)->elem,(*tree)->sz,space,pptr);
  if(split>=0)
     LBERROR((stderr,"ERR Binsert() already inserted space %d pptr %d\n"
        ,space,pptr),return 0);
  split= -1-split;

  if(!(*tree)->elem->child)  /* if at bottom of tree insert info directly */
  { success=1;

    memmove((*tree)->elem+split+1,(*tree)->elem+split
       ,((*tree)->sz-split+1)*sizeof(*(*tree)->elem));

    (*tree)->elem[split].space=space;
    (*tree)->elem[split].pptr=pptr;
    (*tree)->sz++;
  }
  else success=Binsert(&(*tree)->elem[split].child,(*tree),split,space,pptr);

  if((*tree)->sz>SIZE)                      /* keep within size bounds */
  { newparent= !parent;             /* grow upwards if necessary */
    if(newparent)
    { Bcreate(&parent);
      memdepth++;
    }

    memmove(parent->elem+psplit+1,parent->elem+psplit /* make room */
       ,(parent->sz-psplit+1)*sizeof(*parent->elem));

    temp=(*tree); /* *tree may be changed by below */
    parent->elem[psplit]=temp->elem[N]; /* insert splitting element */
    parent->elem[psplit].child=temp;
    Bcreate(&parent->elem[psplit+1].child);
    parent->sz++;

    temp=parent->elem[psplit+1].child;           /* do the split */
    memcpy(temp->elem,(*tree)->elem+N+1,(N+1)*sizeof(*temp->elem));

    temp->sz=(*tree)->sz=N;

    if(newparent) (*tree)=parent;     /* acknowledge any upword growth */
  }
 return success;
}

static void Bfixtree(NODE *tree,NODE **parent,int *split)
/* Only called if tree->sz is smaller then N.  This procedure combines
 * elements of parent and tree's siblings so that every node at tree's depth
 * has at least N elements.  parent and split are adjusted to point to the
 * new location of that element. */
{ NODE *temp;

  if(*split&&(temp=(*parent)->elem[*split-1].child)->sz>N)
     /* if can borrow an item from the left, do a right shift */
  { memmove(tree->elem+1,tree->elem,(tree->sz+1)*sizeof(*temp->elem));
    *tree->elem=(*parent)->elem[*split-1];
    tree->elem->child=temp->elem[temp->sz].child;
    temp->sz--;

    (*parent)->elem[*split-1].space=temp->elem[temp->sz].space;
    (*parent)->elem[*split-1].pptr=temp->elem[temp->sz].pptr;
    tree->sz++;
  }
  else if(*split<(*parent)->sz&&(temp=(*parent)->elem[*split+1].child)->sz>N)
     /* if can borrow an item from the right, do a left shift */
  { tree->elem[tree->sz].space=(*parent)->elem[*split].space;
    tree->elem[tree->sz].pptr=(*parent)->elem[*split].pptr;
    tree->elem[++tree->sz].child=temp->elem->child;

    (*parent)->elem[*split].space=temp->elem->space;
    (*parent)->elem[*split].pptr=temp->elem->pptr;

    memmove(temp->elem,temp->elem+1,temp->sz*sizeof(*temp->elem));
    temp->sz--;

    *parent= tree;
    *split=tree->sz-1;
  }
  else /* can't borrow individual element from either side. */
  { int newsplit;
    if(*split<(*parent)->sz)
       /* if can combine with the tree on the right, do so. */
    { temp=(*parent)->elem[*split+1].child;
      tree->elem[tree->sz].space=(*parent)->elem[*split].space;
      tree->elem[tree->sz].pptr=(*parent)->elem[*split].pptr;
      newsplit=tree->sz;
      tree->sz++;

      memcpy(tree->elem+tree->sz,temp->elem,(temp->sz+1)*sizeof(*temp->elem));
      tree->sz+=temp->sz;
      nodefree(temp);/********  ****** */

      memmove((*parent)->elem+ *split,(*parent)->elem+ *split+1
        ,((*parent)->sz- *split)*sizeof(*temp->elem));
      (*parent)->elem[*split].child= tree;
      (*parent)->sz--;

      *parent= tree;
      *split=newsplit;
    }
    else /* *split==(*parent)->sz
          * logically, it must be possible to combine with left; so do it. */
    { if(!*split)
      { fputs("Internal error in Bfixtree() (for malloc)",stderr);
       exit(-1);
      }
      temp=(*parent)->elem[*split-1].child;
      memmove(tree->elem+(1+temp->sz),tree->elem
        ,(tree->sz+1)*sizeof(*temp->elem));

      memcpy(tree->elem,temp->elem,(temp->sz+1)*sizeof(*temp->elem));

      tree->elem[temp->sz].space=(*parent)->elem[*split-1].space;
      tree->elem[temp->sz].pptr=(*parent)->elem[*split-1].pptr;
      tree->sz+=1+temp->sz;

      nodefree(temp);/********  ****** */

      (*parent)->elem[--(*parent)->sz].child=tree;
    }
  }
}

static int Bdelete_xchg(NODE *tree,NODE **parent,int *psplit
    ,struct node_ele *ele)
/* removes and returns the pointer associated with the largest element in
 * the tree.  Also adjusts each level of the tree with Bfixtree().
 * parant, psplit- start out pointing to split element that pointed to this
 * node.  If fixtree changes things, these are set to point at the new
 * location of that node. */
{ NODE *temp;
  int split;
  int stat;

  if(!tree) return 0;

  temp=tree;
  split=temp->sz;
  stat=Bdelete_xchg(temp->elem[split].child,&temp,&split,ele);
  if(!stat) *ele=tree->elem[--tree->sz];
  if(tree->sz<N&&parent) Bfixtree(tree,parent,psplit);
 return 1;
}

static char *Bdelete(NODE **comtree,NODE **parent,int psplit,int space
   ,char *pptr)
/* Deletes the item with smallest space>space or (if small_space==space)
 *  it deletes the one with the smallest pptr */
{ int split;
  NODE *temp,*tree;
  char *stat;

  if(space<MININSSZ) return pptr;

  tree= *comtree;

  if(!tree) return NULL;
  split=Bbinsearch(tree->elem,tree->sz,space,pptr);

  if(split>=0) /* exact match, can't get any better */
  { stat=NULL;
  }
  else
  { split= -1-split;
    stat=Bdelete(&tree->elem[split].child,comtree,split,space,pptr);
  }

  if(!stat&&split<tree->sz&&tree->elem[split].space>=space)
  { int rplc;
    struct node_ele nd;

    temp=tree;
    rplc=Bdelete_xchg(tree->elem[split].child,&temp,&split,&nd);

    stat=temp->elem[split].pptr;
    if(rplc)
    { temp->elem[split].space=nd.space;
      temp->elem[split].pptr=nd.pptr;
      if(tree->sz==0)
      { nodefree(tree);
        memdepth--;
        (*comtree)=tree=temp;
      }
    }
    else /* we were already at the bottom */
    { memmove(temp->elem+split,temp->elem+split+1
         ,(temp->sz-split+1)*sizeof(*temp->elem));
      temp->sz--;
    }
  }

  if(tree->sz<N&&parent)
  { temp= *parent;
    Bfixtree(tree,&temp,&psplit);
    if((*parent)->sz==0)
    { nodefree(*parent);
      (*parent)=tree;
      memdepth--;
    }
  }
 return stat;
}

void _dcc_checktree(NODE *tree,int depth)
{ int i;
  static cnt;
  static firstnode,lastspace;
  static char *lastpptr;

  if(!depth) firstnode=1;

  if(tree)
  { for(i=0;i<tree->sz;i++)
    { checktree(tree->elem[i].child,depth+1);
      if(!firstnode)
      { if(tree->elem[i].space<lastspace||(tree->elem[i].space==lastspace
          &&tree->elem[i].pptr<=lastpptr)) fprintf(stderr,"INCONSISTENT\n");
      }
      else firstnode=0;
/*
      fprintf(stderr,"%*d %d\n",70-10*depth,tree->elem[i].space
         ,tree->elem[i].pptr);
*/
      lastspace=tree->elem[i].space;
      lastpptr=tree->elem[i].pptr;
    }
    checktree(tree->elem[i].child,depth+1);
  }
  else if(depth-1!=memdepth)
    fprintf(stderr,"INCONSISTENT2 %d %d\n",depth,memdepth);
}

char *malloc(int sz)
{ char *chunk,*startptr,*endptr;
  int cont,fullsize;

  if(newmalloc_disallow) return NULL;

  if(!(spacefound&MALLOC_BTREE))
  { if(!spacefound) _dccinitmem();
    nodefree(_dccmalloc(sizeof(NODE)));
    Bcreate(&memtree);
    for(chunk=firstchunk,cont=1;cont;chunk=NEXTPIECE(chunk))
    { startptr=chunk+SIZEPIECE(chunk);
      endptr=NEXTPIECE(chunk);
      if(!endptr)
      { cont=0; endptr=maxposition; }
      fullsize=endptr-startptr;
      if(fullsize<0) LBERROR((stderr,"ERR malloc() 3\n"),return NULL);
      if(!Binsert(&memtree,NULL,0,fullsize,chunk)) return NULL;
    }
    spacefound=MALLOC_BTREE;
    filemalloc=malloc;
    filefree=free;
  }
  sz=((sz+(HEADSZ+3))&0xfffffffc);
  chunk=Bdelete(&memtree,NULL,0,sz,NULL);
  if(!chunk)
  { checknodecnt();
   return NULL; /* Standard out-of-memory */
  }
  
  startptr=chunk+SIZEPIECE(chunk);
  endptr=NEXTPIECE(chunk);
  if(!endptr) endptr=maxposition;
  fullsize=endptr-startptr;

  if(fullsize<sz) LBERROR((stderr,"ERR malloc() 2\n"),return NULL);
  if(!Binsert(&memtree,NULL,0,fullsize-sz,startptr))
    LBERROR((stderr,"ERR malloc() 1\n"),return NULL);

  NEXTPIECE(startptr)=NEXTPIECE(chunk);
  NEXTPIECE(chunk)=startptr;
  if(NEXTPIECE(startptr)!=NULL) PREVPIECE(NEXTPIECE(startptr))=startptr;
  PREVPIECE(startptr)=chunk;
  SIZEPIECE(startptr)=sz;

  checknodecnt();
  alloc_cnt++;
 return startptr+HEADSZ;
}

char *realloc(ptr,sz) char *ptr;
{ char *chunk,*startptr,*endptr,*prevchunk;
  int fullsize;

  if(!ptr) return malloc(sz);

  if(!spacefound) LBERROR((stderr,"ERR spacefound realloc()\n"),return NULL);
  sz=((sz+(HEADSZ+3))&0xfffffffc);
  chunk=ptr-HEADSZ;
  prevchunk=PREVPIECE(chunk);
  startptr=prevchunk+SIZEPIECE(prevchunk);

  endptr=NEXTPIECE(chunk);
  if(endptr==NULL) endptr=maxposition;

  fullsize=endptr-startptr;
  if(fullsize<0)
    LBERROR((stderr
      ,"ERR realloc() 3 fullsize %d endptr %#x startptr %#x\n",fullsize,endptr
      ,startptr),return NULL);
  if(fullsize>=sz)
  { if(Bdelete(&memtree,NULL,0,endptr-(chunk+SIZEPIECE(chunk)),chunk)!=chunk)
      LBERROR((stderr,"ERR realloc() 1\n"),return NULL);
    if(Bdelete(&memtree,NULL,0,chunk-startptr,prevchunk)!=prevchunk)
      LBERROR((stderr,"ERR realloc() 2\n"),return NULL);

    if(!Binsert(&memtree,NULL,0,fullsize-sz,startptr))
      LBERROR((stderr,"ERR realloc() 4\n"),return NULL);
    if(startptr!=chunk)
    { memmove(startptr,chunk,sz);
      NEXTPIECE(prevchunk)=startptr;
      if(NEXTPIECE(startptr)!=NULL) PREVPIECE(NEXTPIECE(startptr))=startptr;
      chunk=startptr;
    }
    SIZEPIECE(chunk)=sz;

    checknodecnt();
   return chunk+HEADSZ;
  }
  else
  { sz-=HEADSZ; chunk+=HEADSZ;
    startptr=malloc(sz);
    if(startptr!=NULL)
    { memcpy(startptr,chunk,sz);
      free(chunk);
    }
   return startptr;
  }
}

void free(char *ptr)
{ char *chunk,*startptr,*endptr,*prevchunk,*ret;
  int fullsize;

  if(!ptr) return;

  if(!spacefound) LBERROR((stderr,"ERR spacefound in free()\n"),return);
  chunk=ptr-HEADSZ;
  prevchunk=PREVPIECE(chunk);
  startptr=prevchunk+SIZEPIECE(prevchunk);

  endptr=NEXTPIECE(chunk);
  if(endptr==NULL) endptr=maxposition;

  if((ret=Bdelete(&memtree,NULL,0,endptr-(chunk+SIZEPIECE(chunk)),chunk))
      !=chunk)
    LBERROR((stderr,"ERR free() 1 sz %d chunk %d ret %d\n"
      ,endptr-(chunk+SIZEPIECE(chunk)),chunk,ret),return);
  if((ret=Bdelete(&memtree,NULL,0,chunk-startptr,prevchunk))!=prevchunk)
    LBERROR((stderr,"ERR free() 2 sz %d prevchunk %d ret %d\n"
      ,chunk-startptr,prevchunk,ret),return);

  fullsize=endptr-startptr;
  if(fullsize<0) LBERROR((stderr,"ERR free() 2.5\n"),return);
  if(!Binsert(&memtree,NULL,0,fullsize,prevchunk))
    LBERROR((stderr,"ERR free() 3\n"),return);

  NEXTPIECE(prevchunk)=NEXTPIECE(chunk);
  if(NEXTPIECE(chunk)!=NULL) PREVPIECE(endptr)=prevchunk;

  alloc_cnt--;
  checknodecnt();
}

/* file IO instructions. */

int fflush(FILE *file)
{ int sz,size;

  if(file->err) goto error;
  if(file->start!=file->end)
  { if(file->type==OUTBUF)
    { sz=size=(file->end>file->start?file->end:file->al)-file->start;
      if(_dccftransfer(file->buf+file->start,&size,file->handle,DIROUTPUT)
         ||size)
        goto error;
      file->start+=sz;
      if(file->start==file->al)
      { if(_dccftransfer(file->buf,&file->end,file->handle,DIROUTPUT)
           ||file->end)
          goto error;
      }
    }
    else /* type==INBUF */
    { static avoid=0;
      if(avoid) return 0; /* fseek calling fflush back */
      avoid=1;
      fseek(file,0,1);
      avoid=0;
    }
    file->end=file->start=0;
  }
 return 0;
 error:
  file->err=1;
  file->start+=sz-size;
 return EOF;
}

int _dccmain(int argc,char *argv[])
/* init start (a header for the linked list), stdin,stdout,and stderr */
{ int out;
  start.next=NULL;

  stdin=(FILE *)(*filemalloc)(sizeof(FILE));
  if(!stdin) exit(-1);
  stdin->buf=(*filemalloc)(STDFILEAL);
  if(!stdin->buf) exit(-1);
  stdin->read=1;
  stdin->err=stdin->write=stdin->start=stdin->end=0;
  stdin->al=STDFILEAL;
  stdin->bufcntrl=EDITBUF+OUTFLUSHBUF; stdin->type=INBUF;
  stdin->eof=stdin->lastch=stdin->handle=0;

  stdout=(FILE *)(*filemalloc)(sizeof(FILE));
  if(!stdout) exit(-1);
  stdout->buf=(*filemalloc)(STDFILEAL);
  if(!stdout->buf) exit(-1);
  stdout->write=1;
  stdout->eof=stdout->err=stdout->read=stdout->start=stdout->end=0;
  stdout->al=STDFILEAL;
  stdout->bufcntrl=NORMALBUF; stdout->type=OUTBUF;
  stdout->handle=1;
  stdout->prev=stdin; stdin->next=stdout;
  
  stderr=(FILE *)(*filemalloc)(sizeof(FILE));
  if(!stderr) exit(-1);
  stderr->buf=(*filemalloc)(STDFILEAL);
  if(!stderr->buf) exit(-1);
  stderr->write=1;
  stderr->eof=stderr->err=stderr->read=stderr->start=stderr->end=0;
  stderr->al=STDFILEAL;
  stderr->bufcntrl=CONSTFLUSHBUF; stderr->type=OUTBUF;
  stderr->handle=2;
  stderr->prev=stdout; stdout->next=stderr;
  stderr->next=NULL;
  start.next=stdin;

  _dccftransferarea=(*filemalloc)(0x400);
  if(!_dccftransferarea) exit(-1);

  out=main(argc,argv);
  _dccfreeallfiles();
 return out;
}

_dccfreeallfiles()
{ FILE *filelist,*nextfile;
  for(filelist=start.next;filelist;filelist=nextfile)
  { nextfile=filelist->next;
    if(filelist->handle<=2)
        fflush(filelist);
    else fclose(filelist);
  }
}

static getinput(FILE *file)
{ int a=0,size,position;
  if(file->bufcntrl&OUTFLUSHBUF&&fflush(stdout))
  { file->err=1;
   return EOF;
  }
  /* input al/2 */
  size=((file->al*3)>>2);
  if(file->al-file->end<size)
  { a=file->al-file->end;
    size-=a;
    if(_dccftransfer(file->buf+file->end,&a,file->handle,DIRINPUT)||a)
    { file->end=file->al-a;
      if(file->start==file->end)
      { file->eof=1;
       return EOF;
      }
     return 0;
    }
    file->end=0;
  }
  if(file->end==file->start)
    file->end=file->start=0;
  position=file->end;
  file->end+=size;
  if(_dccftransfer(file->buf+position,&size,file->handle,DIRINPUT)||size)
  { file->end-=size;
    if(file->start==file->end)
    { file->eof=1;
     return EOF;
    }
  }
 return 0;
}

_dcccheckoutfile(FILE *file,int sz)
{ /* check that it is ready for output */
  if(file->err) goto error;
  if(file->type==INBUF)
  { if(fflush(file)||!file->write) goto error;
    file->type=OUTBUF;
  }
  else
  { if(file->bufcntrl==CONSTFLUSHBUF) fflush(stdout);
    if(sz&&file->end-file->start+(file->end>=file->start
      ?0:file->al)+sz>=file->al&&fflush(file))
        /* check size; if too big, flush buffer; if error... */
        goto error;
  }
 return 0;
 error:
 return 1;
}

_dcccheckinfile(FILE *file,int sz)
{ if(file->err) goto error;
  if(file->type==OUTBUF)
  { if(fflush(file)||!file->read) goto error;
    file->lastch=0;
    file->type=INBUF;
  }
  if(file->end-file->start+(file->end>=file->start?0:file->al)<sz
    &&getinput(file))
     goto error;
 return 0;
 error:
 return 1;
}

putchar(int ch)
/*MERE: future redefine this as a macro; its so simple... */
{ return putc(ch,stdout);
}

/*putc(int ch,FILE *file)
/*{ int end;
/*  end=file->end+1;
/*  if(end==file->al) end=0;
/*  if(file->err||file->type!=OUTBUF||(file->bufcntrl==CONSTFLUSHBUF
/*    &&stdout->start!=stdout->end)||file->start==end)
/*  { if(_dcccheckoutfile(file,1))
/*      return EOF;
/*    end=file->end+1;
/*    if(end==file->al) end=0;
/*  }
/*  if(ch=='\n')
/*  { file->buf[file->end]='\r';
/*    file->end=end;
/*    if(_dcccheckoutfile(file,1)) return ch;
/*    end=file->end+1;
/*    if(end==file->al) end=0;
/*  }
/*  file->buf[file->end]=ch; file->end=end;
/*  if(bufflush(file)) return EOF;
/* return ch;
/*}
*/

int _dccfwrite(char *str,int len,FILE *file)
{ int a,orglen;
  orglen=len;
  if(len>=file->al)
  { if(_dcccheckoutfile(file,0)||fflush(file)
       ||_dccftransfer(str,&len,file->handle,DIROUTPUT)||len)
    {error:
      file->err=1;
      if(len==orglen) return EOF;
     return orglen-len;
    }
  }
  else
  { if(_dcccheckoutfile(file,len)) goto error; /* there will be room */

    if(len+file->end>file->al)
    { a=file->al-file->end;
      memcpy(file->buf+file->end,str,a);
      str+=a; len-=a;
      file->end=0;
    }

    memcpy(file->buf+file->end,str,len);
    file->end+=len;
    if(file->end==file->al) file->end=0;
  }
  if(bufflush(file)) return EOF;
 return orglen;
}

_dccfread(char *str,int len,FILE *file)
{ int size,orglen,stat,lastlen;
  orglen=len;

  if(_dcccheckinfile(file,1)) return EOF;

  file->lastch=0;
  if(file->end<file->start)       /* handle wrap around */
  { size=file->al-file->start;
    if(size>len) size=len;
    memcpy(str,file->buf+file->start,size);
    str+=size; len-=size;
    file->start+=len;
    if(file->start>=file->end) file->start=0;
  }
  if(len==0) return orglen;

  size=file->end-file->start;     /* handle rest of buffer */
  if(size>len) size=len;
  memcpy(str,file->buf+file->start,size);
  str+=size; len-=size;
  file->start+=size;
  if(file->end==file->start) file->end=file->start=0;
  if(len==0) return orglen;

  do               /* get stuff not in buffer. */
  { lastlen=len;
    stat=_dccftransfer(str,&len,file->handle,DIRINPUT);
    str+=lastlen-len;
  } while(stat!=1&&len&&len!=lastlen);
  if(stat==2||len)
  { file->eof=1;
   return orglen-len;
  }
 return orglen;
}

puts(char *str)
{ int i,a,len,lastpos;
  char *laststr,*modstr;
  len=strlen(str);
  str[len]='\n'; /* this is a sentenal; it will be replaced later */
  for(modstr=laststr=str,i=0;i<=len;i++,modstr++)
  { if(*modstr=='\n')
    { if(_dccfwrite(laststr,modstr-laststr,stdout)!=modstr-laststr
         ||putc('\n',stdout)!='\n')
      { str[len]='\0';
       return EOF;
      }
      laststr=modstr+1;
    }
  }
  str[len]='\0';
 return 0;
}

fputs(char *str,FILE *file)
{ int i,a,len,lastpos;
  char *laststr,*modstr;
  len=strlen(str);
  str[len]='\n'; /* this is a sentenal; it will be replaced later */
  for(modstr=laststr=str,i=0;i<=len;i++,modstr++)
  { if(*modstr=='\n')
    { if(_dccfwrite(laststr,modstr-laststr,file)!=modstr-laststr
         ||(i!=len&&putc('\n',file)!='\n'))
      { str[len]='\0';
       return EOF;
      }
      laststr=modstr+1;
    }
  }
  str[len]='\0';
 return 0;
}

getchar()
{ return getc(stdin);
}

/*getc(FILE *file) /*MEREfuture: as macro */
/*{ int ch;
/*
/*  if((file->err||file->type!=INBUF||file->start==file->end)
/*      &&_dcccheckinfile(file,1))
/*     return EOF;
/*
/*   /* MEREfuture: how should this be truncated (for >127) */
/*  ch=(unsigned char)file->buf[file->start++];
/*  if(file->start==file->al) file->start=0;
/*
/*  if(ch=='\r')
/*  { if(file->lastch=='\n')
/*    { if(file->start==file->end&&_dcccheckinfile(file,1)) return EOF;
/*      ch=(unsigned char)file->buf[file->start++];
/*      if(file->start==file->al) file->start=0;
/*    }
/*    file->lastch=ch;
/*
/*    if(ch=='\r')
/*    { if(file->start==file->end&&_dcccheckinfile(file,1)) return ch;
/*      ch=(unsigned char)file->buf[file->start];
/*      if(ch!='\n') ch='\r';
/*      else if(++file->start==file->al) file->start=0;
/*    }
/*  }
/*  else file->lastch=ch;
/* return ch;
/*}
*/

int ungetc(int ch,FILE *file)
{ if(ch==EOF||_dcccheckinfile(file,0)) return EOF;

  if(file->start==0) file->start=file->al;
  file->buf[--file->start]=ch;
  if(file->start==file->end)
  { file->start++;
    if(file->start==file->al) file->start=0;
   return EOF;
  }
 return ch;
}

char *gets(char *str)
{ int ch;
  char *mstr;
  mstr=str;
  while(ch=getc(stdin),ch!='\n'&&ch!='\r'&&ch!=EOF) *mstr++=ch;
  if(mstr!=str||ch!=EOF)
  { *mstr='\0';
   return str;
  }
  else return 0;
}

char *fgets(char *str,int n,FILE *file)
{ int ch=EOF; /* force consistent behaiviour with n<2 */
  char *mstr;
  mstr=str;
  while(--n>0&&(ch=getc(file),ch!='\n'&&ch!='\r'&&ch!=EOF)) *mstr++=ch;
  if(mstr!=str||ch!=EOF)
  { if(n>0&&ch!=EOF) *mstr++=ch;
    *mstr='\0';
   return str;
  }
  else return 0;
}

FILE *fopen(char *nm,char *perm)
{ int len,read=0,write=0,end=0,change=0,handle,rAX;
  FILE *outfile;
  len=strlen(perm);
  if(len!=1&&(len!=2||perm[1]!='+')) return NULL;
  len--;
  switch(*perm)
  { case 'r':
     read=1;
     if(len) write=1;
    break;
    case 'w':
     change=write=1;
     if(len) read=1;
    break;
    case 'a':
     end=write=1;
     if(len) read=1;
    break;
    default: return NULL;
  }
  rAX=(write<<read)+0x3c00+((!change)<<8);
  handle=_dccfopen(nm,rAX);
  if(handle==0xffffffff) /* error occurred */
    return NULL;
  outfile=(FILE *)malloc(sizeof(FILE));
  if(!outfile) return NULL;
  outfile->buf=malloc(STDFILEAL);
  if(!outfile->buf)
  { (*filefree)(outfile);
   return NULL;
  }
  outfile->handle=handle;
  outfile->read=read;
  outfile->write=write;
  outfile->eof=outfile->lastch=outfile->err=outfile->start=outfile->end=0;
  outfile->al=STDFILEAL;
  outfile->type=read?INBUF:OUTBUF; outfile->bufcntrl=NORMALBUF;
  outfile->next=start.next; outfile->prev= &start;
  start.next=outfile;
  if(outfile->next) outfile->next->prev=outfile;
  if(end)
  { if(fseek(outfile,0,2))
    { (*filefree)(outfile->buf); (*filefree)(outfile);
     return NULL;
    }
  }
 return outfile;
}

int fclose(FILE *fptr)
{ int err;
  err=fptr->err;
  err|=fflush(fptr);
  err|=_dccfclose(fptr->handle);
  if(fptr->next) fptr->next->prev=fptr->prev;
  fptr->prev->next=fptr->next;
  (*filefree)(fptr->buf);
  (*filefree)(fptr);
 return err?EOF:0;
}

int fread(char *ptr,int size,int nitems,FILE *file)
{ int totsize;
  if(nitems<=0) return 0;
  totsize=size*nitems;
  totsize=_dccfread(ptr,totsize,file);
  if(totsize==EOF) return EOF;
  else return totsize/size;
}

int fwrite(char *ptr,int size,int nitems,FILE *file)
{ int totsize;
  if(nitems<=0) return 0;
  totsize=size*nitems;
  totsize=_dccfwrite(ptr,totsize,file);
  if(totsize==EOF) return 0;
  else return totsize/size;
}

int rewind(FILE *file)
{ fseek(file,0,0);
}

int system(char *command)
{ int a,len,out;
  char *chunk;
  fflush(stdout);
  for(chunk=firstchunk;(a=NEXTPIECE(chunk))&&a<0x100000;chunk=a);
/*  if(NEXTPIECE(chunk)) fprintf(stderr,"not last piece in first chunk\n");
 *  chunk=chunk+SIZEPIECE(chunk);*/
  chunk+=HEADSZ;
  len=strlen(command);
  command[len]='\r';
  len++;
  out=_dcc_system(chunk,command,len);
  command[len]='\0';
 return out;
}
