%{ /* lexical analyzer for C compiler */
#include <stdio.h>
#include "head.h"
#include <ctype.h>

#define yywrap() 1  /* this is what the disassembly does as well... */

#ifdef DEBUG
  char * comment[16];
  int cn;
  typedef union  token
  { char *pchar;
    struct str string;
    struct pseudo pseudo;
    struct namedtype ntype;
    double ndouble;
    long nlong;
    struct expr expr;
    struct type type;
    struct vds vds;
  } YYSTYPE;
  YYSTYPE yylval;
  main()
  { char *p;
    extern char *yytext;

    if (sizeof(int)<sizeof(char *))
    { printf("Can't work!\n");
      exit(-1);
    }
    while (p=(char *)yylex())
    { printf("%-10.10s is \"%s\" =%ld or '%c'\n"
       ,p,yytext,yylval.nlong,(char)yylval.nlong);
    /*  if (!strcmp(p,"STRCONST")) printf("(or \"%s\")\n"
         ,strcnsts[yylval.string.off]);
*/
    }
  }
# define token(x) ((int)"x") /* return name rather then # (y.tab.h) */
# define LSHFT 1 /* needed to keep compiler happy about origin */
# define RSHFT 2
#else
# define token(x) x
# include "y.tab.h"
#endif
char *filenm,newfile;
/*#define INTEGRAL (yylval.nlong>1L<<((soint<<3)-1)-1||yylval.nlong<(-(1L<<\
   ((soint<<3)-1)))?token(LNUM):token(INUM))
*/
#define INTEGRAL (solong>soint&&(yylval.nlong>0x7fff||yylval.nlong<\
    0xffff8000)?token(LNUM):token(INUM))
/*[1-9][0-9]* { yylval.nlong=atoi(yytext); return token(INUM); }
 * Use above if you want to distinguish int and long */
%}
%%
auto return token(AUTOSP);
break return token(BREAK);
case return token(CASE);
char return token(CHARSP);
continue return token(CONTINUE);
default return token(DEFAULT);
do return token(DO);
double return token(DOUBLESP);
else return token(ELSE);
extern return token(EXTERNALSP);
float return token(FLOATSP);
for return token(FOR);
goto return token(GOTO);
if return token(IF);
int return token(INTSP);
long { return token(LONGSP); }
register return token(REGISTERSP);
return return token(RETURN);
short { return token(SHORTSP); }
sizeof return token(SIZEOF);
static return token(STATICSP);
struct { yylval.nlong=STRUCT; return token(STRoUNION); }
switch return token(SWITCH);
typedef return token(TYPEDEF);
union { yylval.nlong=UNION; return token(STRoUNION); }
unsigned return token(UNSIGNSP);
void return token(VOIDSP);
volatile return token(VOLATILESP);
while return token(WHILE);
\"([^"\\]|\\.)*\" { AL(yylval.string.stf,yyleng,char);
   for(yylval.string.len=0,a=1;a<yyleng-1/* skip last " */;a++)
   { if(yytext[a]=='\n')
     yyerror("illegal new line in string constant. assuming \\n");
     yylval.string.stf[yylval.string.len++]
       =yytext[a]=='\\'?expand(yytext+a+1,&a):yytext[a];
   }
   yylval.string.stf[yylval.string.len++]='\0';
   return token(STRCONST); }
(\'\\.\'|\'\\[0-7]+\') { yylval.nlong=expand(yytext+2,&a);
   return token(CHRCONST); }
\'[^\\]\' { if(yytext[1]=='\n')
     yyerror("illegal new line in character constant. assuming \\n");
   yylval.nlong=yytext[1]; if (yytext[1]=='\'')
   yyerror("illegal charecter constant. assuming \'\\\'\'");
   return token(CHRCONST); }
0[0-9]* { yylval.nlong=atoo(yytext+1); return INTEGRAL; }
[1-9][0-9]* { yylval.nlong=atoi(yytext); return INTEGRAL; }
[1-9][0-9]*[Ll] { yylval.nlong=atoi(yytext); return token(LNUM); }
[0-9]+\.?[0-9]*([Ee][+-]?[0-9]+)? { yylval.ndouble=atof(yytext);
  return token(FNUM); }
[0-9]*\.?[0-9]+([Ee][+-]?[0-9]+)? { yylval.ndouble=atof(yytext);
  return token(FNUM); }
0[Xx][0-9a-fA-F]+ { for(yylval.nlong=0,a=2;a<yyleng;a++)
  yylval.nlong=(yylval.nlong<<4)+(yytext[a]-'0'>9?toupper(yytext[a])-'A'+10
   :yytext[a]-'0'); return INTEGRAL; }
[A-Za-z_][A-Za-z0-9_]* { for(b=vdscnt-1;b>=0;b--)
     for(a=0;a<vds[b].tpdcnt;a++)
      if (!strcmp(yytext,vds[b].tpd[a].nm))
      { yylval.ntype=vds[b].tpd[a];
       return token(DTYPE); }
   Scp(&yylval.pchar,yytext); return token(ID);
 }
\/\*[^*]+\*\/ { for(a=2;isdigit(yytext[a]);a++);
  if(yytext[a]!='L') { fatal=1; yyerror("unknown line identifier"); }
  b=atoi(yytext+2)+1; a+=b;
  yylineno=atoi(yytext+a); newfile=1;
  yytext[a]='\0'; RAL(filenm,b,char); memcpy(filenm,yytext+(a-b+1),b); }
"<<" return token(LSHFT);
">>" return token(RSHFT);
"->" return token(ARROW);
"++" return token(PP);
"--" return token(MM);
">=" return token(GE);
"<=" return token(LE);
"==" return token(EQ);
"!=" return token(NE);
"&&" return token(CAND);
"||" return token(COR);
[+\-*/%^&|]"=" { yylval.nlong=yytext[0]; return token(COMPLEX_E); }
"<<=" { yylval.nlong=LSHFT; return token(COMPLEX_E); }
">>=" { yylval.nlong=RSHFT; return token(COMPLEX_E); }
[\n\t\r ] ;
. return token(yytext[0]);
