#line 1 "dlex.l"
 /* lexical analyzer for C compiler */
#include <stdio.h>
#include "head.h"
#include <ctype.h>

#define yywrap() 1  /* this is what the disassembly does as well... */

#ifdef DEBUG
  char * comment[16];
  int cn;
  typedef union  token
  { char *pchar;
    struct str string;
    struct pseudo pseudo;
    struct namedtype ntype;
    double ndouble;
    long nlong;
    struct expr expr;
    struct type type;
    struct vds vds;
  } YYSTYPE;
  YYSTYPE yylval;
  main()
  { char *p;
    extern char *yytext;

    if (sizeof(int)<sizeof(char *))
    { printf("Can't work!\n");
      exit(-1);
    }
    while (p=(char *)yylex())
    { printf("%-10.10s is \"%s\" =%ld or '%c'\n"
       ,p,yytext,yylval.nlong,(char)yylval.nlong);
    /*  if (!strcmp(p,"STRCONST")) printf("(or \"%s\")\n"
         ,strcnsts[yylval.string.off]);
*/
    }
  }
# define token(x) ((int)"x") /* return name rather then # (y.tab.h) */
# define LSHFT 1 /* needed to keep compiler happy about origin */
# define RSHFT 2
#else
# define token(x) x
# include "y.tab.h"
#endif
char *filenm,newfile;
/*#define INTEGRAL (yylval.nlong>1L<<((soint<<3)-1)-1||yylval.nlong<(-(1L<<\
   ((soint<<3)-1)))?token(LNUM):token(INUM))
*/
#define INTEGRAL (solong>soint&&(yylval.nlong>0x7fff||yylval.nlong<\
    0xffff8000)?token(LNUM):token(INUM))
/*[1-9][0-9]* { yylval.nlong=atoi(yytext); return token(INUM); }
 * Use above if you want to distinguish int and long */

  /* types: */
#define YY_CLASS_TP yy_uint7
#define YY_STATE_TP yy_uint8
#define YY_PRODN_TP yy_uint7
#define YY_FRWD_REF_TP yy_uint7

/* drive.c - FSM driver for lex clone */
/*NOTE: when copied, #define YY_CLASS_TP, YY_STATE_TP, YY_PRODN_TP,
 *  and YY_FRWD_REF_TP 
 *  to one of yy_uint7, yy_uint8, yy_uint16, or yy_uint32 */

#include <stdio.h>
#include <malloc.h>

/*#define YY_UNSIGNED_PROBLEM /* */
/*#define YY_NO_CHARS /* */

#ifndef YY_BULK
#  define YY_BULK(buf,elem_sz,len,file) \
      fread(buf,elem_sz,len,file)
#endif /*YY_BULK*/

void yy_fatalerror();
FILE *yyin={stdin},*yyout={stdout};

#ifdef YY_NO_CHARS
  typedef unsigned short yy_uint7;
#else
  typedef unsigned char  yy_uint7;
#endif /*YY_NO_CHARS*/
#ifdef YY_UNSIGNED_PROBLEM
  typedef unsigned short yy_uint8;
#else
  typedef unsigned char  yy_uint8;
#endif /*YY_UNSINGED_PROBLEM*/
typedef unsigned short yy_uint16;
typedef unsigned long  yy_uint32;

/* names:
 *  YY_VC_*  = virtual_charset character
 *  yy_b_*   = input buffer manager
 *  yy_l_*   = lexer of lex input file  related function
 */

   /* buffer definitions */

#ifdef YY_TESTING_LEX
# define YY_BUF_GROWTH_SZ   2
#else
# ifdef YY_TESTING_PARSE
#  define YY_BUF_GROWTH_SZ  2
# else
#  define YY_BUF_GROWTH_SZ  512
# endif
#endif

  /* NOTE: I set the sentinel to new line so that I don't need a seperate
   *   test for newline to count lines. */
#define YY_BUF_SENTINEL   '\n'

#define yy_b_begin_token()  (yy_inbuf.posn=yy_inbuf.start  \
     ,yy_inbuf.posn.linecnt=0)
#define yy_b_accept_mark()  (yy_inbuf.accept=yy_inbuf.posn)
#define yy_b_reset_posn()   (yy_inbuf.start=yy_inbuf.accept \
     ,yylineno+=yy_inbuf.accept.linecnt)

#define yy_b_len()          (yy_inbuf.start.bufnum==yy_inbuf.accept.bufnum \
      ?yy_inbuf.accept.ptr-yy_inbuf.start.ptr                              \
      :yy_inbuf.sz[yy_inbuf.start.bufnum]                                  \
          -(yy_inbuf.start.ptr-yy_inbuf.data[yy_inbuf.start.bufnum])       \
        +yy_inbuf.accept.ptr-yy_inbuf.data[yy_inbuf.accept.bufnum])

#ifdef YY_UNSIGNED_PROBLEM
#  define yy_b_getchar() (*yy_inbuf.posn.ptr!=YY_BUF_SENTINEL? \
       ((*(yy_inbuf.posn.ptr++))&0xff):yy_b_special_getchar())
#else
#  define yy_b_getchar() (*yy_inbuf.posn.ptr!=YY_BUF_SENTINEL \
       ?*(yy_inbuf.posn.ptr++):yy_b_special_getchar())
#endif /* UNSIGNED_PROBLEM */

typedef unsigned char yy_buf_elem;
struct yy_buf_mark
{ int bufnum,linecnt;
  yy_buf_elem *ptr;
};

static struct
{ yy_buf_elem *(data[2]);
  int sz[2];
  struct yy_buf_mark start,accept,posn,eof;
  int lastload;
} yy_inbuf;

  /* vc map definitions */
static YY_CLASS_TP yy_vc_map[256]=
 {
    0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  2,  0,  0,  1,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    1,  3,  4,  0,  0,  5,  6,  7,  0,  0,  8,  9,  0, 10, 11, 12,
   13, 14, 14, 14, 14, 14, 14, 14, 15, 15,  0,  0, 16, 17, 18,  0,
    0, 19, 19, 19, 19, 20, 19, 21, 21, 21, 21, 21, 22, 21, 21, 21,
   21, 21, 21, 21, 21, 21, 21, 21, 23, 21, 21,  0, 24,  0,  5, 21,
    0, 25, 26, 27, 28, 29, 30, 31, 32, 33, 21, 34, 35, 21, 36, 37,
   38, 21, 39, 40, 41, 42, 43, 44, 45, 46, 47,  0, 48,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
   };
#define YY_CNT_VC 49
 /* contents inserted by lex */

   /* finite state machine definitions */
YY_PRODN_TP yy_frwd_prodn[]=
 {
   /*state   1*/ 
   /*state   2*/ 
   /*state   3*/ 
   /*state   4*/ 
   /*state   5*/ 
   /*state   6*/ 
   /*state   7*/ 
   /*state   8*/ 
   /*state   9*/ 
   /*state  10*/ 
   /*state  11*/ 
   /*state  12*/ 
   /*state  13*/ 
   /*state  14*/ 
   /*state  15*/ 
   /*state  16*/ 
   /*state  17*/ 
   /*state  18*/ 
   /*state  19*/ 
   /*state  20*/ 
   /*state  21*/ 
   /*state  22*/ 
   /*state  23*/ 
   /*state  24*/ 
   /*state  25*/ 
   /*state  26*/ 
   /*state  27*/ 
   /*state  28*/ 
   /*state  29*/ 
   /*state  30*/ 
   /*state  31*/ 
   /*state  32*/ 
   /*state  33*/ 
   /*state  34*/ 
   /*state  35*/ 
   /*state  36*/ 
   /*state  37*/ 
   /*state  38*/ 
   /*state  39*/ 
   /*state  40*/ 
   /*state  41*/ 
   /*state  42*/ 
   /*state  43*/ 
   /*state  44*/ 
   /*state  45*/ 
   /*state  46*/ 
   /*state  47*/ 
   /*state  48*/ 
   /*state  49*/ 
   /*state  50*/ 
   /*state  51*/ 
   /*state  52*/ 
   /*state  53*/ 
   /*state  54*/ 
   /*state  55*/ 
   /*state  56*/ 
   /*state  57*/ 
   /*state  58*/ 
   /*state  59*/ 
   /*state  60*/ 
   /*state  61*/ 
   /*state  62*/ 
   /*state  63*/ 
   /*state  64*/ 
   /*state  65*/ 
   /*state  66*/ 
   /*state  67*/ 
   /*state  68*/ 
   /*state  69*/ 
   /*state  70*/ 
   /*state  71*/ 
   /*state  72*/ 
   /*state  73*/ 
   /*state  74*/ 
   /*state  75*/ 
   /*state  76*/ 
   /*state  77*/ 
   /*state  78*/ 
   /*state  79*/ 
   /*state  80*/ 
   /*state  81*/ 
   /*state  82*/ 
   /*state  83*/ 
   /*state  84*/ 
   /*state  85*/ 
   /*state  86*/ 
   /*state  87*/ 
   /*state  88*/ 
   /*state  89*/ 
   /*state  90*/ 
   /*state  91*/ 
   /*state  92*/ 
   /*state  93*/ 
   /*state  94*/ 
   /*state  95*/ 
   /*state  96*/ 
   /*state  97*/ 
   /*state  98*/ 
   /*state  99*/ 
   /*state 100*/ 
   /*state 101*/ 
   /*state 102*/ 
   /*state 103*/ 
   /*state 104*/ 
   /*state 105*/ 
   /*state 106*/ 
   /*state 107*/ 
   /*state 108*/ 
   /*state 109*/ 
   /*state 110*/ 
   /*state 111*/ 
   /*state 112*/ 
   /*state 113*/ 
   /*state 114*/ 
   /*state 115*/ 
   /*state 116*/ 
   /*state 117*/ 
   /*state 118*/ 
   /*state 119*/ 
   /*state 120*/ 
   /*state 121*/ 
   /*state 122*/ 
   /*state 123*/ 
   /*state 124*/ 
   /*state 125*/ 
   /*state 126*/ 
   /*state 127*/ 
   /*state 128*/ 
   /*state 129*/ 
   /*state 130*/ 
   /*state 131*/ 
   /*state 132*/ 
   /*state 133*/ 
   /*state 134*/ 
   /*state 135*/ 
   /*state 136*/ 
   /*state 137*/ 
   /*state 138*/ 
   /*state 139*/ 
   /*state 140*/ 
   /*state 141*/ 
   /*state 142*/ 
   /*state 143*/ 
   /*state 144*/ 
   /*state 145*/ 
   /*state 146*/ 
   /*state 147*/ 
   /*state 148*/ 
   /*state 149*/ 
   /*state 150*/ 
   /*state 151*/ 
   /*state 152*/ 
   /*state 153*/ 
   /*state 154*/ 
   /*state 155*/ 
   /*state 156*/ 
   /*state 157*/ 
   /*state 158*/ 
   /*state 159*/ 
   /*state 160*/ 
   /*state 161*/ 
   /*state 162*/ 
   /*state 163*/ 
   /*state 164*/ 
   /*state 165*/ 
   /*state 166*/ 
   /*state 167*/ 
   /*state 168*/ 
   /*state 169*/ 
   /*state 170*/ 
   /*state 171*/ 
   /*state 172*/ 
   /*state 173*/ 
   /*state 174*/ 
   /*state 175*/ 
   /*state 176*/ 
   /*state 177*/ 
   /*state 178*/ 
   /*state 179*/ 
   /*state 180*/ 
   /*state 181*/ 
   /*state 182*/ 
   /*state 183*/ 
   /*state 184*/ 
   /*state 185*/ 
   /*state 186*/ 
   /*state 187*/ 
   /*state 188*/ 
   /*state 189*/ 
   /*state 190*/ 
  0 /* only use is to hide syntax error */
 };
 /* contents inserted by lex */

struct yy_buf_mark yy_frwd_posn
#define YY_RULECNT 57
  [YY_RULECNT];
 /* contents inserted by lex (just size in brackets) */

char yy_frwd_use[]=
 {
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 };
 /* contents inserted by lex */

struct yy_l_machine_state
{ YY_STATE_TP nextstate[YY_CNT_VC];
  YY_FRWD_REF_TP frwdoff;
  YY_PRODN_TP frwdcnt;
  YY_PRODN_TP accept;
} yy_l_machine[]=
 { {{0}}, /*state 0 (dump state)*/
  {{   /*state 1*/
       2,  3,  3,  4,  6, 10, 12, 14, 10, 21, 23, 26, 31, 36, 44, 44,
      46, 50, 52, 56, 56, 56, 56, 56,  2, 57, 61, 66, 80, 92,101,108,
      56,112, 56,116, 56, 56, 56,120,132,156,163,174,184, 56, 56, 56,
     189
   },   0,   0,   0
  },
  {{   /*state 2*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  56
  },
  {{   /*state 3*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  55
  },
  {{   /*state 4*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  5,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  56
  },
  {{   /*state 5*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  49
  },
  {{   /*state 6*/
       7,  7,  7,  7,  8,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,
       7,  7,  7,  7,  7,  7,  7,  7,  9,  7,  7,  7,  7,  7,  7,  7,
       7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,
       7
   },   0,   0,  56
  },
  {{   /*state 7*/
       7,  7,  7,  7,  8,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,
       7,  7,  7,  7,  7,  7,  7,  7,  9,  7,  7,  7,  7,  7,  7,  7,
       7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,
       7
   },   0,   0,   0
  },
  {{   /*state 8*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  30
  },
  {{   /*state 9*/
       7,  7,  0,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,
       7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,
       7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,
       7
   },   0,   0,   0
  },
  {{   /*state 10*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  56
  },
  {{   /*state 11*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  52
  },
  {{   /*state 12*/
       0,  0,  0,  0,  0,  0, 13,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  56
  },
  {{   /*state 13*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  50
  },
  {{   /*state 14*/
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 17, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15
   },   0,   0,  56
  },
  {{   /*state 15*/
       0,  0,  0,  0,  0,  0,  0, 16,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,   0
  },
  {{   /*state 16*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  32
  },
  {{   /*state 17*/
      18, 18,  0, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 20, 20, 18,
      18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18,
      18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18,
      18
   },   0,   0,   0
  },
  {{   /*state 18*/
       0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,   0
  },
  {{   /*state 19*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  31
  },
  {{   /*state 20*/
       0,  0,  0,  0,  0,  0,  0, 19,  0,  0,  0,  0,  0, 20, 20,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,   0
  },
  {{   /*state 21*/
       0,  0,  0,  0,  0,  0,  0,  0,  0, 22,  0,  0,  0,  0,  0,  0,
       0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  56
  },
  {{   /*state 22*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  44
  },
  {{   /*state 23*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 24,  0,  0,  0,  0,  0,
       0, 11, 25,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  56
  },
  {{   /*state 24*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  45
  },
  {{   /*state 25*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  43
  },
  {{   /*state 26*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27, 27, 27,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  56
  },
  {{   /*state 27*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 27, 27, 27,
       0,  0,  0,  0, 28,  0,  0,  0,  0,  0,  0,  0,  0, 28,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  37
  },
  {{   /*state 28*/
       0,  0,  0,  0,  0,  0,  0,  0,  0, 29, 29,  0,  0, 30, 30, 30,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,   0
  },
  {{   /*state 29*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 30, 30, 30,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,   0
  },
  {{   /*state 30*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 30, 30, 30,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  37
  },
  {{   /*state 31*/
       0,  0,  0,  0,  0,  0,  0,  0, 32,  0,  0,  0,  0,  0,  0,  0,
       0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  56
  },
  {{   /*state 32*/
      33, 33, 33, 33, 33, 33, 33, 33,  0, 33, 33, 33, 33, 33, 33, 33,
      33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
      33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
      33
   },   0,   0,   0
  },
  {{   /*state 33*/
      33, 33, 33, 33, 33, 33, 33, 33, 34, 33, 33, 33, 33, 33, 33, 33,
      33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
      33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
      33
   },   0,   0,   0
  },
  {{   /*state 34*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 35,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,   0
  },
  {{   /*state 35*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  40
  },
  {{   /*state 36*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 37,  0, 41, 41, 41,
       0,  0,  0,  0, 38,  0,  0, 42,  0,  0,  0,  0,  0, 38,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 42,  0,  0,
       0
   },   0,   0,  33
  },
  {{   /*state 37*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 37, 37, 37,
       0,  0,  0,  0, 38,  0,  0,  0,  0,  0,  0,  0,  0, 38,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  36
  },
  {{   /*state 38*/
       0,  0,  0,  0,  0,  0,  0,  0,  0, 39, 39,  0,  0, 40, 40, 40,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,   0
  },
  {{   /*state 39*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 40, 40, 40,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,   0
  },
  {{   /*state 40*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 40, 40, 40,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  36
  },
  {{   /*state 41*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 37,  0, 41, 41, 41,
       0,  0,  0,  0, 38,  0,  0,  0,  0,  0,  0,  0,  0, 38,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  33
  },
  {{   /*state 42*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 43, 43, 43,
       0,  0,  0, 43, 43,  0,  0,  0,  0, 43, 43, 43, 43, 43, 43,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,   0
  },
  {{   /*state 43*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 43, 43, 43,
       0,  0,  0, 43, 43,  0,  0,  0,  0, 43, 43, 43, 43, 43, 43,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  38
  },
  {{   /*state 44*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 37,  0, 44, 44, 44,
       0,  0,  0,  0, 38,  0, 45,  0,  0,  0,  0,  0,  0, 38,  0,  0,
       0,  0,  0, 45,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  34
  },
  {{   /*state 45*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  35
  },
  {{   /*state 46*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      47, 49,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  56
  },
  {{   /*state 47*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0, 48,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  41
  },
  {{   /*state 48*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  53
  },
  {{   /*state 49*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  47
  },
  {{   /*state 50*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0, 51,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  56
  },
  {{   /*state 51*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  48
  },
  {{   /*state 52*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0, 53, 54,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  56
  },
  {{   /*state 53*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  46
  },
  {{   /*state 54*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0, 55,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  42
  },
  {{   /*state 55*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  54
  },
  {{   /*state 56*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 57*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 58, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 58*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 59, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 59*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 60, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 60*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,   1
  },
  {{   /*state 61*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 62, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 62*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 63, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 63*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 64, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 64*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 65, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 65*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,   2
  },
  {{   /*state 66*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 67, 56, 56, 56, 56, 56, 56,
      70, 56, 56, 56, 56, 73, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 67*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 68, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 68*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 69, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 69*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,   3
  },
  {{   /*state 70*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 71, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 71*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 72, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 72*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,   4
  },
  {{   /*state 73*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 74, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 74*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 75, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 75*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 76, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 76*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 77, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 77*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 78, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 78*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 79, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 79*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,   5
  },
  {{   /*state 80*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 81, 56, 56,
      56, 56, 56, 56, 56, 87, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 81*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 82, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 82*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 83, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 83*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 84, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 84*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 85, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 85*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 86, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 86*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,   6
  },
  {{   /*state 87*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 88, 56, 56, 56, 56, 56,
       0
   },   0,   0,   7
  },
  {{   /*state 88*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 89, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 89*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 90, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 90*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 91, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 91*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,   8
  },
  {{   /*state 92*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 93, 56, 56, 56, 56, 56, 56, 56, 56, 56, 96, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 93*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 94, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 94*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 95, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 95*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,   9
  },
  {{   /*state 96*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 97, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 97*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 98, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 98*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 99, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 99*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56,100, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 100*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  10
  },
  {{   /*state 101*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56,102, 56,106, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 102*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56,103, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 103*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0,104, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 104*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56,105, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 105*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  11
  },
  {{   /*state 106*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56,107, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 107*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  12
  },
  {{   /*state 108*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56,109, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 109*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56,110, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 110*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56,111, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 111*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  13
  },
  {{   /*state 112*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56,113, 56,
      56, 56, 56, 56,114, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 113*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  14
  },
  {{   /*state 114*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56,115, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 115*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  15
  },
  {{   /*state 116*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56,117, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 117*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56,118, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 118*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56,119,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 119*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  16
  },
  {{   /*state 120*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56,121, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 121*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56,122,
      56, 56, 56, 56, 56, 56, 56, 56, 56,128, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 122*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56,123, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 123*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56,124, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 124*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56,125, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 125*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56,126, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 126*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56,127, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 127*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  17
  },
  {{   /*state 128*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56,129, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 129*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56,130, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 130*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56,131, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 131*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  18
  },
  {{   /*state 132*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
     133,137, 56, 56, 56, 56, 56, 56, 56,142, 56, 56,151, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 133*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56,134, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 134*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56,135, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 135*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56,136, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 136*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  19
  },
  {{   /*state 137*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,138,
       0
   },   0,   0,  39
  },
  {{   /*state 138*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56,139, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 139*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56,140, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 140*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56,141, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 141*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  20
  },
  {{   /*state 142*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0,143, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56,147, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 143*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56,144, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 144*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56,145, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 145*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56,146, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 146*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  21
  },
  {{   /*state 147*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56,148, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 148*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56,149, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 149*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56,150, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 150*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  22
  },
  {{   /*state 151*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56,152, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 152*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56,153, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 153*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56,154, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 154*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
     155, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 155*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  23
  },
  {{   /*state 156*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,157, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 157*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56,158, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 158*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56,159, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 159*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56,160, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 160*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56,161, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 161*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56,162, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 162*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  24
  },
  {{   /*state 163*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56,164, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 164*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56,165, 56, 56, 56, 56, 56, 56,168, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 165*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56,166, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 166*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56,167, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 167*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  25
  },
  {{   /*state 168*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56,169, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 169*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56,170,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 170*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56,171, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 171*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56,172, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 172*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56,173, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 173*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  26
  },
  {{   /*state 174*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56,175, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 175*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56,176, 56,178, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 176*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56,177, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 177*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  27
  },
  {{   /*state 178*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0,179, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 179*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56,180, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 180*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56,181, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 181*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56,182, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 182*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56,183, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 183*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  28
  },
  {{   /*state 184*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
     185, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 185*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56,186, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 186*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56,187, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 187*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56,188, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  39
  },
  {{   /*state 188*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 56, 56, 56,
       0,  0,  0, 56, 56, 56, 56, 56,  0, 56, 56, 56, 56, 56, 56, 56,
      56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,
       0
   },   0,   0,  29
  },
  {{   /*state 189*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0, 11,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     190
   },   0,   0,  56
  },
  {{   /*state 190*/
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
       0
   },   0,   0,  51
  }
};
 /* contents inserted by lex */

int yylineno;
char *yytext;
int yyleng,yyalloc;

static void yy_init_buffer()
{ yy_inbuf.sz[0]=yy_inbuf.sz[1]=YY_BUF_GROWTH_SZ;
  yy_inbuf.data[0]
    =(yy_buf_elem *)malloc((yy_inbuf.sz[0]+1)*sizeof(**yy_inbuf.data));
  yy_inbuf.data[1]
    =(yy_buf_elem *)malloc((yy_inbuf.sz[1]+1)*sizeof(**yy_inbuf.data));
  if(!yy_inbuf.data[0]||!yy_inbuf.data[1])
     yy_fatalerror("unable to get enough memory for initial buffers");

  yy_inbuf.start.bufnum=0;  yy_inbuf.start.ptr=yy_inbuf.data[0]+yy_inbuf.sz[0];
  yy_inbuf.eof  .bufnum=0;  yy_inbuf.eof  .ptr=NULL;
  yy_inbuf.data[0][YY_BUF_GROWTH_SZ]=YY_BUF_SENTINEL;
  yy_inbuf.lastload= -1;
}

/* buffer management routines */

static int yy_b_get_buf(str,len) yy_buf_elem *str; int len;
/* returns length of string written */
{ if(yy_inbuf.start.bufnum==yy_inbuf.accept.bufnum)
  { memcpy(str,yy_inbuf.start.ptr,len*sizeof(*str));
  }
  else
  { int part1_len;
    part1_len=yy_inbuf.data[yy_inbuf.start.bufnum]
       +yy_inbuf.sz[yy_inbuf.start.bufnum]-yy_inbuf.start.ptr;
    memcpy(str,yy_inbuf.start.ptr,part1_len*sizeof(*str));
    memcpy(str+part1_len,yy_inbuf.data[yy_inbuf.accept.bufnum]
       ,(len-part1_len)*sizeof(*str));
  }
  (str)[len]='\0';
 return len;
}

static void yy_b_correct(posn,bufnum,ptr)
    struct yy_buf_mark *posn;
    int bufnum;
    yy_buf_elem *ptr;
{ if(posn->bufnum==bufnum)
  { posn->ptr=ptr+(posn->ptr-yy_inbuf.data[bufnum]);
  }
}

static int yy_b_special_getchar()
{ /* three cases: EOF, we need more chars,
   *  or YY_BUF_SENTINEL occurred in the input */

 recheck_char:
  if(*(yy_inbuf.posn.ptr)!=YY_BUF_SENTINEL) return yy_b_getchar();
  else if(yy_inbuf.posn.ptr==yy_inbuf.eof.ptr)           /* end of file */
  {return EOF;
  }
  else if(yy_inbuf.posn.ptr==yy_inbuf.data[yy_inbuf.posn.bufnum]
      +yy_inbuf.sz[yy_inbuf.posn.bufnum])      /* need more data in buffer */
  { if(yy_inbuf.posn.bufnum==yy_inbuf.start.bufnum) /* can load into other */
    { int count;

      yy_inbuf.posn.bufnum^=1;                   /* switch bufs */
      yy_inbuf.posn.ptr=yy_inbuf.data[yy_inbuf.posn.bufnum];
      if(yy_inbuf.posn.bufnum!=yy_inbuf.lastload)
      { count=YY_BULK(yy_inbuf.posn.ptr,sizeof(*yy_inbuf.posn.ptr)
           ,yy_inbuf.sz[yy_inbuf.posn.bufnum],yyin);
        if(count!=yy_inbuf.sz[yy_inbuf.posn.bufnum]) /* if we've reached EOF */
        { if(count<0)
          { fprintf(stderr,"fatal error: unexpected return from fread(): %d\n"
              ,count);
           exit(-1);
          }
          yy_inbuf.eof.bufnum=yy_inbuf.posn.bufnum;
          yy_inbuf.eof.ptr=yy_inbuf.posn.ptr+count;
          *yy_inbuf.eof.ptr=YY_BUF_SENTINEL;
        }
        else yy_inbuf.posn.ptr[count]=YY_BUF_SENTINEL;
        yy_inbuf.lastload=yy_inbuf.posn.bufnum;
      }
    }
    else            /* can't load into other buf: both bufs are being used */
    { int count;
      int a;

      yy_inbuf.posn.ptr                      /* get extra space in this buf */
        =(yy_buf_elem *)realloc(yy_inbuf.data[yy_inbuf.posn.bufnum]
          ,(yy_inbuf.sz[yy_inbuf.posn.bufnum]+(YY_BUF_GROWTH_SZ+1))
             *sizeof(**yy_inbuf.data));
      if(!yy_inbuf.posn.ptr)
         yy_fatalerror("insuffiecient memory to grow input buffer");

        /* correct stuff in case ptr moved: */
      yy_b_correct(&yy_inbuf.accept,yy_inbuf.posn.bufnum,yy_inbuf.posn.ptr);
      for(a=0;a<YY_RULECNT;a++)
      { yy_b_correct(yy_frwd_posn+a,yy_inbuf.posn.bufnum,yy_inbuf.posn.ptr);
      }

        /* now data is correct */
      yy_inbuf.data[yy_inbuf.posn.bufnum]=yy_inbuf.posn.ptr;
        /* now ptr is correct */
      yy_inbuf.posn.ptr+=yy_inbuf.sz[yy_inbuf.posn.bufnum];
         /* now sz is correct: */
      yy_inbuf.sz[yy_inbuf.posn.bufnum]+=YY_BUF_GROWTH_SZ;

      count=YY_BULK(yy_inbuf.posn.ptr,sizeof(*yy_inbuf.posn.ptr)
         ,YY_BUF_GROWTH_SZ,yyin);
      if(count!=YY_BUF_GROWTH_SZ)                 /* if we've reached EOF */
      { if(count<0)
        { fprintf(stderr,"fatal error: unexpected return from fread(): %d\n"
            ,count);
         exit(-1);
        }
        yy_inbuf.eof.bufnum=yy_inbuf.posn.bufnum;
        yy_inbuf.eof.ptr=yy_inbuf.posn.ptr+count;
        *yy_inbuf.eof.ptr=YY_BUF_SENTINEL;
      }
      else yy_inbuf.posn.ptr[count]=YY_BUF_SENTINEL;
    }
   goto recheck_char;
  }
  else /* the SENTINEL really occurred in the input */
  { yy_inbuf.posn.linecnt++;
#ifdef UNSIGNED_PROBLEM
     return (*(yy_inbuf.posn.ptr++))&0xff;
#else
     return *(yy_inbuf.posn.ptr++);
#endif /*UNSIGNED_PROBLEM*/
  }
}

/* finite state machine routines */
static yy_int_lex()
{ int state;
  int lastaccept;
  int ch;
  struct yy_l_machine_state *state_ptr;
  int a;

 another_char:

  state=1;         /* start state */
  state_ptr=yy_l_machine+state;

  lastaccept=0; /* no accepting state found yet */
  yy_b_begin_token();

  ch=yy_b_getchar();
  if(ch==EOF) return EOF;

  do
  { state=state_ptr->nextstate[yy_vc_map[ch]];
    if(!state) break;          /* this is where the while(1) is exitted */
    state_ptr=yy_l_machine+state;

    for(a=state_ptr->frwdoff;a<state_ptr->frwdoff+state_ptr->frwdcnt;a++)
    { yy_frwd_posn[yy_frwd_prodn[a]]=yy_inbuf.posn;
    }

    if(state_ptr->accept)
    { lastaccept=state_ptr->accept;
      yy_b_accept_mark();
    }
    ch=yy_b_getchar();
  } while(ch!=EOF);
  if(!lastaccept)
  { yy_b_begin_token();
    ch=yy_b_getchar();
    putc(ch,yyout);
    yy_b_accept_mark();
    yy_b_reset_posn();
   goto another_char;
  }
  if(yy_frwd_use[lastaccept])
  { yy_inbuf.accept=yy_frwd_posn[lastaccept];
  }

     /* compute yyleng and yytext: */
  yyleng=yy_b_len();
  if(yyleng+1>yyalloc)
  { yyalloc=yyleng+10;
    yytext=(char *)realloc(yytext,yyalloc);
    if(!yytext) yy_fatalerror("Ran out of memory for yytext");
  }
  yy_b_get_buf(yytext,yyleng);

  yy_b_reset_posn();
 return lastaccept;
}

int yylex()
{ static int yy_initialized; /*=0*/

  if(!yy_initialized)
  { yy_init_buffer();
    yyalloc=10;
    yytext=(char *)malloc(yyalloc);
    if(!yytext) yy_fatalerror("Ran out of memory for yytext");
    yy_initialized=1;
  }

  while(1)
  { switch(yy_int_lex())
    { case EOF: /*deinitialize: */
       free(yy_inbuf.data[0]);
       free(yy_inbuf.data[1]);
       free(yytext);
       yy_initialized=0;
      return EOF;
  case 1:
#line 56 "dlex.l"
return token(AUTOSP);
  break;
  case 2:
#line 57 "dlex.l"
return token(BREAK);
  break;
  case 3:
#line 58 "dlex.l"
return token(CASE);
  break;
  case 4:
#line 59 "dlex.l"
return token(CHARSP);
  break;
  case 5:
#line 60 "dlex.l"
return token(CONTINUE);
  break;
  case 6:
#line 61 "dlex.l"
return token(DEFAULT);
  break;
  case 7:
#line 62 "dlex.l"
return token(DO);
  break;
  case 8:
#line 63 "dlex.l"
return token(DOUBLESP);
  break;
  case 9:
#line 64 "dlex.l"
return token(ELSE);
  break;
  case 10:
#line 65 "dlex.l"
return token(EXTERNALSP);
  break;
  case 11:
#line 66 "dlex.l"
return token(FLOATSP);
  break;
  case 12:
#line 67 "dlex.l"
return token(FOR);
  break;
  case 13:
#line 68 "dlex.l"
return token(GOTO);
  break;
  case 14:
#line 69 "dlex.l"
return token(IF);
  break;
  case 15:
#line 70 "dlex.l"
return token(INTSP);
  break;
  case 16:
#line 71 "dlex.l"
{ return token(LONGSP); }
  break;
  case 17:
#line 72 "dlex.l"
return token(REGISTERSP);
  break;
  case 18:
#line 73 "dlex.l"
return token(RETURN);
  break;
  case 19:
#line 74 "dlex.l"
{ return token(SHORTSP); }
  break;
  case 20:
#line 75 "dlex.l"
return token(SIZEOF);
  break;
  case 21:
#line 76 "dlex.l"
return token(STATICSP);
  break;
  case 22:
#line 77 "dlex.l"
{ yylval.nlong=STRUCT; return token(STRoUNION); }
  break;
  case 23:
#line 78 "dlex.l"
return token(SWITCH);
  break;
  case 24:
#line 79 "dlex.l"
return token(TYPEDEF);
  break;
  case 25:
#line 80 "dlex.l"
{ yylval.nlong=UNION; return token(STRoUNION); }
  break;
  case 26:
#line 81 "dlex.l"
return token(UNSIGNSP);
  break;
  case 27:
#line 82 "dlex.l"
return token(VOIDSP);
  break;
  case 28:
#line 83 "dlex.l"
return token(VOLATILESP);
  break;
  case 29:
#line 84 "dlex.l"
return token(WHILE);
  break;
  case 30:
#line 85 "dlex.l"
{ AL(yylval.string.stf,yyleng,char);
   for(yylval.string.len=0,a=1;a<yyleng-1/* skip last " */;a++)
   { if(yytext[a]=='\n')
     yyerror("illegal new line in string constant. assuming \\n");
     yylval.string.stf[yylval.string.len++]
       =yytext[a]=='\\'?expand(yytext+a+1,&a):yytext[a];
   }
   yylval.string.stf[yylval.string.len++]='\0';
   return token(STRCONST); }
  break;
  case 31:
#line 94 "dlex.l"
{ yylval.nlong=expand(yytext+2,&a);
   return token(CHRCONST); }
  break;
  case 32:
#line 96 "dlex.l"
{ if(yytext[1]=='\n')
     yyerror("illegal new line in character constant. assuming \\n");
   yylval.nlong=yytext[1]; if (yytext[1]=='\'')
   yyerror("illegal charecter constant. assuming \'\\\'\'");
   return token(CHRCONST); }
  break;
  case 33:
#line 101 "dlex.l"
{ yylval.nlong=atoo(yytext+1); return INTEGRAL; }
  break;
  case 34:
#line 102 "dlex.l"
{ yylval.nlong=atoi(yytext); return INTEGRAL; }
  break;
  case 35:
#line 103 "dlex.l"
{ yylval.nlong=atoi(yytext); return token(LNUM); }
  break;
  case 36:
#line 104 "dlex.l"
{ yylval.ndouble=atof(yytext);
  return token(FNUM); }
  break;
  case 37:
#line 106 "dlex.l"
{ yylval.ndouble=atof(yytext);
  return token(FNUM); }
  break;
  case 38:
#line 108 "dlex.l"
{ for(yylval.nlong=0,a=2;a<yyleng;a++)
  yylval.nlong=(yylval.nlong<<4)+(yytext[a]-'0'>9?toupper(yytext[a])-'A'+10
   :yytext[a]-'0'); return INTEGRAL; }
  break;
  case 39:
#line 111 "dlex.l"
{ for(b=vdscnt-1;b>=0;b--)
     for(a=0;a<vds[b].tpdcnt;a++)
      if (!strcmp(yytext,vds[b].tpd[a].nm))
      { yylval.ntype=vds[b].tpd[a];
       return token(DTYPE); }
   Scp(&yylval.pchar,yytext); return token(ID);
 }
  break;
  case 40:
#line 118 "dlex.l"
{ for(a=2;isdigit(yytext[a]);a++);
  if(yytext[a]!='L') { fatal=1; yyerror("unknown line identifier"); }
  b=atoi(yytext+2)+1; a+=b;
  yylineno=atoi(yytext+a); newfile=1;
  yytext[a]='\0'; RAL(filenm,b,char); memcpy(filenm,yytext+(a-b+1),b); }
  break;
  case 41:
#line 123 "dlex.l"
return token(LSHFT);
  break;
  case 42:
#line 124 "dlex.l"
return token(RSHFT);
  break;
  case 43:
#line 125 "dlex.l"
return token(ARROW);
  break;
  case 44:
#line 126 "dlex.l"
return token(PP);
  break;
  case 45:
#line 127 "dlex.l"
return token(MM);
  break;
  case 46:
#line 128 "dlex.l"
return token(GE);
  break;
  case 47:
#line 129 "dlex.l"
return token(LE);
  break;
  case 48:
#line 130 "dlex.l"
return token(EQ);
  break;
  case 49:
#line 131 "dlex.l"
return token(NE);
  break;
  case 50:
#line 132 "dlex.l"
return token(CAND);
  break;
  case 51:
#line 133 "dlex.l"
return token(COR);
  break;
  case 52:
#line 134 "dlex.l"
{ yylval.nlong=yytext[0]; return token(COMPLEX_E); }
  break;
  case 53:
#line 135 "dlex.l"
{ yylval.nlong=LSHFT; return token(COMPLEX_E); }
  break;
  case 54:
#line 136 "dlex.l"
{ yylval.nlong=RSHFT; return token(COMPLEX_E); }
  break;
  case 55:
#line 137 "dlex.l"
;
  break;
  case 56:
#line 138 "dlex.l"
return token(yytext[0]);
  break;
 /* contents inserted by lex */
      break;
      default:
       yy_fatalerror("Internal error: unrecognized production number");
      break;
    }
  }
}

void yy_fatalerror(str) char *str;
{ fprintf(stderr,"Error on line %d: %s\n",yylineno,str);
 exit(-1);
}

#line 139 "dlex.l"
