/* mtst.c - malloc related functions */
#include <stdio.h>
#define PSIZE 50
#define PCHECK 8
#define MAXALLOC 5000
struct allocstuff
{ char *place;
  int length;
} alloc[MAXALLOC];
char inchar,*malloc(),*realloc();
int alcnt;
#ifdef SELFTEST
# define E_MEM (-2)
# define AL(place,size,type) { (place)=(type *)malloc((unsigned)(sizeof(type)\
    *(size))+1);\
   if ((char *)(place)==NULL)\
    yyerror("AL() can't get enough memory"),exit(E_MEM); }
# define RAL(place,size,type) { (place)=(type *)realloc((char *)(place)\
    ,(unsigned)(sizeof(type)*(size))+1);\
   if ((char *)(place)==NULL)\
    yyerror("RAL() can't get enough memory"),exit(E_MEM); }
 main()
 {
 }
 /*yyerror(s)
 { fprintf(stdout,"ERROR: %s\n",s);
 }
yyerror(s) char *s;
{ fatalerror(s);
}
*/
 memmove(x,y,n) register char *x,*y; register long n;
 { if (x<y) while (n--) *x++=(*y++);
   else while (n--) x[n]=y[n];
 }
#endif /* SELFTEST */
periphery(flg)
{ int a,b;
  /* check alloc table integrity, check buffer space */

static lastline;
extern yylineno;
if(yylineno!=lastline)
fprintf(stderr,"alcnt %d line %d\n",alcnt,yylineno),lastline=yylineno;
/* */

  for(a=0;a<alcnt;a++)
  { if(alloc[a].length<2*PSIZE) { yyerror("4periphery 3"); goto quit; }
    for(b=PSIZE-PCHECK;b<PSIZE;b++)
      if(alloc[a].place[b]!=inchar) { yyerror("5periphery 1"); goto quit; }
    for(b=alloc[a].length-PSIZE;b<alloc[a].length-(PSIZE-PCHECK);b++)
      if(alloc[a].place[b]!=inchar) { yyerror("6periphery 2"); goto quit; }
  }
 return 0;
 quit:
fprintf(stderr,"a %d b %d inchar %d alcnt %d\n",a,b,inchar,alcnt);
  if(flg) return 1;
  else return 0;
}
memintegritycheck(flg)
{ int a,b;
  /* check alloc table integrity, check buffer space */
  for(a=0;a<alcnt;a++)
  { if(alloc[a].length<2*PSIZE) { yyerror("7periphery 3"); goto quit; }
    for(b=0;b<PSIZE;b++)
      if(alloc[a].place[b]!=inchar) { yyerror("8periphery 1"); goto quit; }
    for(b=alloc[a].length-PSIZE;b<alloc[a].length;b++)
      if(alloc[a].place[b]!=inchar) { yyerror("9periphery 2"); goto quit; }
  }
 return 0;
 quit:
fprintf(stderr,"a %d b %d inchar %d alcnt %d\n",a,b,inchar,alcnt);
  if(flg) return 1;
  else return 0;
}
partintegritycheck(flg,a)
{ int b;
  if(alloc[a].length<2*PSIZE) { yyerror("1periphery 3"); goto quit; }
  for(b=0;b<PSIZE;b++)
    if(alloc[a].place[b]!=inchar) { yyerror("2periphery 1"); goto quit; }
  for(b=alloc[a].length-PSIZE;b<alloc[a].length;b++)
    if(alloc[a].place[b]!=inchar) { yyerror("3periphery 2"); goto quit; }
 return 0;
 quit:
fprintf(stderr,"length %d a %d b %d inchar %d alcnt %d [b] %d\n"
,alloc[a].length,a,b,inchar,alcnt,alloc[a].place[b]);
  if(flg) return 1;
  else return 0;
}
char *testmalloc(size)
/* alternate: locate place with enough room */
{ int a;
  periphery(0);
  if(alcnt>=MAXALLOC-1) return 0;
  alloc[alcnt].place=malloc(size+2*PSIZE);
  if(!alloc[alcnt].place) { yyerror("testmalloc 1"); exit(-1); }
  alloc[alcnt].length=size+2*PSIZE;
  for(a=0;a<alloc[alcnt].length;a++)
    alloc[alcnt].place[a]=inchar;
 return alloc[alcnt++].place+PSIZE;
}
char *testrealloc(ptr,size) char *ptr;
/*alternate: locate beginning,end of current... 3 choices*/
{ int a,b;
  periphery(0);
  ptr-=PSIZE;
  for(a=0;a<alcnt;a++) if(alloc[a].place==ptr) break;
  if(a>=alcnt) { yyerror("1testrealloc 1"); exit(-1); }
  partintegritycheck(0,a);
  alloc[a].place=ptr=realloc(ptr,size+PSIZE*2);
  if(!ptr) { yyerror("2testrealloc 1"); exit(-1); }
  alloc[a].length=size+PSIZE*2;
  for(b=size+PSIZE;b<alloc[a].length;b++) alloc[a].place[b]=inchar;
 return ptr+PSIZE;
}
testfree(ptr) char *ptr;
{ int a;
  periphery(0);
  ptr-=PSIZE;
  for(a=0;a<alcnt;a++) if(alloc[a].place==ptr) break;
  if(a>=alcnt) { yyerror("3testrealloc 1"); exit(-1); }
  partintegritycheck(0,a);
  memmove(alloc+a,alloc+(a+1),sizeof(struct allocstuff)*(alcnt-(a+1)));
  alcnt--;
  free(ptr);
}
