/* dln.c- linker for C compiler
 * dln dest src src src ...
 * destination: executable to create  src: object file to link in
 */
char RALmsg[]="RAL() can't get enough memory";
char ALmsg[]="AL() can't get enough memory";

#include <stdio.h>
#define NOFUNCTIONS
#include "genhead.h"
#include "pseudo.h"
#include "psas.h"
struct extobj
{ int file,foff,poff,sz;
  char used,*nm; /*note: do not modify this except to set=to file externs*/
} *master;
/* file:foff- tell where it is
 * poff     - offset in memory to be calculated
 * sz       - size of memory requirements
 */
struct funcs /* master list of defined functions */
{ int file,foff,poff,sz;
  char used,present,*nm;
} *funcs;
struct file
{ char *nm;
  struct externvar
  { char *nm,tp,prepres,place,*pre,scope;
    long off,sz,presz;
  } *ext;
  struct func
  { struct externxref *exref;
    char *nm,*bops,here,tp;
    long fnhead,sz,blen,exrcnt,fnnm;
  } *funcs;
  struct statfunc
  { long fnnm,sz,poff;
    char used;
  } *stfnlist;
  struct prexref *extxref;
  long extxcnt/*,poff,*/;
  long stfcnt,numfunc,extcnt;
} *file,*fl;
struct func *fn;
char *extstf;
long poff,pos,extsz,fncnt,mstrcnt; /*mastercnt filecnt*/
long *offxref,offsz;
/*NOTE: Al RAl can be finished for later implementation of tight
 * memory system */
#define EPEXT  0 /* external place  master */
#define EPFUNC 1 /* funcs */
#define EPSTAT 2 /* fl->stfnlist */

#define LOADORDERCNT 6
struct loadorder
{ int *off,cnt;
} ldord[LOADORDERCNT];

main(argc,argv) int argc; char *argv[];
{ int fcnt,fstexst,fmain,mainfunc;
  long c,d,fstplc,atloadpoff;
  fatal=extsz=mstrcnt=fncnt=0;
  AL(file,1,struct file);
  AL(master,1,struct extobj);
  AL(funcs,1,struct funcs);
  AL(extstf,1,char);
  for(fcnt=2;fcnt<argc;fcnt++)
  { /* read in file */
    RAL(file,fcnt+1,struct file);
    fl=file+fcnt;
    fl->nm=argv[fcnt];
    infile=fopen(argv[fcnt],"r");
    if(!infile) { yyerror("cannot open input file"); exit(-1); }
    fl->stfcnt=fl->numfunc=0;
    AL(fl->funcs,1,struct func);
    AL(fl->stfnlist,1,struct statfunc);
    while(1)
    { RAL(fl->funcs,fl->numfunc+1,struct func);
      fn=fl->funcs+fl->numfunc;
      fread(&fn->blen,sizeof(long),1,infile);
      AL(fn->bops,fn->blen,char);
      fread(fn->bops,1,fn->blen,infile);
      a=(*fn->bops);
      if(a!=OFUNC&&a!=OSTATFUNC) break;
      b=strlen(fn->bops+1)+1;
      AL(fn->nm,b,char);
      memcpy(fn->nm,fn->bops+1,b); b++;
      fn->tp=fn->bops[b++];
      if(fn->tp==SPOINTER||fn->tp==SSTRUCT)
      { fn->sz=(*(dwordptr)(fn->bops+b)); b+=4; }
      memmove(fn->bops,fn->bops+b,fn->blen-b); fn->blen-=b;
      fn->fnhead=b;
      if(a==OFUNC)
      { RAL(funcs,fncnt+1,struct funcs);
        funcs[fncnt].file=fcnt; funcs[fncnt].foff=fl->numfunc;
        funcs[fncnt].sz=fn->blen; funcs[fncnt].used=0;
        funcs[fncnt].present=1;
        funcs[fncnt++].nm=fn->nm;
      }
      else
      { RAL(fl->stfnlist,fl->stfcnt+1,struct statfunc);
        fl->stfnlist[fl->stfcnt].fnnm=fl->numfunc;
        fl->stfnlist[fl->stfcnt].sz=fn->blen;
        fl->stfnlist[fl->stfcnt++].used=0;
      }
      fread(&fn->exrcnt,sizeof(long),1,infile);
      AL(fn->exref,fn->exrcnt,struct externxref);
      fread(fn->exref,sizeof(struct externxref),fn->exrcnt,infile);
      fn->here=1;
      fl->numfunc++;
    }
    /* load externs;static */
    if(*fn->bops!=OPTEXTERN) { yyerror("corrupt input file"); exit(-1); }
    fl->extcnt=(*(dwordptr)(fn->bops+1));
    AL(fl->ext,fl->extcnt,struct externvar);
    pos=5; /*1+solong*/
    for(a=0;a<fl->extcnt;a++)
    { b=strlen(fn->bops+pos)+1;
      AL(fl->ext[a].nm,b,char);
      memcpy(fl->ext[a].nm,fn->bops+pos,b); pos+=b;
      fl->ext[a].scope=fn->bops[pos++];
      fl->ext[a].tp=fn->bops[pos++];
      if(fl->ext[a].tp==SPOINTER||fl->ext[a].tp==SSTRUCT
        ||fl->ext[a].tp==SARRAY)
      { fl->ext[a].sz=(*(dwordptr)(fn->bops+pos)); pos+=4; }
      fl->ext[a].prepres=fn->bops[pos++];
      if(fl->ext[a].prepres)
      { fl->ext[a].presz=(*(dwordptr)(fn->bops+pos)); pos+=4;
        AL(fl->ext[a].pre,fl->ext[a].presz,char);
        memcpy(fl->ext[a].pre,fn->bops+pos,fl->ext[a].presz);
        pos+=fl->ext[a].presz;
      }
    }
    fl->extxcnt=(*(dwordptr)(fn->bops+pos)); pos+=4;
    AL(fl->extxref,fl->extxcnt,struct prexref);
    memcpy(fl->extxref,fn->bops+pos,fl->extxcnt*sizeof(struct prexref));
    pos+=fl->extxcnt*sizeof(struct prexref);

    if(pos!=fn->blen)
    { yyerror("#2: corrupt object file");
      exit(-1);
    }
    fread(&exttblsz,sizeof(exttblsz),1,infile);
    RAL(fl->ext,fl->extcnt+exttblsz,struct externvar);
    for(a=fl->extcnt;a<fl->extcnt+exttblsz;a++)
    { fread(&b,1,1,infile);
      AL(fl->ext[a].nm,b,char);
      fread(fl->ext[a].nm,1,b,infile);
      fread(&fl->ext[a].scope,1,1,infile);
      fread(&fl->ext[a].tp,1,1,infile);
      if(fl->ext[a].tp==SPOINTER||fl->ext[a].tp==SSTRUCT
         ||fl->ext[a].tp==SARRAY)
        fread(&fl->ext[a].sz,sizeof(long),1,infile);
      fread(&fl->ext[a].prepres,1,1,infile);
      if(fl->ext[a].prepres)
      { fread(&fl->ext[a].presz,sizeof(long),1,infile);
        AL(fl->ext[a].pre,fl->ext[a].presz,char);
        fread(fl->ext[a].pre,1,fl->ext[a].presz
          ,infile);
      }
    }
    for(a=0;a<fl->numfunc;a++)
    { for(b=0;b<fl->funcs[a].exrcnt;b++)
        if(fl->funcs[a].exref[b].scoff<0)
          fl->funcs[a].exref[b].scoff
             = -1-fl->funcs[a].exref[b].scoff+fl->extcnt;
    }
    fl->extcnt+=exttblsz;
  }
  for(fcnt=2;fcnt<argc;fcnt++)
  { /* load masters */
    fl=file+fcnt;
    for(a=0;a<fl->extcnt;a++)
    { if(fl->ext[a].tp==SFUNC&&fl->ext[a].scope!=SCPSTATIC)
      { /* search statfunc; then in special way funcs for it */
        for(b=0;b<fl->stfcnt;b++)
         if(!strcmp(fl->funcs[fl->stfnlist[b].fnnm].nm,fl->ext[a].nm))
         { fl->ext[a].place=EPSTAT; fl->ext[a].off=b; break; }
        if(b>=fl->stfcnt)
        { fstexst=0;
          for(b=0;b<fncnt;b++)
           if(!strcmp(funcs[b].nm,fl->ext[a].nm))
           { if(funcs[b].file==fcnt) { fstexst=1; fstplc=b; break; }
             else if(!fstexst) { fstexst=1; fstplc=b; }
           }
          if(!fstexst)
          {
/* sprintf(temp,"undefined function declared \"%s\"",fl->ext[a].nm);
            fatal=1; yyerror(temp);
MERE: delete above*/
            RAL(funcs,fncnt+1,struct funcs);
            fstplc=fncnt;
 /* note: .used here used as flag to prevent multiple print of same message.*/
            funcs[fncnt].used=funcs[fncnt].present=0;
            funcs[fncnt++].nm=fl->ext[a].nm;
          }
          fl->ext[a].place=EPFUNC; fl->ext[a].off=fstplc;
        }
      }
      else if(fl->ext[a].tp==SFUNC) /* static function */
      { for(b=0;b<fl->stfcnt;b++)
         if(!strcmp(fl->funcs[fl->stfnlist[b].fnnm].nm,fl->ext[a].nm))
         { fl->ext[a].place=EPSTAT; fl->ext[a].off=b; break; }
        if(b>=fl->stfcnt)
        { fatal=1; sprintf(temp,"STATFUNC \"%s\" not found",fl->ext[a].nm);
          yyerror(temp);
        }
      }
      else if(fl->ext[a].scope==SCPSTATIC)
      { RAL(master,mstrcnt+1,struct extobj);
        master[mstrcnt].file=fcnt; master[mstrcnt].foff=a;
        master[mstrcnt].nm=fl->ext[a].nm;
        master[mstrcnt].sz=typesz(fl->ext[a]); master[mstrcnt].used=0;
        fl->ext[a].place=EPEXT; fl->ext[a].off=mstrcnt++;
      }
      else
      { /* put into master */
        for(c=0;c<mstrcnt;c++)
         if(file[master[c].file].ext[master[c].foff].scope!=SCPSTATIC
             &&!strcmp(master[c].nm,fl->ext[a].nm))
         { /*MORE:decide modification on weather to modify master[c]*/
           int tempsz;
           tempsz=typesz(fl->ext[a]);
           if((fl->ext[a].prepres||(tempsz&&!master[c].sz))&&
              !file[master[c].file].ext[master[c].foff].prepres)
           { master[c].file=fcnt; master[c].foff=a;
             if(master[c].sz&&master[c].sz!=tempsz) goto badsizematch;
             master[c].sz=tempsz;
           }
           else if((tempsz&&master[c].sz!=tempsz)
              ||file[master[c].file].ext[master[c].foff].tp!=fl->ext[a].tp)
           { if(!strcmp(master[c].nm,"_dcc$structreturn"))
             { if(tempsz>master[c].sz)
                 master[c].sz=tempsz;
             }
             else
             {badsizematch:
               sprintf(temp,"bad type match on \"%s\"\n",master[c].nm);
               fatal=1; yyerror(temp);
             }
           }
           fl->ext[a].place=EPEXT; fl->ext[a].off=c;
          break;
         }
        if(c>=mstrcnt)
        { RAL(master,mstrcnt+1,struct extobj);
          master[mstrcnt].file=fcnt; master[mstrcnt].foff=a;
          master[mstrcnt].nm=fl->ext[a].nm;
          master[mstrcnt].sz=typesz(fl->ext[a]); master[mstrcnt].used=0;
          fl->ext[a].place=EPEXT; fl->ext[a].off=mstrcnt++;
        }
      }
    }
  }
  /* mark all statfunc, func, and externs that are used */
  for(a=0;a<fncnt;a++)
   if(!strcmp(funcs[a].nm,"_dccmain"))
   { mainfunc=a;
     xrefuse(EPFUNC,a,0);
    break;
   }
  if(a>=fncnt)
  { for(a=0;a<fncnt;a++)
     if(!strcmp(funcs[a].nm,"main"))
     { mainfunc=a;
       xrefuse(EPFUNC,a,0);
      break;
     }
  }
  if(fatal)
  { yyerror("fatal error(s); cancelling\n"); exit(-1); }
  if(a>=fncnt) { yyerror("no function main"); exit(-1); }
  /* allocate memory for statfunc, func, and externs that are marked */
  poff=0x4; /* offset of table */
  /* load all statfuncs */
  for(fcnt=2;fcnt<argc;fcnt++)
  { fl=file+fcnt;
    for(a=0;a<fl->stfcnt;a++)
    { if(!fl->stfnlist[a].used) continue;
      fl->stfnlist[a].poff=poff;
      poff+=fl->funcs[fl->stfnlist[a].fnnm].blen;
    }
  }
  /* load all funcs */
  for(a=0;a<fncnt;a++)
  { if(!funcs[a].used) continue;
    fl=funcs[a].file+file;
    fn=fl->funcs+funcs[a].foff;
    fn->fnnm=a;
    funcs[a].poff=poff;
    poff+=fl->funcs[funcs[a].foff].blen;
  }

  /* load and allocate master stuff */

  for(a=0;a<LOADORDERCNT;a++)
  { AL(ldord[a].off,1,int); ldord[a].cnt=0; }
  for(a=0;a<mstrcnt;a++)
  { if(!master[a].used) continue;
    fl=file+master[a].file;
    if(!(master[a].sz&3)) b=0;
    else if(!(master[a].sz&1)) b=1;
    else b=2;
    if(!fl->ext[master[a].foff].prepres)
 /*      ||allzero(fl->ext[master[a].foff].pre,fl->ext[master[a].foff].presz))
  * MERE: in future check allzero AND externxref and include if both fit */
    { b+=3;
    }
    RAL(ldord[b].off,ldord[b].cnt+1,int);
    ldord[b].off[ldord[b].cnt++]=a;
  }
  atloadpoff=poff;
  poff=((poff+3)&0xfffffffc);
  for(a=0;a<LOADORDERCNT;a++)
  { int c;
    if(a==0||a==3) poff=((poff+3)&0xfffffffc);
    for(b=0;b<ldord[a].cnt;b++)
    { c=ldord[a].off[b];
      master[c].poff=poff;
      poff+=master[c].sz;
    }
  }
  poff=((poff+3)&0xfffffffc);

  AL(offxref,1,long);
  offsz=0;
  for(fcnt=2;fcnt<argc;fcnt++)
  { fl=file+fcnt;
    RAL(offxref,offsz+fl->extxcnt,long);
    for(a=0;a<fl->extxcnt;a++)
    {
/*fprintf(stderr,"a %d  ext.off %d  ext.place %d  ext.off].used %d\n",a
,fl->ext[fl->extxref[a].eoff].off,fl->ext[fl->extxref[a].eoff].place
,master[fl->ext[fl->extxref[a].eoff].off].used);
fprintf(stderr,"eoff %d  sect %d  scoff %d  poff %d\n",fl->extxref[a].eoff
,fl->extxref[a].sect,fl->extxref[a].soff,fl->extxref[a].poff);
*/
      if(!master[fl->ext[fl->extxref[a].eoff].off].used) continue;
      if(!fl->ext[fl->extxref[a].eoff].prepres)
      { fatal=1; yyerror("pointer in something without predef"); continue; }
      offxref[offsz++]=fl->extxref[a].poff+master[fl->ext
        [fl->extxref[a].eoff].off].poff;
      *(dwordptr)(fl->ext[fl->extxref[a].eoff].pre+
        fl->extxref[a].poff)+=(fl->extxref[a].sect==SCPUBLIC?
         (fl->ext[fl->extxref[a].soff].place==EPEXT?
           master[fl->ext[fl->extxref[a].soff].off].poff
           :(fl->ext[fl->extxref[a].soff].place==EPFUNC?
             funcs[fl->ext[fl->extxref[a].soff].off].poff
             :fl->stfnlist[fl->ext[fl->extxref[a].soff].off].poff))
         :((fatal=1),yyerror("unknown sect in extxref"))); /*HERE and below */
    }
  }
  for(a=0;a<3;a++) /* instead of LOADORDERCNT */
  { int c;
    if(a==0&&(atloadpoff&3))
    { c=((atloadpoff+3)&0xfffffffc);
      RAL(extstf,extsz+c-atloadpoff,char);
      while(atloadpoff++<c) extstf[extsz++]=0;
      atloadpoff--; /* to adjust for last ++ above */
    }
    for(b=0;b<ldord[a].cnt;b++)
    { c=ldord[a].off[b];
      RAL(extstf,extsz+master[c].sz,char);
      if(file[master[c].file].ext[master[c].foff].prepres)
      { if(file[master[c].file].ext[master[c].foff].presz!=master[c].sz)
        { fatal=1; yyerror("predef is not same size as master");
fprintf(stderr,"presz %d sz %d\n",file[master[c].file].ext[master[c].foff].presz
,master[c].sz);
}
        else
        { memcpy(extstf+extsz,file[master[c].file].ext[master[c].foff].pre
           ,master[c].sz);
          extsz+=master[c].sz;
          free(file[master[c].file].ext[master[c].foff].pre);
        }
      }
      else while(master[c].sz--) extstf[extsz++]=0;
      atloadpoff+=master[c].sz;
    }
  }
  if(atloadpoff&3)
  { int c=((atloadpoff+3)&0xfffffffc);
    RAL(extstf,extsz+c-atloadpoff,char);
    while(atloadpoff++<c) extstf[extsz++]=0;
    atloadpoff--;
  }
/* locate main and write out startup routine */
  a=mainfunc;
  if(a>=fncnt) { yyerror("function main dissapeared!"); exit(-1); }
  fmain=a;
  /* tbloff(dword)
   * statfuncs
   * funcs
   * extern vars
   *table:
   * offsz(dword)
   *  offxref (offsz dwords)
   * main's offset(dword)
   */
  outfile=fopen(argv[1],"w");
  if(!outfile) { yyerror("cannot open output file"); exit(-1); }
  fwrite(&atloadpoff,4,1,outfile);
  /* write statfuncs */
  for(fcnt=2;fcnt<argc;fcnt++)
  { fl=file+fcnt;
    for(a=0;a<fl->stfcnt;a++)
    { if(!fl->stfnlist[a].used) continue;
      fn=fl->funcs+fl->stfnlist[a].fnnm;
      RAL(offxref,offsz+fn->exrcnt,long);
      for(b=0;b<fn->exrcnt;b++)
      { switch(fl->ext[fn->exref[b].scoff].place)
        { case EPEXT:
           *(dwordptr)(fn->bops+fn->exref[b].off-fn->fnhead)
            +=master[fl->ext[fn->exref[b].scoff].off].poff;
           offxref[offsz++]=fl->stfnlist[a].poff+fn->exref[b].off-fn->fnhead;
          break;
          case EPSTAT:
           if(fn->exref[b].ptrfnc)
           { *(dwordptr)(fn->bops+fn->exref[b].off-fn->fnhead)
              =fl->stfnlist[fl->ext[fn->exref[b].scoff].off].poff;
             offxref[offsz++]=fl->stfnlist[a].poff+fn->exref[b].off-fn->fnhead;
           }
           else
           { *(dwordptr)(fn->bops+(fn->exref[b].off-fn->fnhead))
               +=fl->stfnlist[fl->ext[fn->exref[b].scoff].off].poff
               -(fl->stfnlist[a].poff+fn->exref[b].off-fn->fnhead+4);
           }
          break;
          case EPFUNC:
           if(fn->exref[b].ptrfnc)
           { *(dwordptr)(fn->bops+(fn->exref[b].off-fn->fnhead))
              =funcs[fl->ext[fn->exref[b].scoff].off].poff;
             offxref[offsz++]=fl->stfnlist[a].poff+fn->exref[b].off-fn->fnhead;
           }
           else
           { *(dwordptr)(fn->bops+(fn->exref[b].off-fn->fnhead))
               +=funcs[fl->ext[fn->exref[b].scoff].off].poff
               -(fl->stfnlist[a].poff+fn->exref[b].off-fn->fnhead+4);
           }
          break;
          default: yyerror("unknown extern place near end"); exit(-1);
        }
      }
      fwrite(fn->bops,1,fn->blen,outfile);
    }
  }
  /* write funcs */
  for(a=0;a<fncnt;a++)
  { if(!funcs[a].used) continue;
    fl=file+funcs[a].file;
    fn=fl->funcs+funcs[a].foff;
    RAL(offxref,offsz+fn->exrcnt,long);
    for(b=0;b<fn->exrcnt;b++)
    { switch(fl->ext[fn->exref[b].scoff].place)
      { case EPEXT:
         *(dwordptr)(fn->bops+fn->exref[b].off-fn->fnhead)
          +=master[fl->ext[fn->exref[b].scoff].off].poff;
         offxref[offsz++]=funcs[a].poff+fn->exref[b].off-fn->fnhead;
        break;
        case EPSTAT:
         if(fn->exref[b].ptrfnc)
         { *(dwordptr)(fn->bops+fn->exref[b].off-fn->fnhead)
            =fl->stfnlist[fl->ext[fn->exref[b].scoff].off].poff;
           offxref[offsz++]=funcs[a].poff+fn->exref[b].off-fn->fnhead;
         }
         else
         { *(dwordptr)(fn->bops+(fn->exref[b].off-fn->fnhead))
             +=fl->stfnlist[fl->ext[fn->exref[b].scoff].off].poff
             -(funcs[a].poff+fn->exref[b].off-fn->fnhead+4);
         }
        break;
        case EPFUNC:
         if(fn->exref[b].ptrfnc)
         { *(dwordptr)(fn->bops+(fn->exref[b].off-fn->fnhead))
            =funcs[fl->ext[fn->exref[b].scoff].off].poff;
           offxref[offsz++]=funcs[a].poff+fn->exref[b].off-fn->fnhead;
         }
         else
         { *(dwordptr)(fn->bops+(fn->exref[b].off-fn->fnhead))
             +=funcs[fl->ext[fn->exref[b].scoff].off].poff
             -(funcs[a].poff+fn->exref[b].off-fn->fnhead+4);
         }
        break;
        default: yyerror("unknown extern place near end"); exit(-1);
      }
    }
    fwrite(fn->bops,1,fn->blen,outfile);
    free(fn->bops);
  }
  /* write external area */

  fwrite(extstf,1,extsz,outfile);
/*printf("poff %#x atloadpoff %#x extsz %#x\n",poff,atloadpoff,extsz);
*/
  poff-=atloadpoff;
if(poff&3)
{ fatal=1; yyerror("internal bad poff"); }
  poff>>=2;
  fwrite(&poff,4,1,outfile);
  fwrite(&offsz,4,1,outfile);
  fwrite(offxref,4,offsz,outfile);
  fwrite(&(funcs[fmain].poff),4,1,outfile);
  fclose(outfile);
 exit(fatal);
}

xrefpreuse(f,off) int f,off;
{ int b,x;
  struct file *fil;
  struct prexref *px;
  fil=file+f;
  px=fil->extxref;
  for(b=0;b<fil->extxcnt&&px[b].eoff<=off;b++)
  { if(px[b].eoff==off)
    { switch(px[b].sect)
      { case SCPUBLIC:
         if(fil->ext[px[b].soff].tp==SFUNC)
           if(fil->ext[px[b].soff].scope==SCPSTATIC)
             xrefuse(EPSTAT,f,fil->ext[px[b].soff].off);
           else xrefuse(EPFUNC,fil->ext[px[b].soff].off,0);
         else
         { if(master[fil->ext[px[b].soff].off].used) break;
           master[fil->ext[px[b].soff].off].used=1;
           xrefpreuse(master[fil->ext[px[b].soff].off].file
             ,master[fil->ext[px[b].soff].off].foff);
         }
        break;
        default: fatal=1; yyerror("illegal section for pointer");
fprintf(stderr,"b %d off %d px[b].sect %d\n",b,off,px[b].sect);/*DEBUG*/
      }
    }
  }
}

xrefuse(plc,off,aux)
{ struct func *fnc;
  struct file *fil;
  long b;
  switch(plc)
  { case EPFUNC:
     if(funcs[off].used) return; /* avoid continuous loops caused by recur */
     funcs[off].used=1;
     if(!funcs[off].present)
     { sprintf(temp,"undefined function \"%s\"",funcs[off].nm);
       fatal=1; yyerror(temp);
      return;
     }
     fil=file+funcs[off].file;
     fnc=fil->funcs+funcs[off].foff;
    break;
    case EPSTAT:
     if(file[off].stfnlist[aux].used) return;
     file[off].stfnlist[aux].used=1;
     fil=file+off;
     fnc=fil->funcs+fil->stfnlist[aux].fnnm;
    break;
    default: yyerror("unknown place in xrefuse"); exit(-1);
  }
  for(b=0;b<fnc->exrcnt;b++)
  { switch(fil->ext[fnc->exref[b].scoff].place)
    { case EPEXT: master[fil->ext[fnc->exref[b].scoff].off].used=1;
       xrefpreuse(master[fil->ext[fnc->exref[b].scoff].off].file
         ,master[fil->ext[fnc->exref[b].scoff].off].foff);
      break;
      case EPSTAT:
       xrefuse(EPSTAT,fil-file,fil->ext[fnc->exref[b].scoff].off);
      break;
      case EPFUNC:
       xrefuse(EPFUNC,fil->ext[fnc->exref[b].scoff].off,0);
      break;
      default:
       fatal=1; yyerror("unknown external place (var,statfunc,func)");
    }
  }
}

typesz(ext) struct externvar ext;
{ switch(ext.tp%SUNSIGNED)
  { case SCHAR:
     return(1);
    case SSHORT:
     return(2);
    case SINT:
    case SFLOAT:
    case SLONG:
    case SPOINTER:
     return(4);
    case SDOUBLE:
     return(8);
    case SARRAY:
    case SSTRUCT:
     return(ext.sz);
    default: fatal=1; yyerror("unknown type in typesz()");
fprintf(stderr,"nm [%s] tp %d sz %d\n",ext.nm,ext.tp,ext.sz);
  }
}

yyerror(s) char *s;
{ fprintf(stderr,"dln: %s:(error) cannot trace line number\n",s);
}
