/* dln86.c- linker for C compiler
 * dln86 dest src src src ...
 * destination: executable to create  src: object file to link in
 */
#include <stdio.h>
#include "head.h"
#include "pseudo.h"
#include "psas86.h"
struct extobj
{ int file,foff,poff,sz;
  char used,*nm; /*note: do not modify this except to set=to file externs*/
} *master;
/* file:foff- tell where it is
 * poff     - offset in memory to be calculated
 * sz       - size of memory requirements
 */
struct funcs /* master list of defined functions */
{ int file,foff,poff,sz;
  char used,*nm;
} *funcs;
struct file
{ char *nm,*strconsts;
  struct externvar
  { char *nm,tp,prepres,place,*pre;
    long off,sz,presz;
  } *ext;
  struct func
  { struct externxref *exref;
    struct staticxref *normstat,*intstat;
    char *nm,*bops,here,tp;
    long fnhead,sz,blen,floff,exrcnt,istatcnt,nstatcnt;
  } *funcs;
  struct statfunc
  { long fnnm,sz,poff;
    char used;
  } *stfnlist;
  struct prexref *extxref,*stpxref;
  long extxcnt,stpxcnt,poff,nstln;
  long stfcnt,strclen,normstcnt,numfunc,extcnt,allstoff;
} *file,*fl;
struct func *fn;
char *extstf;
long poff,pos,extsz,fncnt,strgoff,mstrcnt; /*mastercnt filecnt*/
short *csxref,cssz;
/*NOTE: Al RAl can be finished for later implementation of tight
 * memory system */
#define EPEXT  0 /* external place  master */
#define EPFUNC 1 /* funcs */
#define EPSTAT 2 /* fl->stfnlist */
main(argc,argv) int argc; char *argv[];
{ int fcnt,fstexst;
  long c,d,fstplc;
  fatal=extsz=strgoff=mstrcnt=fncnt=0;
  AL(file,1,struct file);
  AL(master,1,struct extobj);
  AL(funcs,1,struct funcs);
  AL(extstf,1,char);
  for(fcnt=2;fcnt<argc;fcnt++)
  { /* read in file */
    RAL(file,fcnt+1,struct file);
    fl=file+fcnt;
    infile=fopen(argv[fcnt],"r");
    if(!infile) { yyerror("cannot open input file"); exit(-1); }
    fl->stfcnt=fl->numfunc=0;
    AL(fl->funcs,1,struct func);
    AL(fl->stfnlist,1,struct statfunc);
    while(1)
    { RAL(fl->funcs,fl->numfunc+1,struct func);
      fn=fl->funcs+fl->numfunc;
      fread(&fn->blen,sizeof(long),1,infile);
      AL(fn->bops,fn->blen,char);
      fread(fn->bops,1,fn->blen,infile);
      a=(*fn->bops);
      if(a!=OFUNC&&a!=OSTATFUNC) break;
      b=strlen(fn->bops+1)+1;
      AL(fn->nm,b,char);
      memcpy(fn->nm,fn->bops+1,b); b++;
      fn->tp=fn->bops[b++];
      if(fn->tp==SPOINTER||fn->tp==SSTRUCT)
      { fn->sz=(*(unsigned long *)(fn->bops+b)); b+=4; }
      overmemcpy(fn->bops,fn->bops+b,fn->blen-b); fn->blen-=b;
      fn->fnhead=b;
      if(a==OFUNC)
      { RAL(funcs,fncnt+1,struct funcs);
        funcs[fncnt].file=fcnt; funcs[fncnt].foff=fl->numfunc;
        funcs[fncnt].sz=fn->blen; funcs[fncnt].used=0;
        funcs[fncnt++].nm=fn->nm;
      }
      else
      { RAL(fl->stfnlist,fl->stfcnt+1,struct statfunc);
        fl->stfnlist[fl->stfcnt].fnnm=fl->numfunc;
        fl->stfnlist[fl->stfcnt].sz=fn->blen;
        fl->stfnlist[fl->stfcnt++].used=0;
      }
      fread(&fn->exrcnt,sizeof(long),1,infile);
      AL(fn->exref,fn->exrcnt,struct externxref);
      fread(fn->exref,sizeof(struct externxref),fn->exrcnt,infile);
      fread(&fn->nstatcnt,sizeof(long),1,infile);
      AL(fn->normstat,fn->nstatcnt,struct staticxref);
      fread(fn->normstat,sizeof(struct staticxref),fn->nstatcnt,infile);
      fread(&fn->istatcnt,sizeof(long),1,infile);
      AL(fn->intstat,fn->istatcnt,struct staticxref);
      fread(fn->intstat,sizeof(struct staticxref),fn->istatcnt,infile);
      fn->here=1;
      fl->numfunc++;
    }
    /* load externs;static */
    if(*fn->bops!=OPTEXTERN) { yyerror("corrupt input file"); exit(-1); }
    fl->extcnt=(*(unsigned long *)(fn->bops+1));
    AL(fl->ext,fl->extcnt,struct externvar);
    pos=5; /*1+solong*/
    for(a=0;a<fl->extcnt;a++)
    { b=strlen(fn->bops+pos)+1;
      AL(fl->ext[a].nm,b,char);
      memcpy(fl->ext[a].nm,fn->bops+pos,b); pos+=b; /*probably notHERE*/
      fl->ext[a].tp=fn->bops[pos++];
      if(fl->ext[a].tp==SPOINTER||fl->ext[a].tp==SSTRUCT
        ||fl->ext[a].tp==SARRAY)
      { fl->ext[a].sz=(*(unsigned long *)(fn->bops+pos)); pos+=4; }
      fl->ext[a].prepres=fn->bops[pos++];
      if(fl->ext[a].prepres)
      { fl->ext[a].presz=(*(unsigned long *)(fn->bops+pos)); pos+=4;
        AL(fl->ext[a].pre,fl->ext[a].presz,char);
        memcpy(fl->ext[a].pre,fn->bops+pos,fl->ext[a].presz);
        pos+=fl->ext[a].presz;
      }
    }
    fl->extxcnt=(*(unsigned long *)(fn->bops+pos)); pos+=4;
    AL(fl->extxref,fl->extxcnt,struct prexref);
    memcpy(fl->extxref,fn->bops+pos,fl->extxcnt*sizeof(struct prexref));
    pos+=fl->extxcnt*sizeof(struct prexref);

    fl->nstln=fl->strclen=(*(unsigned long *)(fn->bops+pos)); pos+=4;
    fread(&fl->normstcnt,sizeof(long),1,infile); /* intstat */
    AL(fl->strconsts,fl->strclen+fl->normstcnt,char);
    memcpy(fl->strconsts,fn->bops+pos,fl->strclen); pos+=fl->strclen;/*nstat*/

    fl->stpxcnt=(*(unsigned long *)(fn->bops+pos)); pos+=4; /* pointers */
    AL(fl->stpxref,fl->stpxcnt,struct prexref);
    memcpy(fl->stpxref,fn->bops+pos,fl->stpxcnt*sizeof(struct prexref));
    pos+=fl->stpxcnt*sizeof(struct prexref);
    if(pos!=fn->blen)
    { yyerror("#2: corrupt object file");
      exit(-1);
    }
    fread(fl->strconsts+fl->strclen,1,fl->normstcnt,infile); /* intstat */
    fl->strclen+=fl->normstcnt; fl->allstoff=strgoff; strgoff+=fl->strclen;
  }
  for(fcnt=2;fcnt<argc;fcnt++)
  { /* load masters */
    fl=file+fcnt;
    for(a=0;a<fl->extcnt;a++)
    { if(fl->ext[a].tp==SFUNC)
      { /* search statfunc; then in special way funcs for it */
        for(b=0;b<fl->stfcnt;b++)
         if(!strcmp(fl->funcs[fl->stfnlist[b].fnnm].nm,fl->ext[a].nm))
         { fl->ext[a].place=EPSTAT; fl->ext[a].off=b; break; }
        if(b>=fl->stfcnt)
        { fstexst=0;
          for(b=0;b<fncnt;b++)
           if(!strcmp(funcs[b].nm,fl->ext[a].nm))
           { if(funcs[b].file==fcnt) { fstexst=1; fstplc=b; break; }
             else if(!fstexst) { fstexst=1; fstplc=b; }
           }
          if(!fstexst)
          { sprintf(temp,"undefined function declared \"%s\"",fl->ext[a].nm);
            fatal=1; yyerror(temp);
          }
          fl->ext[a].place=EPFUNC; fl->ext[a].off=fstplc;
        }
      }
      else if(fl->ext[a].tp==SSTATFUNC)
      { for(b=0;b<fl->stfcnt;b++)
         if(!strcmp(fl->funcs[fl->stfnlist[b].fnnm].nm,fl->ext[a].nm))
         { fl->ext[a].place=EPSTAT; fl->ext[a].off=b; break; }
        if(b>=fl->stfcnt)
        { fatal=1; yyerror("STATFUNC not found"); }
      } /*doneHERE*/
      else
      { /* put into master */
        for(c=0;c<mstrcnt;c++)
         if(!strcmp(master[c].nm,fl->ext[a].nm))
         { /*MORE:decide modification on weather to modify master[c]*/
           if(fl->ext[a].prepres&&
              !file[master[c].file].ext[master[c].foff].prepres)
           { master[c].file=fcnt; master[c].foff=a;
             master[c].sz=typesz(fl->ext[a]); master[c].used=0;
             master[c].nm=fl->ext[a].nm;
           }
           fl->ext[a].place=EPEXT; fl->ext[a].off=c;
          break;
         }
        if(c>=mstrcnt)
        { RAL(master,mstrcnt+1,struct extobj);
          master[mstrcnt].file=fcnt; master[mstrcnt].foff=a;
          master[mstrcnt].nm=fl->ext[a].nm;
          master[mstrcnt].sz=typesz(fl->ext[a]); master[mstrcnt].used=0;
          fl->ext[a].place=EPEXT; fl->ext[a].off=mstrcnt++;
        }
      }
    }
  }
  /* mark all statfunc, func, and externs that are used */
  for(a=0;a<fncnt;a++)
   if(!strcmp(funcs[a].nm,"main")) { xrefuse(EPFUNC,a,0); break; }
  for(fcnt=2;fcnt<argc;fcnt++)
  { fl=file+fcnt;
    xrefpreuse(EPSTAT,fcnt,0);
  }
/*MORE:HERE: scan STATIC for any pointer predefs and xrefuse on them*/
  if(a>=fncnt) { yyerror("no function main"); exit(-1); }
  /* allocate memory for statfunc, func, and externs that are marked */
  poff=0x100+29;
  /* load all statfuncs */
  for(fcnt=2;fcnt<argc;fcnt++)
  { fl=file+fcnt;
    for(a=0;a<fl->stfcnt;a++)
    { if(!fl->stfnlist[a].used) continue;
      fl->stfnlist[a].poff=poff;
      poff+=fl->funcs[fl->stfnlist[a].fnnm].blen;
    }
  }
  /* load all funcs */
  for(a=0;a<fncnt;a++)
  { fl=funcs[a].file+file;
    fn=fl->funcs+funcs[a].foff;
    if(!funcs[a].used) continue;
    funcs[a].poff=poff;
    poff+=fl->funcs[funcs[a].foff].blen;
  }
  /* load static stuff and static xref */
  AL(csxref,1,short); cssz=0;
  for(fcnt=2;fcnt<argc;fcnt++)
  { fl=file+fcnt;
    RAL(csxref,cssz+fl->stpxcnt,short);
    for(a=0;a<fl->stpxcnt;a++) csxref[cssz++]=fl->stpxref[a].poff+2+poff;
    for(a=0;a<fl->numfunc;a++)
    { fn=fl->funcs+a;
      for(b=0;b<fn->nstatcnt;b++)
       *(unsigned short *)(fn->bops+(fn->normstat[b].off-fn->fnhead))+=poff;
      for(b=0;b<fn->istatcnt;b++)
       *(unsigned short *)(fn->bops+(fn->intstat[b].off-fn->fnhead))
        +=poff+fl->nstln;
    }
    fl->poff=poff;
    poff+=fl->strclen;
  }
  /* load and allocate master stuff */
  for(a=0;a<mstrcnt;a++)
  { if(!master[a].used) continue;
    master[a].poff=poff;
    poff+=master[a].sz;
  }
  for(fcnt=2;fcnt<argc;fcnt++)
  { fl=file+fcnt;
    RAL(csxref,cssz+fl->extxcnt,short);
    for(a=0;a<fl->extxcnt;a++)
    {
/*fprintf(stderr,"a %d  ext.off %d  ext.place %d  ext.off].used %d\n",a
,fl->ext[fl->extxref[a].eoff].off,fl->ext[fl->extxref[a].eoff].place
,master[fl->ext[fl->extxref[a].eoff].off].used);
fprintf(stderr,"eoff %d  sect %d  scoff %d  poff %d\n",fl->extxref[a].eoff
,fl->extxref[a].sect,fl->extxref[a].soff,fl->extxref[a].poff);*/
      if(!master[fl->ext[fl->extxref[a].eoff].off].used) continue;
      if(!fl->ext[fl->extxref[a].eoff].prepres)
      { fatal=1; yyerror("pointer in something without predef"); continue; }
      csxref[cssz++]=fl->extxref[a].poff+2+master[fl->ext
        [fl->extxref[a].eoff].off].poff;
/*fprintf(stderr,"pre %d\n",(*(unsigned short *)(fl->ext[fl->extxref[a].eoff].pre
+fl->extxref[a].poff)));*/
      *(unsigned short *)(fl->ext[fl->extxref[a].eoff].pre+
        fl->extxref[a].poff)+=(fl->extxref[a].sect==SCPUBLIC?
         (fl->ext[fl->extxref[a].soff].place==EPEXT?
           master[fl->ext[fl->extxref[a].soff].off].poff
           :(fl->ext[fl->extxref[a].soff].place==EPFUNC?
             funcs[fl->ext[fl->extxref[a].soff].off].poff
             :fl->stfnlist[fl->ext[fl->extxref[a].soff].off].poff))
         :(fl->extxref[a].sect==SCSTATIC?
           fl->poff+fl->extxref[a].soff
         :((fatal=1),yyerror("unknown sect in extxref")))); /*HERE and below */
    }
    for(a=0;a<fl->stpxcnt;a++)
    { *(unsigned short *)(fl->strconsts+fl->stpxref[a].poff)+=
        (fl->stpxref[a].sect==SCPUBLIC?
          (fl->ext[fl->stpxref[a].soff].place==EPEXT?
            master[fl->ext[fl->stpxref[a].soff].off].poff
            :(fl->ext[fl->stpxref[a].soff].place==EPFUNC?
              funcs[fl->ext[fl->stpxref[a].soff].off].poff
              :fl->stfnlist[fl->ext[fl->stpxref[a].soff].off].poff))
          :(fl->stpxref[a].sect==SCSTATIC?
            fl->poff+fl->stpxref[a].soff
          :((fatal=1),yyerror("unknown sect in stpxref"))));
    }
    /*{ *(unsigned short *)(fl->strconsts+fl->stpxref[a].poff)+=
        (fl->stpxref[a].sect==SCPUBLIC
        ?master[fl->ext[fl->stpxref[a].soff].off].poff:(fl->stpxref[a].sect
        ==SCSTATIC?fl->poff+fl->stpxref[a].soff:((fatal=1)
        ,yyerror("unknown sect in stpxref"))));
    }*/
  }
  for(a=0;a<mstrcnt;a++)
  { if(!master[a].used) continue;
    RAL(extstf,extsz+master[a].sz,char);
    /*MORE: predefs*/
    if(file[master[a].file].ext[master[a].foff].prepres)
    { if(file[master[a].file].ext[master[a].foff].presz!=master[a].sz)
      { fatal=1; yyerror("predef is not same size as master"); }
      else
      { memcpy(extstf+extsz,file[master[a].file].ext[master[a].foff].pre
         ,master[a].sz);
        extsz+=master[a].sz;
        free(file[master[a].file].ext[master[a].foff].pre);
      }
    }
    else while(master[a].sz--) extstf[extsz++]=0;
  }
  /* locate main and write out startup routine */
  for(a=0;a<fncnt;a++) if(!strcmp(funcs[a].nm,"main")) break;
  if(a>=fncnt) { yyerror("function main dissapeared!"); exit(-1); }
  b=a;
  /* finit
   * cld
   * mov cx,[poff]
   * lea si,[poff+2]
   * push cs
   * pop dx
   * ;!:lb:
   * lodsw
   * mov bx,ax
   * mov [bx],dx
   * loop :lb:
   * jmp +0
   * call main
   * int 20
   * db e3 fc 8b 0e poff 8d 36 pof2 0e 5a : ad 8b d8 89 17 e2 f9 eb 0
   *  9a off seg cd 20 */
  outfile=fopen(argv[1],"w");
  if(!outfile) { yyerror("cannot open output file"); exit(-1); }
  a=0xe3db; fwrite(&a,2,1,outfile); a=0x8bfc; fwrite(&a,2,1,outfile);
  a=0x0e; fwrite(&a,1,1,outfile); fwrite(&poff,2,1,outfile);
  a=0x368d; fwrite(&a,2,1,outfile); a=poff+2; fwrite(&a,2,1,outfile);
  a=0x5a0e; fwrite(&a,2,1,outfile); a=0x8bad; fwrite(&a,2,1,outfile);
  a=0x89d8; fwrite(&a,2,1,outfile); a=0xe217; fwrite(&a,2,1,outfile);
  a=0xebf9; fwrite(&a,2,1,outfile); a=0x9a00; fwrite(&a,2,1,outfile);
  fwrite(&funcs[b].poff,2,1,outfile);
  fwrite(&a,2,1,outfile); a=0x20cd; fwrite(&a,2,1,outfile);
  RAL(csxref,cssz+1,short);
  csxref[cssz++]=0x100+25;
  /* write statfuncs */
  for(fcnt=2;fcnt<argc;fcnt++)
  { fl=file+fcnt;
    for(a=0;a<fl->stfcnt;a++)
    { if(!fl->stfnlist[a].used) continue;
      fn=fl->funcs+fl->stfnlist[a].fnnm;
      for(b=0;b<fn->exrcnt;b++)
      { switch(fl->ext[fn->exref[b].scoff].place)
        { case EPEXT:
           *(unsigned short *)(fn->bops+fn->exref[b].off-fn->fnhead)
            +=master[fl->ext[fn->exref[b].scoff].off].poff;
          break;
          case EPSTAT:
           *(unsigned short *)(fn->bops+fn->exref[b].off-fn->fnhead)
            =fl->stfnlist[fl->ext[fn->exref[b].scoff].off].poff;
           RAL(csxref,cssz+1,short);
           csxref[cssz++]=2+fl->stfnlist[a].poff+fn->exref[b].off-fn->fnhead;
          break;
          case EPFUNC:
           *(unsigned short *)(fn->bops+fn->exref[b].off-fn->fnhead)
            =funcs[fl->ext[fn->exref[b].scoff].off].poff;
           RAL(csxref,cssz+1,short);
           csxref[cssz++]=2+fl->stfnlist[a].poff+fn->exref[b].off-fn->fnhead;
          break;
          default: yyerror("unknown extern place near end"); exit(-1);
        }
/*fprintf(stderr,"ptrfnc %d   cssz %d\n",fn->exref[b].ptrfnc,cssz);*/
        if(fn->exref[b].ptrfnc) csxref[cssz-1]-=5; /*was 6 in Ver 1.0*/
      }
      fwrite(fn->bops,1,fn->blen,outfile);
    }
  }
  /* write funcs */
  for(a=0;a<fncnt;a++)
  { if(!funcs[a].used) continue;
    fl=file+funcs[a].file;
    fn=fl->funcs+funcs[a].foff;
    for(b=0;b<fn->exrcnt;b++)
    { switch(fl->ext[fn->exref[b].scoff].place)
      { case EPEXT:
         *(unsigned short *)(fn->bops+fn->exref[b].off-fn->fnhead)
          +=master[fl->ext[fn->exref[b].scoff].off].poff;
        break;
        case EPSTAT:
         *(unsigned short *)(fn->bops+fn->exref[b].off-fn->fnhead)
          =fl->stfnlist[fl->ext[fn->exref[b].scoff].off].poff;
         RAL(csxref,cssz+1,short);
         csxref[cssz++]=2+funcs[a].poff+fn->exref[b].off-fn->fnhead;
        break;
        case EPFUNC:
         *(unsigned short *)(fn->bops+fn->exref[b].off-fn->fnhead)
          =funcs[fl->ext[fn->exref[b].scoff].off].poff;
         RAL(csxref,cssz+1,short);
         csxref[cssz++]=2+funcs[a].poff+fn->exref[b].off-fn->fnhead;
        break;
        default: yyerror("unknown extern place near end"); exit(-1);
      }
/*fprintf(stderr,"ptrfnc %d   cssz %d\n",fn->exref[b].ptrfnc,cssz);*/
      if(fn->exref[b].ptrfnc) csxref[cssz-1]-=5;
    }
    fwrite(fn->bops,1,fn->blen,outfile);
    free(fn->bops);
  }
  /* write external area */
  for(fcnt=2;fcnt<argc;fcnt++)
  { fl=file+fcnt;
    fwrite(fl->strconsts,1,fl->strclen,outfile);
    free(fl->strconsts);
  }
  fwrite(extstf,1,extsz,outfile);
  fwrite(&cssz,2,1,outfile);
  fwrite(csxref,2,cssz,outfile);
  fclose(outfile);
  exit(fatal);
}
xrefpreuse(plc,f,off) int plc,fl,off;
{ int b,x;
  struct file *fil;
  struct prexref *px;
  fil=file+f;
/*fprintf(stderr,"xrefpre plc %d  f %d  off %d\n",plc,f,off);*/
  switch(plc)
  { case EPSTAT:
     px=fil->stpxref;
    break;
    case EPEXT:
     px=fil->extxref;
    break;
    default: fatal=1; yyerror("unknown place in xrefpreuse");
  }
  for(b=0;plc==EPEXT?px[b].eoff<=off:b<fil->stpxcnt;b++)
  {
/*fprintf(stderr,"px[b].eoff %d  off %d  fil->stpxcnt %d  fil->extxcnt %d\n"
,px[b].eoff,off,fil->stpxcnt,fil->extxcnt);*/
    if(plc!=EPEXT||px[b].eoff==off)
    { 
/*fprintf(stderr,"px[b].sect %d\n",px[b].sect);*/
      switch(px[b].sect)
      { case SCSTATIC: break;
        /*case SCSTATFUNC:
         for(x=0;x<fil->stfcnt;x++)
           if(!strcmp(fil->ext[px[b].soff].nm
             ,fil->funcs[fil->stfnlist[x].fnnm].nm))
           { xrefuse(EPSTAT,f,x); break; }
         if(x>=fil->stfcnt)
         { fatal=1; yyerror("static function not found"); }
        break; /*doneHERE*/
        case SCPUBLIC:
/*fprintf(stderr,"fil->ext[px[b].soff].tp %d\n",fil->ext[px[b].soff].tp);*/
         if(fil->ext[px[b].soff].tp==SFUNC)
           xrefuse(EPFUNC,fil->ext[px[b].soff].off,0);
         else if(fil->ext[px[b].soff].tp==SSTATFUNC)
           xrefuse(EPSTAT,f,fil->ext[px[b].soff].off);
         else
         { if(master[fil->ext[px[b].soff].off].used) break;
           master[fil->ext[px[b].soff].off].used=1;
/*fprintf(stderr,"EPEXT (internal)\n");*/
           xrefpreuse(EPEXT,master[fil->ext[px[b].soff].off].file
             ,master[fil->ext[px[b].soff].off].foff);
         }
        break;
        default: fatal=1; yyerror("illegal section for pointer");
      }
    }
  }
/*fprintf(stderr,"EXIT\n");*/
/*  struct prexref *extxref,*stpxref;
  long extxcnt,stpxcnt,poff,nstln;
struct prexref
{ char sect;
  long eoff,soff,poff;
} *stprexref,*extxref;*/
}
xrefuse(plc,off,aux)
{ struct func *fnc;
  struct file *fil;
  long b;
  switch(plc)
  { case EPFUNC:
     if(funcs[off].used) return; /* avoid continuous loops caused by recur */
     funcs[off].used=1;
     fil=file+funcs[off].file;
     fnc=fil->funcs+funcs[off].foff;
    break;
    case EPSTAT:
     if(file[off].stfnlist[aux].used) return;
     file[off].stfnlist[aux].used=1;
     fil=file+off;
     fnc=fil->funcs+fil->stfnlist[aux].fnnm;
    break;
    default: yyerror("unknown place in xrefuse"); exit(-1);
/*fprintf(stderr,"place: %d\n",plc);*/
  }
  for(b=0;b<fnc->exrcnt;b++)
  { switch(fil->ext[fnc->exref[b].scoff].place)
    { case EPEXT: master[fil->ext[fnc->exref[b].scoff].off].used=1;
/*fprintf(stderr,"EPEXT (external)\n");*/
       xrefpreuse(EPEXT,master[fil->ext[fnc->exref[b].scoff].off].file
         ,master[fil->ext[fnc->exref[b].scoff].off].foff);
      break;
/*MORE:HERE: scan EPEXT for any pointer predefs and xrefuse on them*/
      case EPSTAT:
       xrefuse(EPSTAT,off,fil->ext[fnc->exref[b].scoff].off);
      break;
      case EPFUNC:
       xrefuse(EPFUNC,fil->ext[fnc->exref[b].scoff].off,0);
      break;
      default:
       fatal=1; yyerror("unknown external place (var,statfunc,func)");
    }
  }
}
typesz(ext) struct externvar ext;
{ switch(ext.tp%SUNSIGNED)
  { case SCHAR:
     return(1);
    case SSHORT:
    case SINT:
     return(2);
    case SFLOAT:
    case SLONG:
    case SPOINTER:
     return(4);
    case SDOUBLE:
     return(8);
    case SARRAY:
    case SSTRUCT:
     return(ext.sz);
    default: fatal=1; yyerror("unknown type in typesz()");
  }
}
yyerror(s) char *s;
{ fprintf(stderr,"dln: %s:(error) cannot trace line number\n",s);
}
