/* auxilery functions for C compiler */
char RALmsg[]="RAL() can't get enough memory";
char ALmsg[]="AL() can't get enough memory";

extern int yylineno;
#include <stdio.h>
#include "head.h"
#include "pseudo.h"

extern int yydebug;

static freenamedtp(nmtp) struct namedtype *nmtp;
{ free(nmtp->nm);
  if(nmtp->t.modlev) free(nmtp->t.mod);
}

freeupvars(vdptr) struct vds *vdptr;
{ int x,y;
  for(x=0;x<vdptr->vdcnt;x++)   freenamedtp(vdptr->vd+x);
  if(x) free(vdptr->vd);
  for(x=0;x<vdptr->soudcnt;x++) freenamedtp(vdptr->soud+x);
  if(x) free(vdptr->soud);
  for(x=0;x<vdptr->tpdcnt;x++)  freenamedtp(vdptr->tpd+x);
  if(x) free(vdptr->tpd);
  for(x=0;x<vdptr->lvdcnt;x++)
  { for(y=0;y<vdptr->lvd[x].cnt;y++) freenamedtp(vdptr->lvd[x].pt+y);
    if(y) free(vdptr->lvd[x].pt);
  }
  if(x) free(vdptr->lvd);
}

createintfunc(vdptr,offptr,name) flong *vdptr,*offptr; char *name;
{ flong vdp,op;
  vdp=0/*vdscnt-1*/; op=vds[vdp].vdcnt;
  if(op)
  { RAL(vds[vdp].vd,op+1,struct namedtype);
  } else AL(vds[vdp].vd,1,struct namedtype);
  vds[vdp].vdcnt++;
  vds[vdp].vd[op].nm=name;
  vds[vdp].vd[op].p.cnt=0;
  typeinit(&(vds[vdp].vd[op].t)); vds[vdp].vd[op].t.u.tp=SINT;
  AL(vds[vdp].vd[op].t.mod,1,struct modstuff);
  vds[vdp].vd[op].t.mod->null=1;
  vds[vdp].vd[op].t.mod->u.fn.argcnt=0;
  vds[vdp].vd[op].t.mod->u.fn.only=0;
  vds[vdp].vd[op].t.mod->mod=MFUNC;
  vds[vdp].vd[op].t.modlev++;

  RAL(exttbl,exttblsz+1,struct exttbl);
  Scp(&(exttbl[exttblsz].nm),name);
  exttbl[exttblsz].tp=SFUNC; exttbl[exttblsz].scope=SCPEXTERN;
  vds[vdp].vd[op].sect=SCPUBLIC;
  vds[vdp].vd[op].off=exttblsz;
  exttbl[exttblsz++].prepres=0;
  *vdptr=vdp; *offptr=op;
}

startvdefs(tp,rtn)
/* start a list of variable defs; used for struct elements, compound
 *  statement vdefs, 2 types of argument definitions, and typedef commands */
{
  if(vldscnt==vldAL)
  { vldAL++;
    RAL(vldstack,vldAL,struct varloadstack);
  }
  vldstack[vldscnt].tp=tp; vldstack[vldscnt].rtn=rtn;
  switch(tp)
  { case VDTTPDEF:
     vldstack[vldscnt].u.num=vdscnt-1;
    break;
    case VDTVD:
     RAL(vds,vdscnt+1,struct vds);
     vldstack[vldscnt].u.num=vdscnt;
     vds[vdscnt].tpdcnt=vds[vdscnt].soudcnt=vds[vdscnt].vdcnt
       =vds[vdscnt].lvdcnt=0;
     vdscnt++;
    break;
    case VDTLOC:
     vldstack[vldscnt].u.vdfs.cnt=vldstack[vldscnt].u.vdfs.size=0;
    break;
    default:
     fatal=1; yyerror("internal error in startvdefs");
  }
  vldscnt++;
}

vdefsload(ptr,cnt,rtn,tp,vlist)
  struct namedtype **ptr;
  int *cnt,rtn;
  struct type *tp;
  struct vardefs *vlist;
{ int x,y;
  if(*cnt) { RAL((*ptr),(*cnt)+vlist->cnt,struct namedtype); }
  else AL((*ptr),vlist->cnt,struct namedtype);
  for (x=0;x<vlist->cnt;x++)
  { (*ptr)[x+(*cnt)]=vlist->pt[x]; (*ptr)[x+(*cnt)].t.u=tp->u;
    (*ptr)[x+(*cnt)].t.tp=tp->tp;
    (*ptr)[x+(*cnt)].t.scope=tp->scope;
    (*ptr)[x+(*cnt)].t.modpos=0;
    (*ptr)[x+(*cnt)].t.treg=tp->treg;
    (*ptr)[x+(*cnt)].t.tvolatile=tp->tvolatile;
    (*ptr)[x+(*cnt)].t.field=tp->field;
    /*MORE: erroneous void if type>NOTYPE verify no access to nons*/
/*MEREfuture: no void variables, but type-cast to void or func/pointer
 * with void are OK */
    if(tp->modlev)
    { if(vlist->pt[x].t.modlev)
      { RAL((*ptr)[x+(*cnt)].t.mod,tp->modlev+vlist->pt[x].t.modlev
          ,struct modstuff);
      }
      else AL((*ptr)[x+(*cnt)].t.mod,tp->modlev,struct modstuff);
      memcpy((char *)((*ptr)[x+(*cnt)].t.mod+vlist->pt[x].t.modlev)
       ,(char *)(tp->mod),(int)(tp->modlev)*sizeof(struct modstuff));
      (*ptr)[x+(*cnt)].t.modlev+=tp->modlev;
    }
    if(rtn!=VDRTPDEF)
      (*ptr)[x+(*cnt)].t.size=variablesize((*ptr)[x+(*cnt)].t);
    if(modtypeverify((*ptr)[x+(*cnt)].t)&&rtn!=VDRTPDEF)
     /* modtypeverify is first because we DO want to detect other problems*/
    { yyerror("illegal type: unknown size"); }

    for(y=0;y<(*cnt);y++)        /* check for illegal duplicate definitions */
      if(!strcmp((*ptr)[y].nm,vlist->pt[x].nm))
      { tpoftype(&(*ptr)[y].t); tpoftype(&(*ptr)[x+*cnt].t);
        if((rtn!=VDREXTERN&&tp->scope!=SCPEXTERN)||tp->scope==SCPSTATIC
          ||(*ptr)[y].t.scope!=SCPEXTERN
          ||((*ptr)[x+ *cnt].p.cnt&&(*ptr)[y].p.cnt)
          ||(*ptr)[x+*cnt].t.curtp!=(*ptr)[y].t.curtp)
        {incompatible_duplicate_def:
          sprintf(temp,"duplicate and incompatable definition of: \"%s\""
             ,vlist->pt[x].nm);
fprintf(stderr
,"rtn %d tp->scope %d y.scope %d x.cnt %d y.cnt %d x.curtp %d y.curtp %d\n"
,rtn,tp->scope,(*ptr)[y].t.scope,(*ptr)[x+*cnt].p.cnt,(*ptr)[y].p.cnt
,(*ptr)[x+*cnt].t.curtp,(*ptr)[y].t.curtp);
          yyerror(temp); fatal=1;
         break;
        }
        else switch((*ptr)[y].t.curtp)
          { case SSTRUCT:
             if(variablesize((*ptr)[y].t)!=variablesize((*ptr)[x+(*cnt)].t))
               goto incompatible_duplicate_def;
#ifdef UNDEF
             else
             {possibly_illegal:
               sprintf(temp,"looks OK but might be illegal duplicate \"%s\""
                 ,vlist->pt[x].nm);
               yyerror(temp);
             }
#endif /*UNDEF*/
            break;
            case SPOINTER:
             if(objectsize((*ptr)[y].t)!=objectsize((*ptr)[x+(*cnt)].t))
               goto incompatible_duplicate_def;
#ifdef UNDEF
             else goto possibly_illegal;
#endif /*UNDEF*/
          }
      }

    if(rtn==VDREXTERN)
    { externstaticalloc((*ptr)+(x+(*cnt)));
    }
    else if(rtn==VDRALLOC)
    { allocvardefsalloc((*ptr)+(x+(*cnt)));
    }
/*MEREfuture: else check to make sure that it isn't a func*/
  }
  (*cnt)+=vlist->cnt;
  if(tp->modlev) free(tp->mod);
}

allocvardefsalloc(invds) struct namedtype *invds;
{ /*NONPORTABLE: this whole section could contain nonportable stuff*/
  /*if your modifiing this; you may want to modify structalloc() in func.c*/
  int c;
  /*MORE: write allocpredef as used below
   * 1: if predefs allocate and store them; and if size depends on them...
   * 2: at end use */

  if(invds->t.scope!=SCPDEFAULT||(invds->t.modlev&&invds->t.mod->mod==MFUNC))
  { externstaticalloc(invds);
  }
  else
  { int adjust;
    findspec(&invds->t);
    invds->sect=SCAUTO/*+invds->t.treg*SCREGISTER*/;
/*MERE: make sure not already defined somewhere. */
    if(alignauto==2)
      if(!invds->t.size&3)
      { adjust=((ssn+3)&0xfffffffc);
        totssn+=adjust-ssn;
        ssn=adjust; 
      }
      else if(!invds->t.size&1)
      { adjust=((ssn+1)&0xfffffffe);
        totssn+=adjust-ssn;
        ssn=adjust; 
      }
    invds->off=totssn;
    ssn+=invds->t.size;
    totssn+=invds->t.size;
    if(invds->p.cnt)
    { double di; float fi; long li; int it;
      struct expr ex,ex0,exout;
      it=invds->p.s->t;
  /*    if(invds->p.cnt>1||it==PRPOINTER||it==PRSTRING
         ||it==PRPREV||it==PRCODE||invds->t.size>10)/*NONPORTABLE*/
/*MEREfuture: handle all of these. */
      if(invds->p.cnt>1||it==PRPREV||invds->t.size>10)
      { fatal=1; yyerror("illegal: auto variables can be initialized\
 only if fundemental type"); goto allocvardefsrecover;
      }
      ex.pconst=1;
      ex.t=invds->p.s->u.cd.t;
      ex.p=invds->p.s->u.cd.p;
      ex.const=ex.tcnt=ex.fcnt=/*ex.t.modpos=*/ex.lval=0;
/*      ex.t.ptr=0;
*/
      ex.c= *invds->p.s;
      switch(it)
      { case PRSTRING:
/*         stringstf(&ex);
        goto handlecode;
*/
        case PRPOINTER:
/*         ex.t=invds->t;
         tpoftype(&ex0.t);
         if(ex.t.tp>NOTYPE)
         { fatal=1; yyerror("7unknown size"); }
     
         AL(ex.p.d,4+2*solong,char);
         *(ex.p.d)=ORECOG; ex.p.l=1;
         ex.p.d[ex.p.l++]=ex.t.curtp;
         if(ex.t.curtp==SPOINTER||ex.t.curtp==SSTRUCT)
         { SLDLONG(ex.p.d+ex.p.l,ex.t.curtp==SSTRUCT?variablesize(ex.t)
             :objectsize(ex.t));
           ex.p.l+=solong;
         }

         ex.p.d[ex.p.l++]=ex.c.u.ptr.sect;
         SLDLONG(ex.p.d+ex.p.l,ex.c.u.ptr.off+ex.c.u.ptr.boff); ex.p.l+=solong;
         if(ex.t.curtp==SPOINTER&&ex.t.mod->mod==MAR_ELE)
           ex.p.d[ex.p.l++]=OSTOPTR;
*/
         fatal=1; yyerror("internal error: illegal initialization");
        case PRCODE:
        handlecode:
         ex0.t=invds->t;
         tpoftype(&ex0.t);
         ex0.const=ex0.tcnt=ex0.fcnt=ex0.t.modpos=0; ex0.lval=1;
         ex0.t.ptr=0;
         AL(ex0.p.d,4+2*solong,char);
         *(ex0.p.d)=ORECOG; ex0.p.l=1;
         ex0.p.d[ex0.p.l++]=ex0.t.curtp;
         if(ex0.t.curtp==SPOINTER||ex0.t.curtp==SSTRUCT)
         { SLDLONG(ex0.p.d+ex0.p.l,ex0.t.curtp==SSTRUCT?variablesize(ex0.t)
             :objectsize(ex0.t));
           ex0.p.l+=solong;
         }

         ex0.p.d[ex0.p.l++]=SCAUTO;
         SLDLONG(ex0.p.d+ex0.p.l,invds->off);
         ex0.p.l+=solong;
         assignop(&exout,&ex0,&ex);
         RAL(allocprecode.d,allocprecode.l+exout.p.l+1,char);
         memcpy(allocprecode.d+allocprecode.l,exout.p.d,exout.p.l);
         allocprecode.l+=exout.p.l; free(exout.p.d);
         allocprecode.d[allocprecode.l++]=OPOP;
        break;
        default:
         RAL(autin,invds->t.size+autincnt+1+solong,char);
         SLDLONG(autin+autincnt,totssn-invds->t.size); autincnt+=solong;
         autin[autincnt++]=invds->t.size;
         tpoftype(&invds->t);
         li=fi=di= (it==PRDOUBLE)?invds->p.s->u.d:(it==PRLONG
           ?invds->p.s->u.l:yyerror("illegal init"));
         switch(invds->t.curtp%SUNSIGNED)
         { case SPOINTER: /* constant only */
            if(invds->t.mod[invds->t.modlev-1].mod!=MSTAR)
            { fatal=1; yyerror("illegal auto pointer init"); }
           case SCHAR:
           case SSHORT:
           case SINT:
           case SLONG:
            for(c=0;c<invds->t.size;c++)/*assume INTEL(chip) mem organize*/
             autin[autincnt++]=((char *)(&li))[c];
           break;
           case SDOUBLE:
            for(c=0;c<invds->t.size;c++)
             autin[autincnt++]=((char *)(&di))[c];
           break;
           case SFLOAT:
            for(c=0;c<invds->t.size;c++)
             autin[autincnt++]=((char *)(&fi))[c];
           break;
           default: yyerror("init illegal auto type");
         }
      }
    }
   allocvardefsrecover: ;
  }
}

externstaticalloc(invds) struct namedtype *invds;
{ /*NONPORTABLE: this whole section could contain nonportable stuff*/
  /*if you're modifiing this; you may want to modify structalloc() in func.c*/
  int y,extindx;
  struct namedtype curnmt2;

  if(invds->t.scope==SCPDEFAULT) invds->t.scope=SCPEXTERN;
  findspec(&invds->t);
  if(invds->t.modlev&&invds->t.mod->mod==MFUNC)
  { if(invds->p.cnt)
    { yyerror("illegal: initailization of function. ignoring"); }
  }
  invds->t.modpos=0;
  tpoftype(&invds->t);
  RAL(exttbl,exttblsz+1,struct exttbl);
   /* allocpredefs calls stringstf which modifies exttblsz  SO: */
  extindx=exttblsz++;
  exttbl[extindx].prepres=0;
  if(invds->p.cnt)
  { exttbl[extindx].prepres=1;
    curprd.len=curprd.pcnt=0;
    AL(curprd.p,1,char);
    curnmt2.t=invds->t; curnmt2.nm=invds->nm; y=0;
    curnmt2.t.ptr=curnmt2.t.modpos=0;
    allocpredef(&invds->p,&y,&curnmt2,0);
    free(invds->p.s);
    exttbl[extindx].presz=curprd.len;
    curnmt2.t.modpos=0;
    curnmt2.t.size=variablesize(curnmt2.t);
    if(curprd.len!=curnmt2.t.size)
    { fatal=1; yyerror("2internal error predef size");
fprintf(stderr,"curnmt2.t.size %d len %d\n",curnmt2.t.size,curprd.len);
 }
    invds->t=curnmt2.t;
    if(curprd.pcnt)
    { if(extxcnt) { RAL(extxref,extxcnt+curprd.pcnt,struct prexref); }
      else { AL(extxref,extxcnt+curprd.pcnt,struct prexref); }
      for(y=0;y<curprd.pcnt;y++)
      { extxref[extxcnt].soff=curprd.ptr[y].soff;
        extxref[extxcnt].sect=curprd.ptr[y].sect;
        extxref[extxcnt].eoff=extindx;
        extxref[extxcnt++].poff=curprd.ptr[y].poff;
      }
      free(curprd.ptr);
    }
    exttbl[extindx].pre=curprd.p;
  }
  if(invds->t.scope==SCPSTATIC&&invds->t.curtp!=SFUNC)
    Scp(&(exttbl[extindx].nm),"");
  else Scp(&(exttbl[extindx].nm),invds->nm);
  exttbl[extindx].size=invds->t.size;
  exttbl[extindx].tp=invds->t.curtp; exttbl[extindx].scope=invds->t.scope;
  if(invds->t.mod->mod==MAR_ELE) exttbl[extindx].tp=SARRAY;
  invds->sect=SCPUBLIC/*+invds->t.treg*SCREGISTER*/;
  invds->off=extindx;
}

argsalloc(invds,vdcnt) struct namedtype *invds;
{ int argslen,x;
  for(argslen=x=0;x<vdcnt;x++)
  { if(invds[x].t.modlev&&invds[x].t.mod->mod==MAR_ELE)
    { invds[x].t.mod->mod=MSTAR; invds[x].t.size=sopoint; }
    if(invds[x].t.scope!=SCPDEFAULT)
    { fatal=1; yyerror("cannot define extern or static arguments"); }
    if(invds[x].p.cnt)
    { fatal=1; yyerror("cannot initialize argument values"); }

    if(!invds[x].t.modlev&&!invds[x].t.tp)
    { switch(invds[x].t.u.tp)
      { case SCHAR:
        case SSHORT:
         invds[x].t.u.tp=SINT;
         invds[x].t.size=soint;
        break;
        case SCHAR+SUNSIGNED:
        case SSHORT+SUNSIGNED:
         invds[x].t.u.tp=SINT+SUNSIGNED;
         invds[x].t.size=soint;
        break;
        case SFLOAT:
         invds[x].t.u.tp=SDOUBLE;
         invds[x].t.size=sodouble;
      }
    }
    invds[x].sect=SCARG;
    invds[x].off=argslen;
    argslen+=invds[x].t.size;
  }
}

stringstf(e) struct expr *e;
{ struct cptr p;
  if(e->pconst==1&&e->c.t==PRSTRING)
  { p.len=e->c.u.s.len;
    p.off=exttblsz;
    p.boff=0; p.sect=SCPUBLIC;
    RAL(exttbl,exttblsz+1,struct exttbl);
    exttbl[exttblsz].presz=exttbl[exttblsz].size=p.len;
    exttbl[exttblsz].pre=e->c.u.s.stf;
    exttbl[exttblsz].prepres=1;
    Scp(&exttbl[exttblsz].nm,"");
    exttbl[exttblsz].tp=SARRAY; exttbl[exttblsz].scope=SCPSTATIC;
    AL(e->p.d,2*solong+4,char); *(e->p.d)=ORECOG; e->p.l=1;
    e->p.d[e->p.l++]=SPOINTER;
    SLDLONG(e->p.d+e->p.l,1); e->p.l+=solong;
    e->p.d[e->p.l++]=SCPUBLIC;
    SLDLONG(e->p.d+e->p.l,exttblsz); e->p.l+=solong;
    e->p.d[e->p.l++]=OSTOPTR;
    e->c.u.ptr=p; e->c.t=PRPOINTER; exttblsz++;
  }
}

findspec(tp) struct type *tp;
/* find definition of struct or union */
{ int c,d; /* MORE? check for legality */
  if(!(tp->tp>NOTYPE&&tp->tp<=NOTYPE+2)) return;
  for(c=vdscnt-1;c>=0;c--)
  { for(d=0;d<vds[c].soudcnt;d++)
     if(!strcmp(vds[c].soud[d].nm,tp->u.nm))
     { tp->tp=vds[c].soud[d].t.tp;
       tp->u=vds[c].soud[d].t.u;
/*MERE: in order to free .nm, must be accessing the MAIN copy */
/*See MERE in types in yacc.y
 *       if(tp->u.p.l>=tp->notypevdscnt)
 *       { fatal=1;
 *fprintf(stderr,"l %d notypevdscnt %d\n",tp->u.p.l,tp->notypevdscnt);
 *         yyerror("can't define structure types at higher nested level");
 *        exit(-1);
 *       }
 */
      goto done;
     }
  }
 done: ;
}

allocpredef(pre,poff,nmt,usedagg) flong *poff; struct namedtype *nmt;
 struct prevalue *pre;
{ /*NOTE: this whole thing is non-portable */
  flong d,e,c;
  int adjust,lsz;
  struct vardefs *lvdp;
  tpoftype(&nmt->t);
/*fprintf(stderr
,"enterring allocpredefs(%#x,%#x &(%d),%#x) nm [%s] tp %d mod %d\n",pre
,poff,*poff,nmt,nmt->nm,nmt->t.curtp,nmt->t.mod[nmt->t.modpos].mod);
printprev(*pre);
*/
  if(*poff>=pre->cnt)
  { d=curprd.len+nmt->t.size;
if(nmt->t.size!=variablesize(nmt->t))
fprintf(stderr,"!!!!!!!!!!!!!!! size mismatch size %d vsize %d\n",nmt->t.size
,variablesize(nmt->t));
    RAL(curprd.p,d,char);
    while(curprd.len<d) curprd.p[curprd.len++]=0;
   return 1;
  }
  else
  { if(pre->s[*poff].t==PRCODE)
    { yyerror("cannot initialize global vars with non-constants"); }
    switch(nmt->t.curtp%SUNSIGNED) /*NONPORTABLE: short and float*/
    { case SPOINTER:
       switch(nmt->t.mod[nmt->t.modpos].mod)
       { case MSTAR: /* pconst or 0  put into */
          RAL(curprd.p,curprd.len+sopoint,char);
          if(pre->s[*poff].t==PRSTRING)
          { struct expr exp;
            exp.c=pre->s[*poff];
            exp.pconst=1;
            stringstf(&exp);
            free(exp.p.d);
            pre->s[*poff]=exp.c;
           goto pointerxref;
          }
          else if(pre->s[*poff].t!=PRPOINTER)
          { SLDLONG(curprd.p+curprd.len,0);
            e=pre->s[*poff].t;
            if(e!=PRLONG||pre->s[*poff].u.l)
            { yyerror("pointer initialized illegally: assuming 0"); }
          }
          else
          {pointerxref:
            if(curprd.pcnt) { RAL(curprd.ptr,curprd.pcnt+1,struct predefptr); }
            else AL(curprd.ptr,1,struct predefptr);
            curprd.ptr[curprd.pcnt].poff=curprd.len;
            *(long *)(curprd.p+curprd.len)=pre->s[*poff].u.ptr.boff;
  /* seg should be overwritten if 8086 */
            curprd.ptr[curprd.pcnt].soff=pre->s[*poff].u.ptr.off;
            curprd.ptr[curprd.pcnt++].sect=pre->s[*poff].u.ptr.sect;
          }
          curprd.len+=sopoint;
          (*poff)++;
         break;
         case MAR_ELE:
          if(nmt->t.mod[nmt->t.modpos].null)
          { /* allocate untill all predefs used */
            nmt->t.modpos++;
            if(pre->s[*poff].t==PRSTRING&&variablesize(nmt->t)==1)
            { c=pre->s[*poff].u.s.len;
              RAL(curprd.p,curprd.len+c,char);
              memcpy(curprd.p+curprd.len,pre->s[*poff].u.s.stf,c);
              curprd.len+=c;
              free(pre->s[*poff].u.s.stf);
              if(variablesize(nmt->t)!=1)
              { fatal=1; yyerror("init non-char array with string"); }
              (*poff)++;
            }
            else if(pre->s[*poff].t==PRPOINTER)
            {/* if(pre->s[*poff].u.ptr.sect!=SCSTATIC
                ||nmt->t.modlev-nmt->t.modpos>1||nmt->t.tp||nmt->t.u.tp!=SCHAR)
              { fatal=1; yyerror("illegal initialization"); }
  */
  yyerror("not be here PRPOINTER");
              e=pre->s[*poff].u.ptr.len;
              RAL(curprd.p,curprd.len+e,char);
              for(c=0;c<e;c++)
                curprd.p[curprd.len++]=strcnsts[pre->s[*poff].u.ptr.off+c];
            }
            else if(pre->s[*poff].t!=PRPREV||!usedagg)
              for(c=0;*poff<pre->cnt;c++)
              { allocpredef(pre,poff,nmt,1); }
            else
            { for(e=c=0;e<pre->s[*poff].u.p.cnt;c++)
              { allocpredef(&pre->s[*poff].u.p,&e,nmt,1); }
              free(pre->s[*poff].u.p.s);
              (*poff)++;
            }
            nmt->t.mod[--nmt->t.modpos].u.arr=c;
            nmt->t.mod[nmt->t.modpos].null=0;
    /* possibly use allocpredef for each element? */
          }
          else /* not null */
          { nmt->t.modpos++;
            if(pre->s[*poff].t==PRSTRING&&variablesize(nmt->t)==1)
            { c=pre->s[*poff].u.s.len;
              RAL(curprd.p,curprd.len+c,char);
              memcpy(curprd.p+curprd.len,pre->s[*poff].u.s.stf,c);
              curprd.len+=c;
              free(pre->s[*poff].u.s.stf);
              if(variablesize(nmt->t)!=1)
              { fatal=1; yyerror("init non-char array with string"); }
              (*poff)++;
            }
            else if(pre->s[*poff].t==PRPOINTER)
            {/* if(pre->s[*poff].u.ptr.sect!=SCSTATIC
                ||nmt->t.modlev-nmt->t.modpos>1||nmt->t.tp||nmt->t.u.tp!=SCHAR)
              { fatal=1; yyerror("illegal initialization"); }
  */
  yyerror("not here static 2");
              e=nmt->t.mod[nmt->t.modpos-1].u.arr;
              RAL(curprd.p,curprd.len+e,char);
              for(c=0;c<e&&c<pre->s[*poff].u.ptr.len;c++)
                curprd.p[curprd.len++]=strcnsts[pre->s[*poff].u.ptr.off+c];
            }
            else if(pre->s[*poff].t!=PRPREV||!usedagg)
             for(c=0;c<nmt->t.mod[nmt->t.modpos-1].u.arr&&*poff<pre->cnt;c++)
             { allocpredef(pre,poff,nmt,1); }
            else
            { for(e=c=0;c<nmt->t.mod[nmt->t.modpos-1].u.arr
                 &&e<pre->s[*poff].u.p.cnt;c++)
              { allocpredef(&pre->s[*poff].u.p,&e,nmt,1); }
              free(pre->s[*poff].u.p.s);
              (*poff)++;
            }
            if(c<nmt->t.mod[nmt->t.modpos-1].u.arr)
            { d=(nmt->t.mod[nmt->t.modpos-1].u.arr-c)*variablesize(nmt->t);
              RAL(curprd.p,curprd.len+d,char);
              while(d--) curprd.p[curprd.len++]=0;
            }
            nmt->t.modpos--;
          }
         break;
         default: fatal=1; yyerror("internal error: predef");
       }
      break;
      case SSTRUCT: /* call allocpredefs for each element */
       lvdp=vds[nmt->t.u.p.l].lvd+nmt->t.u.p.o;
       if((alignstructintern||alignstructextern)&&(curprd.len&3))
       { fatal=1; yyerror("internal: allocpredefs with aligned struct"); }
       lsz=curprd.len;
       if(pre->s[*poff].t!=PRPREV||!usedagg)
        for(c=0;c<lvdp->cnt;c++)
        { lvdp->pt[c].t.modpos=0;
          if(alignstructintern)
          { curprd.len-=lsz;
            if(!(lvdp->pt[c].t.size&3)) adjust=((curprd.len+3)&0xfffffffc);
            else if(!(lvdp->pt[c].t.size&1))
               adjust=((curprd.len+1)&0xfffffffe);
            else adjust=curprd.len;
            curprd.len+=lsz; adjust+=lsz;
            RAL(curprd.p,adjust,char);
            while(curprd.len<adjust) curprd.p[curprd.len++]=0;
          }
          allocpredef(pre,poff,lvdp->pt+c,1);
        }
       else
       { for(e=c=0;c<lvdp->cnt;c++)
         { lvdp->pt[c].t.modpos=0;
           if(alignstructintern)
           { curprd.len-=lsz;
             if(!(lvdp->pt[c].t.size&3)) adjust=((curprd.len+3)&0xfffffffc);
             else if(!(lvdp->pt[c].t.size&1))
                adjust=((curprd.len+1)&0xfffffffe);
             else adjust=curprd.len;
             curprd.len+=lsz; adjust+=lsz;
             RAL(curprd.p,adjust,char);
             while(curprd.len<adjust) curprd.p[curprd.len++]=0;
           }
           allocpredef(&pre->s[*poff].u.p,&e,lvdp->pt+c,1);
         }
         free(pre->s[*poff].u.p.s);
         (*poff)++;
       }
       curprd.len-=lsz;
       adjust=curprd.len;
       switch(alignstructextern)
       { case 1:
          if(curprd.len>2) adjust=((curprd.len+3)&0xfffffffc);
         break;
         case 2:
          adjust=1;
          while(adjust<curprd.len) adjust<<=1;
       }
       curprd.len+=lsz; adjust+=lsz;
       RAL(curprd.p,adjust,char);
       while(curprd.len<adjust) curprd.p[curprd.len++]=0;
      break;
      case SCHAR:   /* all scalers just copy info in. */
       RAL(curprd.p,curprd.len+sochar,char);
       if(pre->s[*poff].t!=PRLONG)
        { fatal=1; yyerror("illegal character constant"); }
       else
       { SLDCHAR(curprd.p+curprd.len,pre->s[*poff].u.l);
         curprd.len+=sochar;
       }
       (*poff)++;
      break;
      case SSHORT:
       RAL(curprd.p,curprd.len+soshort,char);
       if(pre->s[*poff].t!=PRLONG)
        { fatal=1; yyerror("illegal short constant"); }
       else
       { *(short *)(curprd.p+curprd.len)=pre->s[*poff].u.l;
         curprd.len+=soshort;
       }
       (*poff)++;
      break;
      case SINT:
       RAL(curprd.p,curprd.len+soint,char);
       if(pre->s[*poff].t!=PRLONG)
        { fatal=1; yyerror("illegal int constant"); }
       else
       { SLDINT(curprd.p+curprd.len,pre->s[*poff].u.l);
         curprd.len+=soint;
       }
       (*poff)++;
      break;
      case SLONG:
       RAL(curprd.p,curprd.len+solong,char);
       if(pre->s[*poff].t!=PRLONG)
        { fatal=1; yyerror("illegal long constant"); }
       else
       { SLDLONG(curprd.p+curprd.len,pre->s[*poff].u.l);
         curprd.len+=solong;
       }
       (*poff)++;
      break;
      case SDOUBLE:
       RAL(curprd.p,curprd.len+sodouble,char);
       e=pre->s[*poff].t;
       if(e!=PRDOUBLE&&e!=PRLONG)
        { fatal=1; yyerror("illegal double constant"); }
       else
       { SLDDOUBLE(curprd.p+curprd.len,e==PRLONG?pre->s[*poff].u.l
           :pre->s[*poff].u.d);
         curprd.len+=sodouble;
       }
       (*poff)++;
      break;
      case SFLOAT:
       RAL(curprd.p,curprd.len+sofloat,char);
       e=pre->s[*poff].t;
       if(e!=PRDOUBLE&&e!=PRLONG)
        { fatal=1; yyerror("illegal float constant"); }
       else
       { *(float *)(curprd.p+curprd.len)=e==PRLONG?pre->s[*poff].u.l
           :pre->s[*poff].u.d;
         curprd.len+=sofloat;
       }
       (*poff)++;
      break;
      default: fatal=1; yyerror("internal error: unknown tp in allcopredef");
    }
  }
 return 0;
}

objectsize(tp) struct type tp;
/* objectsize() - find size of object of pointer */
{ if(tp.ptr) tp.ptr=0;
  else tp.modpos++;
  return variablesize(tp);
}

modtypeverify(tp) struct type tp;
/*MERE: here and at calls design so that function def illegal except
 * during VDRALLOC or VDREXTERN */
/* verify modifier sequence is legal
 *returns 1 if size would be unknown */
{ int c,lastmod=50; /* dummy value to prevent getting error on first mod*/
  for(c=0;c<tp.modlev;c++)
  { switch(tp.mod[c].mod)
    { case MSTAR:
      break;
      case MAR_ELE:
       if(lastmod==MFUNC||(tp.mod[c].null&&lastmod==MAR_ELE))
       { fatal=1; yyerror("illegal type: illegal declarator1"); }
      break;
      case MFUNC:
       if(lastmod==MFUNC||lastmod==MAR_ELE)
       { fatal=1; yyerror("illegal type: illegal declarator3"); }
      break;
      default:
       fatal=1; yyerror("internal error: illegal modifier in 1storage");
    }
    lastmod=tp.mod[c].mod;
  }
  if(!tp.tp&&tp.treg&&tp.modlev&&tp.mod->mod==MFUNC)
  { fatal=1; yyerror("illegal type: register function"); }
  else return (tp.tp>NOTYPE&&(!tp.modlev
     ||(tp.mod[tp.modlev-1].mod!=MSTAR&&tp.mod[tp.modlev-1].mod!=MFUNC)));
 return 0;
}

structalloc(vard,inc) struct vardefs *vard; int inc;
/* allocate elements of structure */
{ int c,totsz=0; /* MORE: lowpriority, allocate more speed efficiently */
  /* if you are modifiing this; you may want to modify allocvardefs */
  if(inc)
    for(c=0;c<vard->cnt;c++)
    { if(alignstructintern)
        if(!(vard->pt[c].t.size&3)) totsz=((totsz+3)&0xfffffffc);
        else if(!(vard->pt[c].t.size&1)) totsz=((totsz+1)&0xfffffffe);
      vard->pt[c].byteoff=totsz;
      totsz+=vard->pt[c].t.size;
      vard->pt[c].bitoff=0;
    }
  else
    for(c=0;c<vard->cnt;c++)
    { vard->pt[c].byteoff=0;
      if(totsz<vard->pt[c].t.size) totsz=vard->pt[c].t.size;
      vard->pt[c].bitoff=0;
    }
  switch(alignstructextern)
  { case 1:
     if(totsz>2) totsz=((totsz+3)&0xfffffffc);
    break;
    case 2:
     { int xx=1;
       while(xx<totsz) xx<<=1;
       totsz=xx;
     }
  }
  vard->size=totsz;
}

flong variablesize(tp) struct type tp;
/* return size of variable with mods */
{ int base,z;
  int badbase=0;
  if(!tp.tp)
  { switch(tp.u.tp%SUNSIGNED)
    { case SINT:    base=soint;    break;
      case SLONG:   base=solong;   break;
      case SSHORT:  base=soshort;  break;
      case SCHAR:   base=sochar;   break;
      case SDOUBLE: base=sodouble; break;
      case SFLOAT:  base=sofloat;  break;
      case SVOID:   base=0;        break; /*MEREfuture*/
      default:
      { yyerror("internal error: blank type sent to variablesize()");
fprintf(stderr,"tp.u.tp %d STOP\n",tp.u.tp);
fprintf(stderr,"modpos %d curtp %d\n",tp.modpos,tp.curtp);
    exit(1);
      }
    }
  }
  else if(tp.tp==STRUCT||tp.tp==UNION)
  { base=vds[tp.u.p.l].lvd[tp.u.p.o].size; }
  else if(tp.tp==NOTYPE)
    yyerror("internal error: variablesize() received NOTYPE");
  else badbase=1;

  for(z=tp.modlev-1;z>=(int)tp.modpos;z--)
  { switch(tp.mod[z].mod)
    { case MSTAR:  base=sopoint; badbase=0; break;
      case MFUNC:  base=0;          break;
      case MAR_ELE:
       base*=tp.mod[z].u.arr;
      break;
      default:
       fatal=1; yyerror("internal error: illegal modifier in 2storage");
    }
  }
  if(badbase) yyerror("warning: 1unknown size of struct");
 return base;
}

#ifdef VDDEBUG
printtype(type) struct type type;
{ int y;
  printf("size:%d; tregister:%d; tvolatile:%d; tp:%d; scope:%d;\n"
   ,type.size,type.treg,type.tvolatile
   ,type.tp,type.scope);
  printf("field:%d;\n",type.field);
  for(y=0;y<type.modlev;y++)
  { printf("mod[%d].mod=%d .null %d .u.arr %d \t",y,type.mod[y].mod
      ,type.mod[y].null,type.mod[y].u.arr);
  }
  putchar('\n');
  if(type.tp>NOTYPE) printf("unsp arr \"%s\"",type.u.nm);
  else if(type.tp==UNION||type.tp==STRUCT)
   printf("struct: lev %d  off %d\n",type.u.p.l,type.u.p.o);
  else if(type.tp==0)
  { printf("t.u.tp %d\n",type.u.tp);
  }
}
printvdef(Tvds) struct vds Tvds;
{ int c,x;
/*return; /* limit output */
  printf("##### VARDEFS HERE:\n%d vds\n",vdscnt);
  printf("%d vd; %d lvds; %d tpd; %d soud\n",Tvds.vdcnt,Tvds.lvdcnt
   ,Tvds.tpdcnt,Tvds.soudcnt);
  printf("*vds:\n");
  for (x=0;x<Tvds.vdcnt;x++)
  { printf("---\nTvds.vd[%d]:\"%s\"\n",x,Tvds.vd[x].nm);
    printf("#start prevalue\n");
    printprev(Tvds.vd[x].p);
    printf("#finish prevalue\n");
    printtype(Tvds.vd[x].t);
  }
  printf("*lvd:\n");
  for (c=0;c<Tvds.lvdcnt;c++)
  { printf("---------Tvds.lvd[%d].size=%d\n",c,Tvds.lvd[c].size);
    for (x=0;x<Tvds.lvd[c].cnt;x++)
    { printf("---\nTvds.lvd[%d].pt[%d]:\"%s\"\n",c,x,Tvds.lvd[c].pt[x].nm);
      printf("byteoff:%d;  bitoff:%d;\n"
       ,Tvds.lvd[c].pt[x].byteoff,Tvds.lvd[c].pt[x].bitoff);
      printtype(Tvds.lvd[c].pt[x].t);
    }
  }
  printf("*soud:\n");
  for (x=0;x<Tvds.soudcnt;x++)
  { printf("---\nTvds.soud[%d]:\"%s\"\n",x,Tvds.soud[x].nm);
    printtype(Tvds.soud[x].t);
  }
  printf("*tpd:\n");
  for (x=0;x<Tvds.tpdcnt;x++)
  { printf("---\nTvds.tpd[%d]:\"%s\"\n",x,Tvds.tpd[x].nm);
    printtype(Tvds.tpd[x].t);
  }
  printf("#####END vardefs\n");
}

static printprev(p) struct prevalue p;
{ int c;
  printf("{ length:%d\n",p.cnt);
  for (c=0;c<p.cnt;c++)
  { printf("%d: ",c);
    switch(p.s[c].t)
    { case PRPREV: printprev(p.s[c].u.p); break;
      case PRPOINTER:
       printf("off:%d; len:%d\n",p.s[c].u.ptr.off,p.s[c].u.ptr.len);
       printf("pchar: \"%s\"\n",strcnsts+p.s[c].u.ptr.off);
      break;
      case PRSTRING:
       printf("string: \"%s\" len %d\n",p.s[c].u.s.stf,p.s[c].u.s.len);
      break;
      case PRLONG: printf("long: %ld\n",p.s[c].u.l); break;
      case PRDOUBLE: printf("double: %lf\n",p.s[c].u.d); break;
      case PRCODE: printf("program segment to generate value\n"); break;
      default: printf("unknown:code %d\n",p.s[c].t);
    }
  }
  printf("}\n");
}
#endif /*VDDEBUG*/

typecmp(x,y) struct type x,y;
/* verify 2 types are equal */
{ int z;
  struct vardefs v1,v2;
  if(x.modlev!=y.modlev||x.treg!=y.treg
   ||x.tvolatile!=y.tvolatile||y.tp!=x.tp/*MORE:ex_st*/) return(0);
/*MEREfuture: should scope stuff be tested?*/
  for(z=0;z<x.modlev;z++)
  { if(x.mod[z].mod!=y.mod[z].mod) return(0);
    switch(x.mod[z].mod)
    { case MFUNC:
       if(x.mod[z].u.fn.only&&y.mod[z].u.fn.only
          &&x.mod[z].u.fn.argcnt!=y.mod[z].u.fn.argcnt)
         return 0;
/*MEREfuture: check the types */
      break;
      case MAR_ELE:
       if(x.mod[z].null!=y.mod[z].null
         ||(!x.mod[z].null&&x.mod[z].u.arr==y.mod[z].u.arr))
        return 0;
    }
  }
  switch(x.tp)
  { case STRUCT:
    case UNION:
     if(x.u.p.l==y.u.p.l&&x.u.p.o==y.u.p.o) return(1);
     v1=vds[x.u.p.l].lvd[x.u.p.o];
     v2=vds[y.u.p.l].lvd[y.u.p.o];
     if(v1.cnt!=v2.cnt) return 0;
     for(z=0;z<v1.cnt;z++) if(strcmp(v1.pt[z].nm,v2.pt[z].nm)
       ||!typecmp(v1.pt[z].t,v2.pt[z].t)) return 0;
    return 1;
    case 0:
    return x.u.tp==y.u.tp;
    case NOTYPE:
     yyerror("internal err: var with NOTYPE reached typecmp");
     fatal=1; return(0);
    case 4:
    case 5:
    return(!strcmp(x.u.nm,y.u.nm));
    default:
     fatal=1;
     yyerror("internal error: unrecognised type for union in typecmp");
    return(0);
  }
}

char expand(s,c) char *s; flong *c; /* expand \x excapes to ascii */
{ short d;
  char r;
  switch(*s)
  { case 'n': (*c)++; return '\n';
    case 't': (*c)++; return '\t';
    case 'b': (*c)++; return '\b';
    case 'r': (*c)++; return '\r';
    case 'f': (*c)++; return '\f';
    case '\\': (*c)++; return '\\';
    case '\'': (*c)++; return '\'';
    case '\"': (*c)++; return '\"';
  } /* Otherwise: */
  if((*s)<'0'||(*s)>'7')
   yyerror("illegal char. after \\ in constant. assuming \\0");
  for(r=d=0;s[d]>='0'&&s[d]<='7'&&d<3;d++,(*c)++) r=(r<<3)+s[d]-'0';
  return (char)r;
}

char *filenm,newfile; /* both definitly initialized in main */

yyerror(s) char *s; /* replace standard error routine with my own */
{ fprintf(stderr,"cc: %s: \"%s\" about line %d\n",s,filenm,yylineno);
  if(!strcmp(s,"syntax error")) { fatal=1; exit(-1); }
}

typeinit(x) struct type *x;
{ x->size=
  x->tp=
  x->curtp=
  x->u.tp=
  x->treg=
  x->scope=
  x->tvolatile=
  x->modlev=
  x->modpos=
  x->field=
  x->ptr=0;
}

linetrack(p) struct pseudo *p;
{ static int oldline=0;
  if(newfile)
  { int len;
    len=strlen(filenm)+1;
    RAL(p->d,p->l+1+len,char);
    p->d[p->l++]=OINFILE;
    memcpy(p->d+p->l,filenm,len); p->l+=len;
    newfile=0;
  }
  if(yylineno!=oldline)
  { RAL(p->d,p->l+1+solong,char);
    p->d[p->l++]=OINLINE;
    SLDLONG(p->d+p->l,yylineno); p->l+=solong;
    oldline=yylineno;
  }
}

#ifndef DEBUG /* if not debuging lex */
 main(len,ptr) int len; char *ptr[];
 { int fcnt,anyfat;
   extern FILE *yyin;
/*extern char inchar;
inchar='~';
*/
   alignauto=2; alignstructextern=alignstructintern=1;
   yydebug=0;
   anyfat=0;
   filenm= *ptr; /* temporary for yyerror calls before 1st file processing */
   if(strlen(ptr[1])!=7||len<2) { fatal=1; yyerror("illegal size string"); }
   sochar=ptr[1][0]-'0'; soshort=ptr[1][1]-'0'; soint=ptr[1][2]-'0';
   solong=ptr[1][3]-'0'; sopoint=ptr[1][4]-'0'; sofloat=ptr[1][5]-'0';
   sodouble=ptr[1][6]-'0';
   AL(elimmods,1,char *); elimcnt=0;
   AL(allocprecode.d,1,char);
   AL(vds,1,struct vds);
   AL(labelname,1,char *);
   AL(labelnum,1,int);
   AL(strcnsts,1,char);
   AL(exttbl,1,struct exttbl);
   AL(vldstack,1,struct varloadstack);
   vldscnt=vldAL=1;
   vldstack->tp=VDTVD;
   vldstack->rtn=VDREXTERN;
   vldstack->u.num=0;
   for(fcnt=2;fcnt<len;fcnt++)
   { totssn=fatal=0;
     Scp(&filenm,ptr[fcnt]);
     newfile=1;
if(vldscnt!=1)
{ fatal=1; yyerror("internal error vldscnt"); }
     vdscnt=1;
     nextaddress=strclen=vds->tpdcnt=vds->vdcnt=vds->soudcnt=vds->lvdcnt=0;
     extxcnt=labelcnt=0;
     exttblsz=0;
     /* set up lex to read input from file fcnt */
     yyin=infile=fopen(ptr[fcnt],"r");
     /* write out to file suffix p */
     ptr[fcnt][strlen(ptr[fcnt])-1]='p';
     if(!infile) { yyerror("cannot open input file"); exit(E_FILE); }
     outfile=fopen(ptr[fcnt],"w");
     if(!outfile)
     { fatal=1; yyerror("Can't open output file"); }
     else
     { yyparse();
       for(a=1+2*sizeof(long)+extxcnt
            *sizeof(struct prexref),b=0;b<exttblsz;b++)
         a+=strlen(exttbl[b].nm)+4+4*(exttbl[b].tp==SPOINTER
           ||exttbl[b].tp==SSTRUCT||exttbl[b].tp==SARRAY)
           +exttbl[b].prepres*(sizeof(long)+exttbl[b].presz);
       fwrite(&a,sizeof(long),1,outfile);
       a=OPTEXTERN;
       fwrite(&a,1,1,outfile);
       fwrite(&exttblsz,sizeof(long),1,outfile);
       for(a=0;a<exttblsz;a++)
       { fwrite(exttbl[a].nm,1,strlen(exttbl[a].nm)+1,outfile);
         free(exttbl[a].nm);
         fwrite(&exttbl[a].scope,1,1,outfile);
         fwrite(&exttbl[a].tp,1,1,outfile);
         if(exttbl[a].tp==SPOINTER||exttbl[a].tp==SSTRUCT
            ||exttbl[a].tp==SARRAY)
           fwrite(&exttbl[a].size,sizeof(long),1,outfile);
         fwrite(&exttbl[a].prepres,1,1,outfile);
         if(exttbl[a].prepres)
         { fwrite(&exttbl[a].presz,sizeof(long),1,outfile);
           fwrite(exttbl[a].pre,1,exttbl[a].presz,outfile);
           free(exttbl[a].pre);
         }
       }
       fwrite(&extxcnt,sizeof(long),1,outfile);
       fwrite(extxref,sizeof(struct prexref),extxcnt,outfile);
/*write out tables*/
       fclose(outfile);
     }
     fclose(infile);
     if(fatal) { anyfat=1; yyerror("1 or more fatal errors:can't compile"); }
     freeupvars(vds);
     RAL(vds,1,struct vds);
     RAL(labelname,1,char *);
     RAL(labelnum,1,int);
     RAL(exttbl,1,struct exttbl);
   }
   exit(anyfat);
  return 0; /* keeps lint happy; execution never gets here */
 }
#endif
