%{ preprocessor for C compiler
#include <stdio.h>
struct defn
{ char name[32],*replc;
  long len,offcnt,offpcnt[32],*off[32];
} *defs;
long defcnt;
struct incld
{ FILE *fl;
  char name[32];
  long line;
} nestincld[32];
char nestlev,place;
%}
%%
^#[ ]*include[ ]+<[^>\n]*> { /*set up seperate name and input*/ }
^#[ ]*include[ ]+\"[^>\n]*\" { /*set up seperate name and input*/ }
^#[ ]*define[ ]+Id[ ]+[^\n]* { /* put into table*/ }
^#[ ]*define[ ]+Id\(Id(,Id)*\)[ ]+[^\n]* { /* put into table */ }
^#[ ]*if[ ]+[^\n]+ { /* execute scanner on argument. if false read manually
 until matching #endif or #else or #elif otherwise ignore */ }
^#[ ]*ifdef[ ]+Id { /* if Id in table read till matching #endif */ }
^#[ ]*ifndef[ ]+Id { /* if !Id in table read till matching #endif */ }
^#[ ]*elif[ ]+[^\n]+ { /* else read here automatically means non-else already
 run-just make sure it has a matching if and read untill endif. */ }
^#[ ]*else[ ]+ { /* same as above */ }
^#[ ]*endif[ ]+ { /* make sure matching if is somewhere&ignore */ }
^#[ ]*line[ ]+[^\n]* ;
^#[ ]*ident[ ]+[^\n]* ;
\"([^\"\\]|\\.)*\" { fprintf(nextincld[nextlev].fl,"%s",yytext); }
[a-zA-Z_][a-zA-Z0-9_]* { /*scan through defs*/ }
%%
main(argc,argv) int argc; char *argv[];
{ /*MORE: file I/O*/
  nestlev=place=defcnt=0;
  AL(defs,1,struct defn);
  nestincld->fl=stdin;
  nextincld->line=1;
  yylex();
}
veryfirstpass() /* getchar function - removes comments and concatenates lns*/
{ char ch,x;
  static char notprintdnl=0;
  if(notprintdnl) { notprintdnl--; nestincld[nestlev].line++; return '\n'; }
 startagain:
  ch=getc(nestincld[nestlev].fl);
  if(ch==EOF) ch=backinclude();
  switch(ch)
  { case '/':
     if(place)
     { if(place==2) place=1;
       break;
     }
     x=getc(nestincld[nestlev].fl);
     if(ch==EOF) ch=backinclude();
     if(x=='*')
     { while(1)
       { ch=getc(nestincld[nestlev].fl);
         if(ch==EOF) ch=backinclude();
         if(ch=='*')
         { x=getc(nestincld[nestlev].fl);
           if(ch==EOF) ch=backinclude();
           if(x=='\') break;
           ungetc(x,stdin);
         }
         else if(ch=='\n') notprintdnl++;
       }
       ch=notprintdnl?notprintdnl--,'\n':' ';
     }
     else ungetc(x,stdin);
    break;
    case '\\':
     x=getc(nestincld[nestlev].fl);
     if(ch==EOF) ch=backinclude();
     if(x=='\n')
     { notprintdnl++;
       goto startagain;
     }
     if(place==1) place=2;
     else if(place==2) place=1;
     ungetc(x,stdin);
    break;
    case '\"':
     place=~(place&1);
    break;
    default:
     if(place==2) place=1;
  }
  if(ch=='\n') .line++;
  return ch;
}
backinclude()
{ int ch;
  do
  { if(nestlev==0) return EOF;
    fclose(nestincld[nestlev].fl);
    nestlev--;
    ch=getc(nestincld[nestlev].fl);
  } while(ch==EOF);
  return ch;
}
