/* psas.h - header file for pseudo assembler (and linker) */
char *inpfile;
long scan,inline;
int startncb,nestquest,startcomma;
typedef unsigned short *wordptr;
struct opcode
{ long pos;
  char tp,sp;
} *inp;
long oplen,oppos,inlen;
/* oplen=size of input; oppos=position of pseuod getchar() in input */
/* inlen=opcode instruction locator length */
/* Types for opcode(below) used to optimise input */
#define TSTD       0 /* used by everything not applied to below */
#define TLABEL     1
#define TCMPJMP    2
#define TJMP       3
#define TCASECMP   4
#define TTESTJMP   5
#define TSTATUS    6 /* instr. doesn't add code, is always need & never del*/
#define TINTBINARY 7 /* add,sub,and,etc. have similar capabil. for operands*/
#define TRECOG     8 /* ORECOG only */
#define TSPECIAL1 0x10 /*actually uses sp, not tp, one of comparison's */
#define TSPECIAL2 0x20 /*  destinations is immediate */
struct block
{ char *ops,jmpsz,swtched,unsgn;
  long outoff,len,jmppos;
} *block;
#define JSSMALL 0 /* jmp size (1 byte displacements) */
#define JS1BIG  1 /* jmp size (one uses multiple bytes/other uses 1 byte) */
#define JSABIG  2 /* (both jmps are multiple byte) */
long fsz,blcnt,blen;
char ftp,*bops;
struct labels
{ long block,off; char here;
} *lbtbl;
long lbtbllen;
struct staticxref
{ long blck,off;
} *normstat,*intstat;
char *intstatstf;
struct externxref
{ long blck,off,scoff;
  char ptrfnc;
} *exref;
long nstatcnt,istatcnt,exrcnt,intstatoff;
struct regusage
{ char use,reg;
} reguse[14]; /* ax cx dx bx sp bp si di es ds ss */
struct stack /* rpn stack */
{ char place,sect,lexist,tp,ltp,lplace,maxfltlev,combineflg;
  char gzf,gcsof; /* good zero flag, good carry, sign,& overflow flags*/
  long scoff,boff,lboff,blen,*bpxref,bpxcnt,maxoff,bpoff,size;
  struct staticxref *normstat,*intstat;
  struct externxref *exref;
  long nstatcnt,istatcnt,exrcnt,hblkcnt,lbcnt,loccnt,cval,ncbcnt;
  struct nestcombined
  { long off,nbp;  /* offset in bops of thing */
    char call,hidn; /* call-if because of LDFNCARGS then this is 1 */
       /* hidn if blen applies to a hblock */
  } *ncb;
  char *bops,argreg,llprg,lpprg2;
  struct regusage reguse[14];
  struct locations
  { unsigned short lab;
    char place,argreg,rg2,tp;
  } *loc;
  struct hiddenblock
  { long jmppos,*bpxref,bpxcnt;/*place in inp where jmp found*/
    struct staticxref *normstat,*intstat;
    struct externxref *exref;
    long blen,lbcnt,nstatcnt,istatcnt,exrcnt;
    char *bops,swtched,unsgn,purejmp,plc,argreg,tp,cntnusrch;
    unsigned short jmplab,srchlab;
     /*with cntnusrch, used to track order for combine, 1st with no
      * cntnusrch is the split point*/
    struct labels *lbt;
  } *hblk;  /* Assume no labels before any jmps that would cause hblk used */
  struct labels *lbt;
} rpnstk[64];
/* place:  see #defines below
 * sect scoff: sect/offset from RECOG
 * boff:   this specifies an offset to actual memory location for index strct
 * lexist: if a recent instr. on this was convert for op=
 *          then this signals that sect, scoff, and ltp, lplace, below legal
 * llprg,lpprg2: when lexist, these tell what reg's lastpoint was in
 * bpoff:  when on stack this indicates the offset bp needs to acces it
 * tp,ltp: specifies what this thing's type is
 * size:   size of struct or of object pointed to by pointer
 * blen,bops: output area
 * argreg: which register in reguse has value of this in it
 * reguse: tells what each register is used for
 * ncb,ncbcnt: nexted call tells where last combine=1 was exec so that
 *          when combined, bpoff is kept track of
 */
long bpoff,rpnsln,spstot,spsmaxt,calllev,callstksz[64],spsln,spssz[64];
#define PCSTACK    0  /* on sp stack; bpoff says offset */
#define PCMATH     1  /* inside 80387 */
#define PCMEMORY   2  /* if here sect,scoff, and boff are location */
#define PCLSTPOINT 3  /* if this es:bx is location */
#define PCREG      4  /* in 80386 register */
#define PCCONST    5  /* constant/ either not anywhere or in istat */

#define RPNOTREF 0 /* used in struct for determining what is in a register */
#define RPTRASH  1
#define RP1STPT  2
#define RP2NDPT  3
char *opcode,mathuse;
long getlong();
#define GETCHAR() (oppos>=oplen?EOF:opcode[oppos++])
#define BUFSZ 16
struct memindx
{ char stf[8],sz,xexist,xoff,segexist,seg,pushseg;
  long scoff;
} memtmp,memtmp2,genmemin();
#define XREXSTATIC 1 /* xexist says which type of extern. */
#define XREXTERN   2
#define XRSTACK    3
#define XRCNSTDOUBLE 5 /*internal static*/
/*These assume that rpp is pointed to the correct place:*/
#define R2 (rpp->bops[rpp->blen++])
#define RB2 (*(unsigned short *)(rpp->bops+rpp->blen))
#define RBI2; (rpp->blen+=2)
#define R1 (rpp->bops[rpp->blen++])
#define RB1 (*(unsigned short *)(rpp->bops+rpp->blen))
#define RBI1 (rpp->blen+=2)
#define RN (rpn->bops[rpn->blen++])
#define RBN (*(unsigned short *)(rpn->bops+rpn->blen))
#define RBIN (rpn->blen+=2)
#define RBU(x,y) (*(unsigned short *)((x)+(y)))

#define RGNONE   0 /* for limiting arguments to specific registers */
#define RG2ND    1
#define RGEITHER 2
#define RG1ST    3
struct bld
{ struct memindx m,m2;
  char tp,swtched,dstmem,const,fltsrcmem,mem;
  long cval;
} binaryloadit(),monoploadit();
/* m,m2    - access for 1st and if present 2nd bytes
 * mem     - rg/mem field is 2nd
 * swtched - only useful with floats, 1st argument calculated last?
 * dstmem  - op [mem],reg
 * const   - op a?,const
 * cval    - above
 */
