/* pseudo.h -defines pseudo-code used by C compiler */
#ifndef NOFUNCTIONS
# include "pseudofunc.h"
#endif
/* SUPPORT */
#define SAL      2 /* address length */
#define SOSL     4 /* object size length */

#define SCHAR    2 /* types are same as prevalues*/
#define SSHORT   3
#define SINT     4
#define SLONG    5
#define SFLOAT   6
#define SDOUBLE  7
#define SPOINTER 8 /* if it is this type; followed by object size */
#define SSTRUCT  9 /* followed by object size */
#define SFUNC   10
#define SARRAY  11 /* used only in ext. var. def. (followed by sz) */
/*#define SSTATFUNC 12
MMERE: eliminate SSTATFUNC */
#define SVOID   13

#define SUNSIGNED 0x10

#define SLABELIT(x,y) *(short *)(x)=(short)(y)
/**(x)=(*((char *)(&(y)))),*((x)+1)=((char *)(&(y)))[1]*/
#define SLDINT(x,y) { int k,j; j=(y); for(k=0;k<soint;k++)\
 (x)[k]=(char)(j>>8*k); }
#define SLDLONG(x,y) { long k,j; j=(y); for(k=0;k<solong;k++)\
 (x)[k]=(char)(j>>8*k); }
 /*(x)[k]=((char *)(&(j)))[k]; }*/
#define SLDDOUBLE(x,y) { int k; double j; j=(y); for(k=0;k<sodouble;k++)\
 (x)[k]=((char *)(&(j)))[k]; }
#define SLDCHAR(x,y) *(x)=y
#define SRDCHAR(x,y) (y)=(*(x))
#define SRDLONG(x,y) { long k,j; for(k=j=0;k<solong;k++) j+=((uchar)((x)[k]))\
 <<8*k; (y)=j; }
#define SRDINT(x,y) { long k,j; for(k=j=0;k<soint;k++) j+=((uchar)((x)[k]))\
 <<8*k; (y)=j; }
#define SRDDOUBLE(x,y) { int k; double j; for(k=j=0;k<sodouble;k++)\
 ((char *)(&j))[k]=(x)[k]; (y)=j; }
#define SRDLABEL(z,y) (y=(*(short *)(z)))
 /*{ long t; int x; for(x=t=0;x<SAL;x++) t<<=8,t\
 +=(unsigned char)((z)[SAL-x]); (y)=t; }*/
/* above is NONPORTABLE */

/* OPERATIONS */
#define OEQ     1  /* A:2 addr. jmp to first if true; 2nd if false */
#define ONEQ    2  /* ptrs legal here */
#define OLT     3
#define OGT     4
#define OLE     5
#define OGE     6
#define OTEST   7  /* true if val <> 0 */
#define OCASECMP 8 /* A:value(int) true(label) */

#define OADD      10 /* NO  ptrs. legal here*/
#define OSUB      11
#define OSUBSCRPT 12 /* A:type */

#define OMUL   20 /*NO no ptr.*/
#define ODIV   21
#define OCHS   22

#define OAND   30 /*NO integral types only */
#define OOR    31
#define OXOR   32
#define OMOD   33
#define OLSHFT 34
#define ORSHFT 35

#define OLABEL    40 /* A: address */
#define OCONVERT  41 /* A: type */
#define OJMP      42 /* A: address */
#define OPTRCONVERT 43 /* A: type (use object pointed to by type) */
#define OTOPTR    44 /* NO convert to ptr to type */
#define ORETURN   45 /* NO */
#define OVALRET   46 /* NO return value of expression */
#define OLDFNCARG 47 /* NO */
#define OPOP      48 /* NO (pop expression off stack) */
#define OCALL     49 /* A:tp */
#define OCALL0    50 /* A:tp */
#define OPOINT    51 /* A:off(long) type (for getting structure elements) */
#define OFPOINT   52 /* A:off(long) bitoff field type */
#define OARROW    53 /* A:off(long) type */
#define OFARROW   54 /* A:off(long) bitoff field type */
#define ORECOG    55 /* A:type sect byteoff(long) */
#define OSTCLL    56 /* NO start function OCALL (nestable)*/
#define OASSIGN   57 /* NO = operator; */
#define OLASTASGN 58 /* NO op= operator */
/* #define OFUNCREC  59 /* A:local(char) nm \0 */
#define OSTOPTR   60 /* NO used on POINTER for when array */
#define OPTEXTERN 61 /* defines end of function definitions */
#define OSTARTCOMMA 62 /* NO start comma oper(establish order of things done)*/
#define OENDCOMMA 63 /* NO end comma operator(establish order of things done)*/
#define OSTARTQ   64 /* NO this and follow start and end ?: to aid swtched */
#define OENDQ     65
#define OINLINE   66 /* A:line(long) */
#define OINFILE   67 /* A:"file name"\0 */

#define OLCCHAR   70 /* load constants */
#define OLCSTRING 71 /* A:offset(long) length(long) */
#define OLCINT    72
#define OLCLONG   73
#define OLCDOUBLE 75

#define OVINC  80 /*NO ptrs. or integral */
#define OINCV  81
#define OVDEC  82
#define ODECV  83

#define OFUNC    90 /* A:name (char 0) type (stuff below) - define function */
#define OBLOCK   91 /* A:(ss needed(long)) (auto init) */
#define OENDBLCK 92 /*NO */
#define OSTATFUNC 93 /* just like OFUNC; used to represent static functions */

#define ONOT   100 /*NO integral type only */
/*#define OEXTBLCK 93 /* A: (ext. nm,tp&predef) */
/*table autoinit: size(long) { stkoff(long) len(char) stuff(spcfd by len) }*/
/*table extnmtp: count(long) { name '\0' tp(char poss. long) ispre(char)
 * [poss. (len comes from size len) prestf(spcfd by len) ] } */
