/* operate.c: functions to take care of operators in C compiler */
extern int yylineno;
#include <stdio.h>
#include "head.h"
#include "pseudo.h"
#include "y.tab.h"

questcollonop(eout,e1,e3,e5) struct expr *eout,*e1,*e3,*e5;
{ /* OSTARTQ $1 LB TR $3 JMP NEW LB FS $5 LB NEW OENDQ */
  stringstf(e1); stringstf(e3); stringstf(e5);
  (*e1)=mkcompare((*e1));
  if((*e1).tcnt&&!(*e1).fcnt)
  { (*eout)=(*e3); free((*e1).p.d); free((*e5).p.d); }
  else if((*e1).fcnt&&(!(*e1).tcnt))
  { (*eout)=(*e5); free((*e1).p.d); free((*e3).p.d); }
  else
  { (*eout)=(*e1);
    a=labeltruefalse(&((*e1)));
    (*eout)=(*e1);
    commontype(&((*e3)),&((*e5)));
    if((*e3).t.curtp!=(*e5).t.curtp)
    { if(!(((*e3).t.curtp==SPOINTER&&(*e5).const&&(*e5).c.t==PRLONG
         &&(*e5).c.u.l==0)||((*e5).t.curtp==SPOINTER&&(*e3).const
         &&(*e3).c.t==PRLONG&&(*e3).c.u.l==0)))
      { fatal=1; yyerror("illegal combination of type on ?: operator"); }
      if((*e3).t.curtp==SPOINTER) (*eout).t=(*e3).t;
      if((*e5).t.curtp==SPOINTER) (*eout).t=(*e5).t;
    }
    else
    { if((*e3).t.curtp==SFUNC)
      { fatal=1; yyerror("illegal type for ?: operator"); }
      else if((*e3).t.curtp==SSTRUCT)
      { if(variablesize((*e3).t)!=variablesize((*e5).t))
        { fatal=1; yyerror("structures are diffrent in ?: operator"); }
      }
      else if((*e3).t.curtp==SPOINTER)
       if(objectsize((*e3).t)!=objectsize((*e5).t))
       { fatal=1;
         yyerror("pointers are to diffrently sized objects in ?: ");
       }
      (*eout).t=(*e5).t;
    }
    RAL((*eout).p.d,4*SAL+6+(*eout).p.l+(*e3).p.l+(*e5).p.l,char);
    memmove((*eout).p.d+1,(*eout).p.d,(*eout).p.l);
    *((*eout).p.d)=OSTARTQ; (*eout).p.l++;
    (*eout).p.d[(*eout).p.l++]=OLABEL;
    SLABELIT((*eout).p.d+(*eout).p.l,a); (*eout).p.l+=SAL; /*LB TR*/
    memcpy((*eout).p.d+(*eout).p.l,(*e3).p.d,(*e3).p.l);
    (*eout).p.l+=(*e3).p.l;                                /*(*e3) */
    b=unique(); free((*e3).p.d);
    (*eout).p.d[(*eout).p.l++]=OJMP; SLABELIT((*eout).p.d+(*eout).p.l,b);
    (*eout).p.l+=SAL;                                      /*JMP NEW*/
    a++;
    (*eout).p.d[(*eout).p.l++]=OLABEL; SLABELIT((*eout).p.d+(*eout).p.l,a);
    (*eout).p.l+=SAL;                                      /*LB FS*/
    memcpy((*eout).p.d+(*eout).p.l,(*e5).p.d,(*e5).p.l);
    (*eout).p.l+=(*e5).p.l;                                /*(*e5) */
    (*eout).p.d[(*eout).p.l++]=OLABEL; SLABELIT((*eout).p.d+(*eout).p.l,b);
    (*eout).p.l+=SAL;                                      /*LB NW*/
    (*eout).p.d[(*eout).p.l++]=OENDQ;
    (*eout).lval=0;
  }
}

complexassignop(eout,e1,e2,e3) struct expr *eout,*e1,*e3;
{ struct type ttp;
  int tp;
  stringstf(&((*e1)));
  ttp=(*e1).t;
  tpoftype(&((*e1).t));
  tp=(*e1).t.curtp;
  if(!(*e1).lval)
  { fatal=1; yyerror("LHS of op= is not an lval"); }
  switch(e2)
  { case '+':
    case '-':
    case '/':
    case '*':
     genop(eout,(*e1),(int)e2,(*e3));
    break;
    case '%':
    case '^':
    case '&':
    case '|':
    case LSHFT:
    case RSHFT:
     intop(eout,(*e1),(int)e2,(*e3));
    break;
    default:
     fatal=1; yyerror("internal error: operator on op= isn't recognised");
  }
  tpoftype(&((*eout).t));
  if(tp!=(*eout).t.curtp) stdconvert(eout,tp,ttp);
  RAL((*eout).p.d,(*eout).p.l+1,char);
  (*eout).p.d[(*eout).p.l++]=OLASTASGN;
  (*eout).pconst=(*eout).lval=(*eout).const=0;
  /*exprtype(&(eout));*/
}

computeandor(eout,e1,e3,e1bcnt,e3bcnt,e1bpoint,e3bpoint,e1ecnt,e3ecnt
       ,e1epoint,e3epoint)
   struct expr *eout,*e1,*e3;
   uchar *e1bcnt,*e3bcnt,*e1ecnt,*e3ecnt;
   int **e1bpoint,**e3bpoint,**e1epoint,**e3epoint;
    /* e(#)(scope)(portion)
     * scope=e  - if either is exclusively this, then result is this
     * scop=b   - both must be this for result to be this
     */
{ int un;
  /* $1 LB 1TR $3 # LB 3TR:TR LB 1FS LB 3FS:FS */

  *e1=mkcompare(*e1); *e3=mkcompare(*e3);
  *eout= *e1;
  if((!*e1ecnt&&!*e1bcnt)||(!*e3ecnt&&!*e3bcnt))
  { fatal=1; yyerror("corrupt comparison"); }
  if(!*e1bcnt||!*e3bcnt)
  { RAL(eout->p.d,1+soint,char);
    *(eout->p.d)=OLCINT; eout->p.l=1+soint;
    eout->c.t=PRLONG; eout->c.u.l= &eout->tcnt==e1ecnt;
    eout->const=1; eout->pconst=0;
    SLDINT(eout->p.d+1,eout->c.u.l);
    typeinit(&(eout->t));
    eout->t.curtp=eout->t.u.tp=SINT;
    if(*e1bcnt) free(*e1bpoint);
    if(*e3bcnt) free(*e3bpoint);
    if(*e1ecnt) free(*e1epoint);
    if(*e3ecnt) free(*e3epoint);
    *e1ecnt= *e1bcnt=0;
  }
  else if(!*e1ecnt&&!*e3ecnt)
  { RAL(eout->p.d,1+soint,char);
    eout->c.t=PRLONG; eout->c.u.l= &eout->tcnt!=e1ecnt;
    eout->const=1; eout->pconst=0;
    SLDINT(eout->p.d+1,eout->c.u.l); eout->p.l=1+soint;
    typeinit(&(eout->t));
    eout->t.curtp=eout->t.u.tp=SINT;
    if(*e1bcnt) free(*e1bpoint);
    if(*e3bcnt) free(*e3bpoint);
    if(*e3ecnt) free(*e3epoint); /* note: by if above, we know e1ecnt==0 */
    *e1ecnt= *e1bcnt=0;
  }
  else
  { un=unique();
    for(b=0;b<*e1bcnt;b++) SLABELIT(eout->p.d+(*e1bpoint)[b],un);
    if(*e1bcnt) free(*e1bpoint);
    *e1bcnt= *e3bcnt; *e1bpoint= *e3bpoint;
    a=1+SAL+eout->p.l;
    for(b=0;b<*e1bcnt;b++) (*e1bpoint)[b]+=a;
    if(*e3ecnt)
    { if(*e1ecnt) { RAL(*e1epoint,*e3ecnt+*e1ecnt,flong); }
      else AL(*e1epoint,*e3ecnt,flong);
      for(b=0;b<*e3ecnt;b++) (*e1epoint)[(*e1ecnt)++]=a+(*e3epoint)[b];
      free(*e3epoint);
    }
    RAL(eout->p.d,1+SAL+eout->p.l+e3->p.l,char);
    eout->p.d[eout->p.l++]=OLABEL; SLABELIT(eout->p.d+eout->p.l,un);
    eout->p.l+=SAL;                                                   /*L 1T*/
    memcpy(eout->p.d+eout->p.l,e3->p.d,e3->p.l); eout->p.l+=e3->p.l;   /*e3*/
  }
  free(e3->p.d);
}

assignop(dest,e1,e2) struct expr *dest,*e1,*e2;
{ *e1 =mkvalue(*e1); *e2 =mkvalue(*e2);
  tpoftype(&(e1->t)); tpoftype(&(e2->t));
  if(!e1->lval) { fatal=1; yyerror("LHS not an lvalue"); }
  switch(e1->t.curtp%SUNSIGNED)
  { case SCHAR:
    case SSHORT:
    case SINT:
    case SLONG:
    case SFLOAT:
    case SDOUBLE:
     if(e1->t.curtp%SUNSIGNED!=e2->t.curtp%SUNSIGNED)
        stdconvert(e2,(int)e1->t.curtp,e1->t);
    break;
    case SPOINTER:
     if(e2->t.modpos<e2->t.modlev&&e2->t.mod[e2->t.modpos].mod==MFUNC)
     { e2->t.ptr=1;
       e2->const=e2->lval=0;
       RAL(e2->p.d,e2->p.l+1,char);
       e2->p.d[e2->p.l++]=OTOPTR; e2->t.curtp=SPOINTER;
     }
     if(e2->t.curtp!=SINT&&(e2->t.curtp!=e1->t.curtp
        ||objectsize(e1->t)!=objectsize(e2->t)))
     { yyerror("warning: pointer assignment of diffrently sized objects");
fprintf(stderr,"$1.curtp %d $3 %d\n",e1->t.curtp,e2->t.curtp);
}
     if(e1->t.mod[e1->t.modpos].mod!=MSTAR)
     { fatal=1; yyerror("illegal assigment to an array!"); }
    break;
    case SSTRUCT:
     if(e1->t.curtp!=e2->t.curtp)
     { fatal=1; yyerror("incompatable types");
fprintf(stderr,"e1 %d e2 %d\n",e1->t.curtp,e2->t.curtp); }
     if(variablesize(e1->t)!=variablesize(e2->t))
     { fatal=1; yyerror("illegal assignment: structs with diffrent sizes"); }
    break;
    case SFUNC:
     fatal=1; yyerror("illegal lhs: function");
  }
  *dest = *e1;
  RAL(dest->p.d,dest->p.l+e2->p.l+1,char);
  memcpy(dest->p.d+dest->p.l,e2->p.d,e2->p.l); dest->p.l+=e2->p.l;
  free(e2->p.d);
  dest->p.d[dest->p.l++]=OASSIGN;
  dest->pconst=dest->lval=dest->const=0;
}

loadconst(exp) struct expr *exp;
/* chop off/extend constant to match proper # of bytes;
 *  then put code to load it. */
{ int et1,usize;
  et1=exp->t.curtp;
  if(!exp->const)
  { fatal=1; yyerror("1internal error loadconst"); }
  switch(et1%SUNSIGNED)
  { case SCHAR:  usize=sochar;  goto inthandle;
    case SSHORT: usize=soshort; goto inthandle;
    case SINT:   usize=soint;   goto inthandle;
    case SLONG:  usize=solong;  goto inthandle;
    inthandle:
     if(exp->c.t!=PRLONG)
     { fatal=1; yyerror("1unknown constant type"); }
     switch(usize)
     { case 1:
        if(et1>SUNSIGNED) exp->c.u.l=(unsigned char)exp->c.u.l;
        else exp->c.u.l=(char)exp->c.u.l;
       break;
       case 2:
        if(et1>SUNSIGNED) exp->c.u.l=(unsigned short)exp->c.u.l;
        else exp->c.u.l=(short)exp->c.u.l;
       case 4: /*nothing*/
       break;
       default: fatal=1; yyerror("bad integral size");
     }
     switch(et1%SUNSIGNED)
     { case SCHAR:
       case SSHORT:
       case SINT:
        RAL(exp->p.d,3+soint,char);
        *exp->p.d=OLCINT; exp->p.l=1;
        SLDINT(exp->p.d+1,exp->c.u.l); exp->p.l+=soint;
        if(et1!=SINT)
        { exp->p.d[exp->p.l++]=OCONVERT;
          exp->p.d[exp->p.l++]=et1;
        }
       break;
       case SLONG:
        RAL(exp->p.d,3+solong,char);
        *exp->p.d=OLCLONG; exp->p.l=1;
        SLDLONG(exp->p.d+1,exp->c.u.l); exp->p.l+=solong;
        if(et1!=SLONG)
        { exp->p.d[exp->p.l++]=OCONVERT;
          exp->p.d[exp->p.l++]=et1;
        }
       break;
       default: fatal=1; yyerror("internal error loadconst3");
     }
    break;
    case SDOUBLE:
    case SFLOAT:
     if(exp->c.t!=PRDOUBLE)
     { fatal=1; yyerror("2unknown constant type"); }
     RAL(exp->p.d,3+sodouble,char);
     *exp->p.d=OLCDOUBLE; exp->p.l=1;
     SLDDOUBLE(exp->p.d+1,exp->c.u.d); exp->p.l+=sodouble;
     if(et1!=SDOUBLE)
     { exp->p.d[exp->p.l++]=OCONVERT;
       exp->p.d[exp->p.l++]=et1;
     }
    break;
    default:
     fatal=1; yyerror("internal error loadconst2");
fprintf(stderr,"et1 %d\n",et1);
  }
}

monop(out,op) struct expr *out; int op;
/* monop() - (~ PP MM -) ;op is recorded as pseudo neccessary*/
{ int e1t,waslval;
  waslval=out->lval;
  autoconvert(out);
  e1t=out->t.curtp;
  if(e1t==SFUNC||e1t==SSTRUCT)
  { fatal=1; yyerror("illegal type of operand on unary operator"); }
  if(out->const)
  { switch(op)
    { case ONOT:
       if(out->c.t!=PRLONG)
       { fatal=1; yyerror("illegal type for ~"); }
       out->c.u.l=(~out->c.u.l);
      break;
      case OCHS:
       switch(out->c.t)
       { case PRLONG:
          out->c.u.l=(-out->c.u.l);
         break;
         case PRDOUBLE:
          out->c.u.d=(-out->c.u.d);
         break;
         default:
          fatal=1; yyerror("illegal type of operand");
       }
      break;
      case OVINC:
      case OINCV:
      case OVDEC:
      case ODECV:
       fatal=1;
       if(out->lval) yyerror("internal error: constant lval in monop");
       else yyerror("illegal operand: -- a constant");
      break;
      default:
       fatal=1; yyerror("internal error: unknown pseudocode in monop");
    }
    loadconst(out);
  }
  else
  { switch(op)
    { case ONOT:
      case OCHS:
       out->pconst=0;
       if(e1t==SPOINTER)
       { fatal=1; yyerror("illegal pointer on unary operator"); }
      break;
      default:
       fatal=1; yyerror("internal error: unknown pseudocode in monop");
      break;
      case OVINC:
      case OINCV:
      case OVDEC:
      case ODECV:
       if(!waslval)
       { fatal=1; yyerror("operand of unary ++ or -- is not an lval"); }
    }
    RAL(out->p.d,out->p.l+1,char);
    out->p.d[out->p.l++]=op;
  }
  out->pconst=out->lval=0;
}

genop(out,e1,op,e2) struct expr *out,e1,e2; int op;
/* genop() - (* / + -) all number; (+ -) can have pointer & int */
{ int x,e1t,e2t;
  commontype(&e1,&e2);
  if(e1.t.curtp==STRUCT||e1.t.curtp==SFUNC||e2.t.curtp==SSTRUCT
    ||e2.t.curtp==SFUNC)
  { fatal=1;
    sprintf(temp,"illegal type of operand for binary %c operator",op);
  }
  *out=e1;
  e1t=e1.t.curtp%SUNSIGNED;
  e2t=e2.t.curtp%SUNSIGNED;
  if(e1.const&&e2.const)
  { if(e1t!=e2t)
    { fatal=1; yyerror("non-equal types"); }
    switch(op)
    { case '+':
       switch(e1.c.t)
       { case PRLONG:
          if(e1.t.curtp>=SUNSIGNED) out->c.u.l+=(unsigned long)e2.c.u.l;
          else out->c.u.l+=e2.c.u.l;
         break;
         case PRDOUBLE:
          out->c.u.d+=e2.c.u.d;
         break;
         default:
          sprintf(temp,"internal error: unknown exp tp(%d) in genop",e1t);
          fatal=1; yyerror(temp);
       }
      break;
      case '-':
       switch(e1.c.t)
       { case PRLONG:
          if(e1.t.curtp>=SUNSIGNED) out->c.u.l-=(unsigned long)e2.c.u.l;
          else out->c.u.l-=e2.c.u.l;
         break;
         case PRDOUBLE:
          out->c.u.d-=e2.c.u.d;
         break;
         default:
          sprintf(temp,"internal error: unknown exp tp(%d) in genop",e1t);
          fatal=1; yyerror(temp);
       }
      break;
      case '*':
       switch(e1.c.t)
       { case PRLONG:
          if(e1.t.curtp>=SUNSIGNED) out->c.u.l*=(unsigned long)e2.c.u.l;
          else out->c.u.l*=e2.c.u.l;
         break;
         case PRDOUBLE:
          out->c.u.d*=e2.c.u.d;
         break;
         default:
          sprintf(temp,"internal error: unknown exp tp(%d) in genop",e1t);
          fatal=1; yyerror(temp);
       }
      break;
      case '/': /* copy above,substitute / for * */
       switch(e1.c.t)
       { case PRLONG:
          if(e1.t.curtp>=SUNSIGNED) out->c.u.l/=(unsigned long)e2.c.u.l;
          else out->c.u.l/=e2.c.u.l;
         break;
         case PRDOUBLE:
          out->c.u.d/=e2.c.u.d;
         break;
         default:
          sprintf(temp,"internal error: unknown exp tp(%d) in genop",e1t);
          fatal=1; yyerror(temp);
       }
      break;
      default:
       fatal=1; sprintf(temp,"internal error: unknown operator %c",op);
    }
    out->pconst=0;
    loadconst(out);
  }
  else /* not a constant */
  { out->const=0;
    RAL(out->p.d,out->p.l+e2.p.l+1,char);
    memcpy(out->p.d+out->p.l,e2.p.d,e2.p.l); out->p.l+=e2.p.l;
    switch(op)
    { case '+':
       if(e2.t.curtp==SPOINTER)
       { x=e1t; e1t=e2t; e2t=x; out->t=e2.t; }
       if((e1t!=e2t&&!(e1t==SPOINTER&&(e2t==SINT||e2t==SLONG))))
       { fatal=1; yyerror("illegal type(s) for + operator"); }
       if(e1.pconst==1&&e2.const&&e2.c.t==PRLONG)
       { out->c=e1.c;
         if(out->c.t==PRPOINTER)
           out->c.u.ptr.boff+=objectsize(e1.t)*e2.c.u.l;
         else
         { fatal=1; yyerror("weird constant in genop"); }
       }
       else out->pconst=0;
       out->p.d[out->p.l++]=OADD;
      break;
      case '-':
       if((e1t!=e2t||objectsize(out->t)!=objectsize(e2.t))
         &&!(e1t==SPOINTER&&(e2t==SINT||e2t==SLONG)))
       { fatal=1; yyerror("illegal type for bin. - operator"); }
       if(e1.pconst==1&&e2.const&&e2.c.t==PRLONG)
       { out->c=e1.c;
         if(out->c.t==PRPOINTER)
           out->c.u.ptr.boff-=objectsize(e1.t)*e2.c.u.l;
         else
         { fatal=1; yyerror("weird constant in genop"); }
       }
       else out->pconst=0;
       out->p.d[out->p.l++]=OSUB;
       if(e2t==SPOINTER)
       { typeinit(&(out->t)); out->t.curtp=out->t.u.tp=SINT; }
      break;
      case '*':
       out->pconst=0;
       if(e1t!=e2t||e1t==SPOINTER)
       { fatal=1; yyerror("illegal type for * operator"); }
       out->p.d[out->p.l++]=OMUL;
      break;
      case '/':
       out->pconst=0;
       if(e1t!=e2t||e1t==SPOINTER)
       { fatal=1; yyerror("illegal type for / operator"); }
       out->p.d[out->p.l++]=ODIV;
      break;
      default:
       fatal=1; sprintf(temp,"internal error: unknown operator %c",op);
       yyerror(temp); break;
    }
  }
  free(e2.p.d);
  out->lval=0;
}

cmpop(out,e1,op,e2) struct expr *out,e1,e2; int op;
/* cmpop() - (LE GE < > NE EQ) all number; 2 pointers */
{ int e1t,e2t;
  commontype(&e1,&e2);
  e1t=e1.t.curtp; e2t=e2.t.curtp;
  if(!(e1t==e2t||(e1t==SPOINTER&&(e2t%SUNSIGNED==SINT
    ||e2t%SUNSIGNED==SLONG)&&e2.const)||(e2t==SPOINTER
    &&(e1t%SUNSIGNED==SINT||e1t%SUNSIGNED==SLONG)&&e1.const))
    ||e1t==SSTRUCT||e1t==SFUNC)
  { fatal=1; yyerror("illegal type for comparison operator"); }
  *out=e1;
  if(e1.const&&e2.const)
  { if(e1t!=e2t||e1t==SPOINTER)
    { fatal=1; yyerror("internal error cmpop"); }
    switch(op)
    { case '>':
       if(e1t>=SUNSIGNED)
       { if(e1.c.t!=PRLONG)
         { fatal=1; yyerror("3unknown constant type"); }
         out->c.u.l=e1.c.u.l>(unsigned long)e2.c.u.l;
       }
       else
       { if(e1.c.t!=PRLONG&&e1.c.t!=PRDOUBLE)
         { fatal=1; yyerror("4unknown constant type"); }
         out->c.u.l=(e1.c.t==PRLONG?e1.c.u.l:e1.c.u.d)
            >(e2.c.t==PRLONG?e2.c.u.l:e2.c.u.d);
       }
      break;
      case '<':
       if(e1t>=SUNSIGNED)
       { if(e1.c.t!=PRLONG)
         { fatal=1; yyerror("5unknown constant type"); }
         out->c.u.l=e1.c.u.l<(unsigned long)e2.c.u.l;
       }
       else
       { if(e1.c.t!=PRLONG&&e1.c.t!=PRDOUBLE)
         { fatal=1; yyerror("6unknown constant type"); }
         out->c.u.l=(e1.c.t==PRLONG?e1.c.u.l:e1.c.u.d)
            <(e2.c.t==PRLONG?e2.c.u.l:e2.c.u.d);
       }
      break;
      case LE:
       if(e1t>=SUNSIGNED)
       { if(e1.c.t!=PRLONG)
         { fatal=1; yyerror("7unknown constant type"); }
         out->c.u.l=e1.c.u.l<=(unsigned long)e2.c.u.l;
       }
       else
       { if(e1.c.t!=PRLONG&&e1.c.t!=PRDOUBLE)
         { fatal=1; yyerror("8unknown constant type"); }
         out->c.u.l=(e1.c.t==PRLONG?e1.c.u.l:e1.c.u.d)
            <=(e2.c.t==PRLONG?e2.c.u.l:e2.c.u.d);
       }
      break;
      case GE:
       if(e1t>=SUNSIGNED)
       { if(e1.c.t!=PRLONG)
         { fatal=1; yyerror("9unknown constant type"); }
         out->c.u.l=e1.c.u.l>=(unsigned long)e2.c.u.l;
       }
       else
       { if(e1.c.t!=PRLONG&&e1.c.t!=PRDOUBLE)
         { fatal=1; yyerror("10unknown constant type"); }
         out->c.u.l=(e1.c.t==PRLONG?e1.c.u.l:e1.c.u.d)
            >=(e2.c.t==PRLONG?e2.c.u.l:e2.c.u.d);
       }
      break;
      case NE:
       if(e1.c.t!=PRLONG&&e1.c.t!=PRDOUBLE)
       { fatal=1; yyerror("11unknown constant type"); }
       out->c.u.l=(e1.c.t==PRLONG?e1.c.u.l:e1.c.u.d)
          !=(e2.c.t==PRLONG?e2.c.u.l:e2.c.u.d);
      break;
      case EQ:
       if(e1.c.t!=PRLONG&&e1.c.t!=PRDOUBLE)
       { fatal=1; yyerror("12unknown constant type"); }
       out->c.u.l=(e1.c.t==PRLONG?e1.c.u.l:e1.c.u.d)
          ==(e2.c.t==PRLONG?e2.c.u.l:e2.c.u.d);
      break;
      default:
       sprintf(temp,"internal error: unknown operator %d in cmpop",op);
       yyerror(temp);
    }
    typeinit(&(out->t)); out->t.u.tp=out->t.curtp=SINT;
    out->c.t=PRLONG;
    RAL(out->p.d,1+soint,char);
    *(out->p.d)=OLCINT;
    SLDINT(out->p.d+1,out->c.u.l); out->p.l=1+soint;
    out->tcnt=out->fcnt=0;
  }
  else
  { RAL(out->p.d,out->p.l+e2.p.l+1+2*SAL,char);
    memcpy(out->p.d+out->p.l,e2.p.d,e2.p.l); out->p.l+=e2.p.l;
    switch(op)
    { case '<':
       out->p.d[out->p.l++]=OLT;
      break;
      case '>':
       out->p.d[out->p.l++]=OGT;
      break;
      case GE:
       out->p.d[out->p.l++]=OGE;
      break;
      case LE:
       out->p.d[out->p.l++]=OLE;
      break;
      case NE:
       out->p.d[out->p.l++]=ONEQ;
      break;
      case EQ:
       out->p.d[out->p.l++]=OEQ;
      break;
      default:
       sprintf(temp,"internal error: unknown operator %d in cmpop",op);
       yyerror(temp);
    }
    typeinit(&(out->t)); out->t.u.tp=out->t.curtp=SINT;
    AL(out->tpoint,1,flong); *out->tpoint=out->p.l; out->p.l+=SAL;
    AL(out->fpoint,1,flong); *out->fpoint=out->p.l; out->p.l+=SAL;
    out->const=0; out->tcnt=out->fcnt=1;
  }
  free(e2.p.d);
  out->pconst=out->lval=0;
}

intop(out,e1,op,e2) struct expr *out,e1,e2; int op;
/* intop() - (% & ^ | LSHFT RSHFT) integers only */
{ int e1t;
  if(op==LSHFT||op==RSHFT)
  { struct type t;
    autoconvert(&e1);
    if(e1.t.curtp!=SINT)
      stdconvert(&e2,SINT,t);
    e1t=e1.t.curtp%SUNSIGNED;
  }
  else
  { commontype(&e1,&e2);
    e1t=e1.t.curtp%SUNSIGNED;
    if(e1.t.curtp!=e2.t.curtp||(e1t!=SINT&&e1t!=SLONG))
    { fatal=1; sprintf(temp,"non integer constant on integer operator");
      yyerror(temp); }
  }
  *out=e1;
  if(out->const&&e2.const)
  { if(out->c.t!=PRLONG||e2.c.t!=PRLONG)
    { fatal=1; yyerror("13unknown constant type"); }
    switch(op)
    { case '%':
       if(out->t.curtp>=SUNSIGNED)
         out->c.u.l%=(unsigned long)e2.c.u.l;
       else out->c.u.l%=e2.c.u.l;
      break;
      case '&':
       if(out->t.curtp>=SUNSIGNED)
         out->c.u.l&=(unsigned long)e2.c.u.l;
       else out->c.u.l&=e2.c.u.l;
      break;
      case '^':
       if(out->t.curtp>=SUNSIGNED)
         out->c.u.l^=(unsigned long)e2.c.u.l;
       else out->c.u.l^=e2.c.u.l;
      break;
      case '|':
       if(out->t.curtp>=SUNSIGNED)
         out->c.u.l|=(unsigned long)e2.c.u.l;
       else out->c.u.l|=e2.c.u.l;
      break;
      case LSHFT:
       if(out->t.curtp>=SUNSIGNED)
         out->c.u.l<<=(unsigned long)e2.c.u.l;
       else out->c.u.l<<=e2.c.u.l;
      break;
      case RSHFT:
       if(out->t.curtp>=SUNSIGNED)
         out->c.u.l>>=(unsigned long)e2.c.u.l;
       else out->c.u.l>>=e2.c.u.l;
      break;
      default:
       fatal=1; yyerror("1internal error: unknown operater in intop");
    }
    loadconst(out);
  }
  else
  { RAL(out->p.d,out->p.l+e2.p.l+1,char);
    memcpy(out->p.d+out->p.l,e2.p.d,e2.p.l); out->p.l+=e2.p.l;
    switch(op)
    { case '%':
       out->p.d[out->p.l++]=OMOD;
      break;
      case '&':
       out->p.d[out->p.l++]=OAND;
      break;
      case '^':
       out->p.d[out->p.l++]=OXOR;
      break;
      case '|':
       out->p.d[out->p.l++]=OOR;
      break;
      case LSHFT:
       out->p.d[out->p.l++]=OLSHFT;
      break;
      case RSHFT:
       out->p.d[out->p.l++]=ORSHFT;
      break;
      default:
       fatal=1; yyerror("2internal error: unknown operater in intop");
      break;
    }
    out->const=0;
  }
  free(e2.p.d);
  out->pconst=out->lval=0;
}

autoconvert(exp) struct expr *exp;
/* autoconvert() - convert to int, long or double if appropriate */
{ *exp=mkvalue(*exp);
  tpoftype(&exp->t);
  switch(exp->t.curtp%SUNSIGNED)
  { case SCHAR:
    case SSHORT:
     if(exp->t.curtp>=SUNSIGNED)
       exp->t.curtp=exp->t.u.tp=SINT+SUNSIGNED;
     else exp->t.curtp=exp->t.u.tp=SINT;
     if(exp->const) /* NOTE: conversion automatically done earlier */
     { if(exp->c.t!=PRLONG)
       { fatal=1; yyerror("illegal type in autoconvert"); }
     }
     RAL(exp->p.d,exp->p.l+2,char);
     exp->p.d[exp->p.l++]=OCONVERT;
     exp->p.d[exp->p.l++]=exp->t.curtp;
     exp->lval=0;
    break;
    case SFLOAT:
     if(exp->t.curtp>=SUNSIGNED)
     { fatal=1; yyerror("internal error: unsigned float in autoconvert()"); }
     typeinit(&(exp->t)); exp->t.curtp=exp->t.u.tp=SDOUBLE;
     RAL(exp->p.d,exp->p.l+2,char);
     exp->p.d[exp->p.l++]=OCONVERT;
     exp->p.d[exp->p.l++]=SDOUBLE;
     if(exp->const&&exp->c.t!=PRDOUBLE)
     { fatal=1;
       yyerror("internal error: type is double but constant tp is not");
     }
     exp->lval=0;
    break;
    case SINT:
    case SLONG:
    break;
    case SDOUBLE:
    case SPOINTER:
    case SSTRUCT:
     if(exp->t.curtp>=SUNSIGNED)
     { fatal=1; yyerror("internal error: unsigned nonint in autoconvert()"); }
    return;
    case SFUNC:
     if(exp->t.modpos<exp->t.modlev&&exp->t.mod[exp->t.modpos].mod==MFUNC)
     { exp->t.ptr=1;
       exp->const=exp->lval=0;
       RAL(exp->p.d,exp->p.l+1,char);
       exp->p.d[exp->p.l++]=OTOPTR; exp->t.curtp=SPOINTER;
     }
    return;
    default:
     fatal=1; yyerror("internal error: unknown tp in autoconvert()");
  }
  /* note: any conversion should convert constants too */
}

commontype(e1,e2) struct expr *e1,*e2;
/* commontype() - convert objects to same int, long or double if possible */
{ int x;
  autoconvert(e1); autoconvert(e2);
  if(e1->t.curtp==SSTRUCT||e1->t.curtp==SFUNC||e2->t.curtp==SSTRUCT
    ||e2->t.curtp==SFUNC)
  { fatal=1; yyerror("illegal type for binary operator"); }
  if(e1->t.curtp==SPOINTER||e2->t.curtp==SPOINTER)
    return;
  if(e1->t.curtp==e2->t.curtp) return;
  if(e1->t.curtp==SDOUBLE)
  { if(e2->const)
    { if(e2->c.t!=PRLONG)
      { fatal=1; yyerror("14unknown constant type"); }
      if(e1->t.curtp>=SUNSIGNED)
        e2->c.u.d=(unsigned long)e2->c.u.l;
      else e2->c.u.d=e2->c.u.l;
      e2->c.t=PRDOUBLE;
      RAL(e2->p.d,1+sodouble,char);
      *(e2->p.d)=OLCDOUBLE; e2->p.l=1;
      SLDDOUBLE(e2->p.d+1,e2->c.u.d); e2->p.l+=sodouble;
    }
    else
    { RAL(e2->p.d,e2->p.l+2,char);
      e2->p.d[e2->p.l++]=OCONVERT;
      e2->p.d[e2->p.l++]=SDOUBLE;
    }
    typeinit(&(e2->t)); e2->t.curtp=e2->t.u.tp=SDOUBLE;
    e2->lval=0;
   return;
  }
  if(e2->t.curtp==SDOUBLE)
  { if(e1->const)
    { if(e1->c.t!=PRLONG)
      { fatal=1; yyerror("15unknown constant type"); }
      if(e2->t.curtp>=SUNSIGNED)
        e1->c.u.d=(unsigned long)e1->c.u.l;
      else e1->c.u.d=e1->c.u.l;
      e1->c.t=PRDOUBLE;
      RAL(e1->p.d,1+sodouble,char);
      *(e1->p.d)=OLCDOUBLE; e1->p.l=1;
      SLDDOUBLE(e1->p.d+1,e1->c.u.d); e1->p.l+=sodouble;
    }
    else
    { RAL(e1->p.d,e1->p.l+2,char);
      e1->p.d[e1->p.l++]=OCONVERT;
      e1->p.d[e1->p.l++]=SDOUBLE;
    }
    typeinit(&(e1->t)); e1->t.curtp=e1->t.u.tp=SDOUBLE;
    e1->lval=0;
   return;
  }
  x=e1->t.curtp>=SUNSIGNED||e2->t.curtp>=SUNSIGNED;
  if(e1->t.curtp%SUNSIGNED==SLONG||e2->t.curtp%SUNSIGNED==SLONG)
  { if(x!=(e2->t.curtp==SLONG+SUNSIGNED)||e2->t.curtp%SUNSIGNED!=SLONG)
    { if(e2->const)
      { if(e2->c.t!=PRLONG)
        { fatal=1; yyerror("unknown type of constant"); }
        RAL(e2->p.d,3+solong,char);
        *(e2->p.d)=OLCLONG; e2->p.l=1;
        SLDLONG(e2->p.d+e2->p.l,e2->c.u.l); e2->p.l+=solong;
        if(x)
        { e2->p.d[e2->p.l++]=OCONVERT;
          e2->p.d[e2->p.l++]=SLONG+SUNSIGNED;
        }
      }
      else
      { RAL(e2->p.d,e2->p.l+2,char);
        e2->p.d[e2->p.l++]=OCONVERT;
        e2->p.d[e2->p.l++]=SLONG+x*SUNSIGNED;
      }
    }
    if(x!=(e1->t.curtp==SLONG+SUNSIGNED)||e1->t.curtp%SUNSIGNED!=SLONG)
    { if(e1->const)
      { if(e1->c.t!=PRLONG)
        { fatal=1; yyerror("unknown type of constant"); }
        RAL(e1->p.d,3+solong,char);
        *(e1->p.d)=OLCLONG; e1->p.l=1;
        SLDLONG(e1->p.d+e1->p.l,e1->c.u.l); e1->p.l+=solong;
        if(x)
        { e1->p.d[e1->p.l++]=OCONVERT;
          e1->p.d[e1->p.l++]=SLONG+SUNSIGNED;
        }
      }
      else
      { RAL(e1->p.d,e1->p.l+2,char);
        e1->p.d[e1->p.l++]=OCONVERT;
        e1->p.d[e1->p.l++]=SLONG+x*SUNSIGNED;
      }
    }
    typeinit(&(e1->t)); typeinit(&(e2->t));
    if(x)
      e1->t.curtp=e2->t.curtp=e1->t.u.tp=e2->t.u.tp=SLONG+SUNSIGNED;
    else e1->t.curtp=e2->t.curtp=e1->t.u.tp=e2->t.u.tp=SLONG;
    e2->lval=0;
   return;
  }
  if(x)
  { if(e2->t.curtp%SUNSIGNED!=SINT||e1->t.curtp%SUNSIGNED!=SINT)
    { fatal=1; yyerror("internal error autoconvert"); }
    if(x!=(e2->t.curtp==SINT+SUNSIGNED))
    { if(e2->const)
      { if(e2->c.t!=PRLONG)
        { fatal=1; yyerror("unknown type of constant"); }
        RAL(e2->p.d,3+soint,char);
        *(e2->p.d)=OLCINT; e2->p.l=1;
        SLDINT(e2->p.d+e2->p.l,e2->c.u.l); e2->p.l+=solong;
        if(x)
        { e2->p.d[e2->p.l++]=OCONVERT;
          e2->p.d[e2->p.l++]=SINT+SUNSIGNED;
        }
      }
      else
      { RAL(e2->p.d,e2->p.l+2,char);
        e2->p.d[e2->p.l++]=OCONVERT;
        e2->p.d[e2->p.l++]=SINT+x*SUNSIGNED;
      }
    }
    if(x!=(e1->t.curtp==SINT+SUNSIGNED))
    { if(e1->const)
      { if(e1->c.t!=PRLONG)
        { fatal=1; yyerror("unknown type of constant"); }
        RAL(e1->p.d,3+soint,char);
        *(e1->p.d)=OLCINT; e1->p.l=1;
        SLDINT(e1->p.d+e1->p.l,e1->c.u.l); e1->p.l+=solong;
        if(x)
        { e1->p.d[e1->p.l++]=OCONVERT;
          e1->p.d[e1->p.l++]=SINT+SUNSIGNED;
        }
      }
      else
      { RAL(e1->p.d,e1->p.l+2,char);
        e1->p.d[e1->p.l++]=OCONVERT;
        e1->p.d[e1->p.l++]=SINT+x*SUNSIGNED;
      }
    }
    typeinit(&(e1->t)); typeinit(&(e2->t));
    if(x)
      e1->t.curtp=e2->t.curtp=e1->t.u.tp=e2->t.u.tp=SINT+SUNSIGNED;
    else e1->t.curtp=e2->t.curtp=e1->t.u.tp=e2->t.u.tp=SINT;
    e2->lval=0;
   return;
  }
  /* if execution gets here, they are integers or both something */
}

stdconvert(exp,t,stp) struct expr *exp; int t; struct type stp;
/* stp is used only if t is SPOINTER SFUNC or SSTRUCT */
{ int e1t,usize;
  tpoftype(&exp->t); e1t=exp->t.curtp%SUNSIGNED;
  if(exp->const)
  { switch(t%SUNSIGNED)
    { case SCHAR:  usize=sochar;  goto cintconv;
      case SSHORT: usize=soshort; goto cintconv;
      case SINT:   usize=soint;   goto cintconv;
      case SLONG:  usize=solong;  goto cintconv;
      cintconv:
       if(t==exp->t.tp) goto nochange;
       switch(exp->c.t)
       { case PRDOUBLE:
          if(t>SUNSIGNED)
            exp->c.u.l=(unsigned long)exp->c.u.d;
          else exp->c.u.l=exp->c.u.d;
          exp->c.t=PRLONG;
         case PRLONG:
          switch(usize)
          { case 1:
             if(t>SUNSIGNED) exp->c.u.l=(unsigned char)exp->c.u.l;
             else exp->c.u.l=(char)exp->c.u.l;
            break;
            case 2:
             if(t>SUNSIGNED) exp->c.u.l=(unsigned short)exp->c.u.l;
             else exp->c.u.l=(short)exp->c.u.l;
            case 4: /*nothing*/
            break;
            default: fatal=1; yyerror("bad integral size");
          }
         break;
         default:
          fatal=1; yyerror("possible internal error: I am not equipped to\
 convert non-numerical constants to numerical constants");
       }
       typeinit(&(exp->t)); exp->t.curtp=exp->t.u.tp=t;
      break;
      case SFLOAT:
      case SDOUBLE:
       if(t==exp->t.curtp) goto nochange;
       switch(exp->c.t)
       { case PRDOUBLE:
         break;
         case PRLONG:
          if(exp->t.curtp>=SUNSIGNED) exp->c.u.d=(unsigned long)exp->c.u.l;
          else exp->c.u.d=exp->c.u.l;
          exp->c.t=PRDOUBLE;
         break;
         default:
          fatal=1; yyerror("possible internal error: I am not equipped to\
 convert non-numerical constants to numerical constants");
       }
       typeinit(&(exp->t)); exp->t.curtp=exp->t.u.tp=t;
      break;
      case SPOINTER:
       switch(exp->c.t)
       { case PRDOUBLE:
         case PRLONG:
         break;
         default:
          fatal=1; yyerror("possible internal error: I am not equipped to\
 convert non-numerical constants to numerical constants");
       }
       exp->t=stp;
       exp->t.curtp=t;
       tpoftype(&exp->t);
       RAL(exp->p.d,exp->p.l+2+solong,char);
       exp->p.d[exp->p.l++]=OCONVERT;
       exp->p.d[exp->p.l++]=SPOINTER;
       SLDLONG(exp->p.d+exp->p.l,objectsize(exp->t)); exp->p.l+=solong;
       exp->const=exp->pconst=0;
      goto nochange;
      case SSTRUCT:
       fatal=1;
       yyerror("inernal error: internal constant struct attempt conversion");
      break;
      case SFUNC:
       fatal=1;
       yyerror("inernal error: internal const. func attempting conversion");
      break;
      default:
       fatal=1; yyerror("internal error: unknown const tp attemp conversion");
      break;
    }
    loadconst(exp);
   nochange: ;
  }
  else
  { if(e1t==SFUNC)
    { exp->t.ptr=1;
      exp->const=exp->lval=0;
      RAL(exp->p.d,exp->p.l+1,char);
      exp->p.d[exp->p.l++]=OTOPTR; e1t=exp->t.curtp=SPOINTER;
    }
    switch(t%SUNSIGNED)
    { case SCHAR:
      case SSHORT:
      case SINT:
      case SLONG:
      case SFLOAT:
      case SDOUBLE:
       typeinit(&(exp->t)); exp->t.u.tp=exp->t.curtp=t;
       if(e1t==SSTRUCT||e1t==SFUNC||(e1t==SPOINTER&&!((t%SUNSIGNED==SLONG
          &&solong==sopoint)||(t%SUNSIGNED==SINT&&soint==sopoint))))
       { yyerror("warning: unusual conversion: struct, func or pointer\
 converted to numerical");
fprintf(stderr,"e1t %d t %d\n",e1t,t);
       }
      goto nosize;
      case SPOINTER:
       if(e1t!=SPOINTER&&(e1t!=SINT||soint!=sopoint)
          &&(e1t!=SLONG||solong!=sopoint))
       { yyerror("warning: unusual conversion: convert nonpointer to pointer");
       }
       RAL(exp->p.d,exp->p.l+2+solong,char);
       exp->t=stp; exp->t.curtp=t;
       exp->p.d[exp->p.l++]=OCONVERT;
       exp->p.d[exp->p.l++]=t;
       SLDLONG(exp->p.d+exp->p.l,objectsize(stp)); exp->p.l+=solong;
      break;
      case SSTRUCT:
       if(e1t!=SSTRUCT)
       { yyerror("warning: unusual conversion: convert nonstruct to struct");
       }
       else yyerror("warning: unusual conversion: convert struct to struct");
       RAL(exp->p.d,exp->p.l+2+solong,char);
       exp->p.d[exp->p.l++]=OCONVERT;
       exp->p.d[exp->p.l++]=t;
       exp->t=stp; exp->t.curtp=t;
       SLDLONG(exp->p.d+exp->p.l,exp->t.size); exp->p.l+=solong;
      break;
      case SFUNC:
       if(e1t!=SFUNC)
       { yyerror("warning: unusual conversion: convert to function");
       }
       exp->t=stp; exp->t.curtp=t;
      nosize:
       RAL(exp->p.d,exp->p.l+2,char);
       exp->p.d[exp->p.l++]=OCONVERT;
       exp->p.d[exp->p.l++]=t;
      break;
      default:
       fatal=1; yyerror("internal error: unknown type in stdconvert");
      break;
    }
  }
  exp->lval=0;
}
