/* support routines for pseudo code generation */
#include <stdio.h>
#include "head.h"
#include "pseudo.h"

int incindx(ptr,sz) struct pseudo *ptr;
/* increment all indxs in ptr by sz (for if things being stuffed before it */
{ int x;
  for(x=0;x<ptr->bcnt;x++) ptr->bd[x]+=sz;
  for(x=0;x<ptr->ccnt;x++) ptr->cd[x]+=sz;
}

zerotransfer(ptr) struct pseudo *ptr;
/* fill indx's like bcnt,ccnt,defcnt,cscnt with 0 */
{ ptr->bcnt=ptr->ccnt=ptr->defcnt=ptr->cscnt=0;
}

indxcombine(dst,src,sz) struct pseudo *dst,*src;
/* combine indx's in such a way that src tacked on end of dst with
 *  sz bytes between */
{ incindx(src,sz+dst->l);
  if(src->bcnt)
  { if(dst->bcnt)
    { RAL(dst->bd,dst->bcnt+src->bcnt,flong);
      memcpy(dst->bd+dst->bcnt,src->bd,src->bcnt*sizeof(flong));
      dst->bcnt+=src->bcnt;
    }
    else
    { dst->bcnt=src->bcnt; dst->bd=src->bd; }
  }
  if(src->ccnt)
  { if(dst->ccnt)
    { RAL(dst->cd,dst->ccnt+src->ccnt,flong);
      memcpy(dst->cd+dst->ccnt,src->cd,src->ccnt*sizeof(flong));
      dst->ccnt+=src->ccnt;
    }
    else
    { dst->ccnt=src->ccnt; dst->cd=src->cd; }
  }
  if(src->cscnt)
  { if(dst->cscnt)
    { RAL(dst->cspos,dst->cscnt+src->cscnt,flong);
      memcpy(dst->cspos+dst->cscnt,src->cspos,src->cscnt*sizeof(flong));
      RAL(dst->csval,dst->cscnt+src->cscnt,int);
      memcpy(dst->csval+dst->cscnt,src->csval,src->cscnt*sizeof(int));
      dst->cscnt+=src->cscnt;
    }
    else
    { dst->cscnt=src->cscnt; dst->cspos=src->cspos;
      dst->cscnt=src->cscnt; dst->csval=src->csval;
    }
  }
  if(src->defcnt)
  { if(dst->defcnt)
    { fatal=1; yyerror("multiple default positions"); }
    dst->defcnt=src->defcnt; dst->defpos=src->defpos;
  }
}

short unique()
{ if(nextaddress>=32765)
  { yyerror("internal error:too many labels"); fatal=1; }
 /* ABOVE IS NON-PORTABLE */
 return ++nextaddress;
}

short labeltruefalse(exp) struct expr *exp;
/* labels trues and falses in exp and returns label for true; l+1=false*/
{ short int x,y;
  if(!exp->p.l) /* for the for statement with blank middle */
  { AL(exp->tpoint,1,flong); exp->tcnt=1; *(exp->tpoint)=1;
    AL(exp->p.d,1+SAL,char);
    *(exp->p.d)=OJMP; exp->p.l=1+SAL;
    exp->const=exp->pconst=0;
  }
  else *exp=mkcompare(*exp);
  x=unique();
  for(y=0;y<exp->tcnt;y++) SLABELIT(exp->p.d+exp->tpoint[y],x);
  x=unique();
  for(y=0;y<exp->fcnt;y++) SLABELIT(exp->p.d+exp->fpoint[y],x);
  if(exp->fcnt) free(exp->fpoint);
  if(exp->tcnt) free(exp->tpoint);
  exp->tcnt=exp->fcnt=0;
 return x-1; /* assume unique produces consecutive integers */
}

labelbreak(ps,i) struct pseudo *ps; int i;
/* labelbreak() - labels all breaks in exp */
{ int x;
  for(x=0;x<ps->bcnt;x++) SLABELIT(ps->d+ps->bd[x],i);
  if(ps->bcnt) free(ps->bd);
}

labelcontinue(ps,i) struct pseudo *ps; int i;
/* labelcontinue() - labels all continues in ps */
{ int x;
  for(x=0;x<ps->ccnt;x++) SLABELIT(ps->d+ps->cd[x],i);
  if(ps->ccnt) free(ps->cd);
}

struct expr mkcompare(exp) struct expr exp;
/* changes a value to a comparison */
{ if(!(exp.tcnt||exp.fcnt))
  { if(exp.const)
    { autoconvert(&exp);
      if(!exp.const)
      { fatal=1; yyerror("internal error constant mkcompare"); }
      switch(exp.c.t)
      { case PRLONG:
         if(exp.c.u.l)
         { AL(exp.tpoint,1,flong); exp.tcnt= *(exp.tpoint)=1; }
         else
         { AL(exp.fpoint,1,flong); exp.fcnt= *(exp.fpoint)=1; }
        break;
        case PRDOUBLE:
         if(exp.c.u.d)
         { AL(exp.tpoint,1,flong); exp.tcnt= *(exp.tpoint)=1; }
         else
         { AL(exp.fpoint,1,flong); exp.fcnt= *(exp.fpoint)=1; }
        break;
        default:
         fatal=1; yyerror("internal error:unknown tp in mkcompare");
      }
      RAL(exp.p.d,1+SAL,char);
      *(exp.p.d)=OJMP; exp.p.l=1+SAL;
    }
    else if(exp.pconst==1)
    { AL(exp.tpoint,1,flong); exp.tcnt=1; *(exp.tpoint)=1;
      RAL(exp.p.d,1+SAL,char);
      *(exp.p.d)=OJMP; exp.p.l=1+SAL;
    }
    else
    { RAL(exp.p.d,exp.p.l+1+2*SAL,char);
      exp.p.d[exp.p.l]=OTEST;
      AL(exp.tpoint,1,flong);
      AL(exp.fpoint,1,flong);
      exp.tcnt=exp.fcnt=1;
      *(exp.tpoint)=exp.p.l+1;
      *(exp.fpoint)=exp.p.l+1+SAL;
      exp.p.l+=1+2*SAL;
    }
  }
  exp.const=exp.pconst=0;
 return exp;
}

struct expr mkvalue(exp) struct expr exp;
/* changes a comparison to a value */
{ flong x,y,z,n;

  if(exp.tcnt||exp.fcnt)
  { typeinit(&(exp.t));
    exp.t.curtp=exp.t.u.tp=SINT;

    if(!exp.tcnt)
    { RAL(exp.p.d,1+soint,char);
      *(exp.p.d)=OLCINT; exp.p.l=1+soint;
      SLDINT(exp.p.d+1,0);
      exp.c.t=PRLONG; exp.c.u.l=0;
      exp.const=1; exp.pconst=0;
    }
    else if(!exp.fcnt)
    { RAL(exp.p.d,1+soint,char);
      *(exp.p.d)=OLCINT; exp.p.l=1+soint;
      SLDINT(exp.p.d+1,1);
      exp.c.t=PRLONG; exp.c.u.l=1;
      exp.const=1; exp.pconst=0;
    }
    else
    { RAL(exp.p.d,exp.p.l+2*soint+9+4*SAL,char);
      x=exp.p.l;

      memmove(exp.p.d+1,exp.p.d,x);
      *exp.p.d=OSTARTQ; x++;

      /* STRT expression LB TR LD 1 JMP NEW LB FL LD 0 LB NEW END */
      y=unique(); /* label true */
      exp.p.d[x++]=OLABEL; SLABELIT(exp.p.d+x,y); x+=SAL;
      for(z=0;z<exp.tcnt;z++) SLABELIT(exp.p.d+exp.tpoint[z]+1,y);
      if(z) free(exp.tpoint);
      z=1; /* LD 1 */
      exp.p.d[x++]=OLCINT; SLDINT(exp.p.d+x,z); x+=soint;

      n=unique(); /* jmp new */
      exp.p.d[x++]=OJMP; SLABELIT(exp.p.d+x,n); x+=SAL;

      y=unique(); /* label false */
      exp.p.d[x++]=OLABEL; SLABELIT(exp.p.d+x,y); x+=SAL;
      for(z=0;z<exp.fcnt;z++) SLABELIT(exp.p.d+exp.fpoint[z]+1,y);
      if(z) free(exp.fpoint);
      z=0; /* LD 0 */
      exp.p.d[x++]=OLCINT; SLDINT(exp.p.d+x,z); x+=soint;

      exp.p.d[x++]=OLABEL; SLABELIT(exp.p.d+x,n); x+=SAL; /* label new */
      exp.const=exp.pconst=exp.fcnt=exp.tcnt=0;

      exp.p.d[x++]=OENDQ;

      exp.p.l=x;
    }
  }
 return exp;
}

/* tpoftype() - calculate size & tp for expression */
tpoftype(type) struct type *type;
{ type->size=variablesize(*type);
  if(type->ptr)
  { type->curtp=SPOINTER; }
  else if(type->modlev&&type->modpos<type->modlev)
  { switch(type->mod[type->modpos].mod)
    { case MSTAR:
      case MAR_ELE:
       type->curtp=SPOINTER;
      break;
      case MFUNC:
       type->curtp=SFUNC;
      break;
      default: fatal=1; yyerror("internal error: unknown mod in exprtype");
    }
  }
  else if(type->tp)
  { type->curtp=SSTRUCT; }
  else type->curtp=type->u.tp;
}
