%{/* parser for C compiler */
extern int yylineno,yydebug;
#include <stdio.h>
#include "head.h"
#include "pseudo.h"
#define DONE break  /* PORT: assumes that it is UNIX's yacc or compatible */
char curfunctp;
flong curfuncsz;
%}
%union argtype
{ char *pchar;
  struct str string;
  struct pseudo pseudo;
  double ndouble;
  flong nlong;
  struct expr expr;
  struct type type;
  struct vardefs vardefs;
  struct namedtype ntype;
  struct prevalue prev;
  struct funcargspec funcargspec;
  struct
  { struct expr *exp;
    int cnt;
  } funcargs;
}
%type <type> type typemods basictype scope_specifier mainscope_specifier
%type <type> integraltp argtype modifiers definite_scope
%type <ntype> vle varlist_ele intfuncdef intfuncdef2
%type <vardefs> varlist Dvarlist vdef
%type <funcargspec> meatoftpargvardefs tpargvardefs Dids
%type <prev> prevalues braced_const constlist
%type <pchar> Sid
%type <pseudo> statement statements Dstatements allocvardefs compound_statement
%type <expr> exp0 exp1st exp2nd Lexpression expression expoblk exphigh
%type <nlong> vardefs limvardefs argvardefs
%type <funcargs> Lexplist

%token SWITCH IF GOTO WHILE DO CASE BREAK CONTINUE FOR
%token DEFAULT RETURN ELSE ';' '?' ':' '{' '}' '[' '(' ')' ']' SIZEOF
%token <pchar> ID
%token <string> STRCONST
%token <nlong> INUM LNUM STRoUNION COMPLEX_E CHRCONST
%token <ndouble> FNUM
%token INTSP TYPEDEF CHARSP UNSIGNSP VOLATILESP LONGSP SHORTSP
%token EXTERNALSP STATICSP VOIDSP FLOATSP DOUBLESP REGISTERSP AUTOSP
%token <ntype> DTYPE

%left ','
%right '=' COMPLEX_E
%left COR
%left CAND
%left '|'
%left '^'
%left '&'
%left EQ NE
%left LE GE '<' '>'
%left RSHFT LSHFT
%left '+' '-'
%left '*' '/' '%'
%right '!' '~' PP MM SIZEOF
%left '.' ARROW '(' '['

%%
program: func_def
 | program func_def
;
intfuncdef: varlist_ele
  { /*MERE?: erroneous void if type>NOTYPE verify no access to nons*/
    if($1.t.modlev!=1||$1.t.mod->mod!=MFUNC)
    { fatal=1; yyerror("non function acts like function"); }
    $1.t.u.tp=SINT;
    $1.t.modpos=1;
    $1.t.size=variablesize($1.t);
    if(modtypeverify($1.t))
    { yyerror("illegal type of func: unknown size"); }
    tpoftype(&($1.t));
    curfunctp=$1.t.curtp; /* curfuncsz unneeded. */

    RAL(exttbl,exttblsz+1,struct exttbl);
    Scp(&(exttbl[exttblsz].nm),$1.nm);
    exttbl[exttblsz].size=$1.t.size;
    exttbl[exttblsz].tp=SFUNC; exttbl[exttblsz].scope=SCPEXTERN;
    exttbl[exttblsz].prepres=0;
    if(!vds->vdcnt) { AL(vds->vd,1,struct namedtype); }
    else RAL(vds->vd,vds->vdcnt+1,struct namedtype);
    /*MORE what if struct defined here? legal? */
    vds->vd[vds->vdcnt]=$1;
    vds->vd[vds->vdcnt].sect=SCPUBLIC;
    vds->vd[vds->vdcnt].off=exttblsz++;
    vds->vd[vds->vdcnt++].p.cnt=0;
    $1.t.modpos=0;
    $$=$1;
  }
 | type varlist_ele
  { $2.t.u=$1.u;
    $2.t.tp=$1.tp;
    $2.t.scope=$1.scope;
    $2.t.treg=$1.treg;
    $2.t.tvolatile=$1.tvolatile;
    $2.t.field=$1.field;
    /*MERE?: erroneous void if type>NOTYPE verify no access to nons*/
    if($1.modlev)
    { if($2.t.modlev)
      { RAL($2.t.mod,$1.modlev+$2.t.modlev,struct modstuff); }
      else AL($2.t.mod,$1.modlev,struct modstuff);
      memcpy((char *)($2.t.mod+$2.t.modlev)
       ,(char *)($1.mod),(int)($1.modlev)*sizeof(struct modstuff));
      $2.t.modlev+=$1.modlev;
    }
    if(!$2.t.modlev||$2.t.mod->mod!=MFUNC)
    { fatal=1; yyerror("non function acts like function"); }
    $2.t.modpos=1;
    $2.t.size=variablesize($2.t);
    if(modtypeverify($2.t))
    { yyerror("illegal type of func: unknown size"); }
    if($1.modlev) free($1.mod);
    tpoftype(&($2.t));
    curfunctp=$2.t.curtp;
    if(curfunctp==SSTRUCT) curfuncsz=$2.t.size;
    else if(curfunctp==SPOINTER) curfuncsz=objectsize($2.t);

    RAL(exttbl,exttblsz+1,struct exttbl);
    Scp(&(exttbl[exttblsz].nm),$2.nm);
    exttbl[exttblsz].size=$2.t.size;
    exttbl[exttblsz].tp=SFUNC; exttbl[exttblsz].scope=$1.scope;
    exttbl[exttblsz].prepres=0;
    if(!vds->vdcnt) { AL(vds->vd,1,struct namedtype); }
    else RAL(vds->vd,vds->vdcnt+1,struct namedtype);
    vds->vd[vds->vdcnt]=$2;
    vds->vd[vds->vdcnt].sect=SCPUBLIC/*+$2.t.treg*SCREGISTER*/;
    vds->vd[vds->vdcnt].off=exttblsz++;
    vds->vd[vds->vdcnt++].p.cnt=0;
    $2.t.modpos=0;
    $$=$2;
  }
;
intfuncdef2: intfuncdef argvardefs
  { int tvdcnt;
    struct namedtype *tmpvds;
    char *sptr;
    tmpvds=vds[vdscnt-1].vd;
    tvdcnt=vds[vdscnt-1].vdcnt;
    if($1.t.mod->null) /* if argvardefs is needed */
    { /* move the type for each argvardef into appropriate spot */
      for(a=0;a<tvdcnt;a++) tmpvds[a].sect=SCARG+1; /* this is flag */
      for(b=0;b<$1.t.mod->u.fn.argcnt;b++)
      { sptr=$1.t.mod->u.fn.args[b].nm;
        for(a=0;a<tvdcnt;a++)
         if(!strcmp(sptr,tmpvds[a].nm))
         { if(tmpvds[a].sect==SCARG)
           { fatal=1; sprintf(temp,"two arguments %s",tmpvds[a].nm);
             yyerror(temp);
           }
           tmpvds[a].sect=SCARG;
          break;
         }
        if(a>=tvdcnt)
        { if(tvdcnt) { RAL(vds[vdscnt-1].vd,tvdcnt+1,struct namedtype); }
          else AL(vds[vdscnt-1].vd,1,struct namedtype);
          tmpvds=vds[vdscnt-1].vd;
          vds[vdscnt-1].vdcnt++;
          Scp(&(tmpvds[tvdcnt].nm),sptr);
          tmpvds[tvdcnt].p.cnt=0;
          typeinit(&(tmpvds[tvdcnt].t)); tmpvds[tvdcnt].t.u.tp=SINT;
          tmpvds[tvdcnt].t.size=soint;
          tmpvds[tvdcnt].sect=SCARG;
          tvdcnt=vds[vdscnt-1].vdcnt;
        }
        free(sptr);
        $1.t.mod->u.fn.args[b]=tmpvds[a];
      }
      for(a=0;a<tvdcnt;a++)
        if(tmpvds[a].sect!=SCARG)
        { fatal=1; yyerror("argument defined is not in argument list"); }
      /* allocate space */
      argsalloc($1.t.mod->u.fn.args,$1.t.mod->u.fn.argcnt);
    }
    else if($2)
    { fatal=1; yyerror("illegitimate method of specifiing types"); }
    /* copy the stuff into tmpvds */
    if(tvdcnt) free(tmpvds);
    /*NOTE: vardefs[1].vd should not be freed. */
    vds[vdscnt-1].vd=$1.t.mod->u.fn.args;
    vds[vdscnt-1].vdcnt=$1.t.mod->u.fn.argcnt;
    $$=$1;
  }
;
func_def: intfuncdef2 compound_statement
  { if($2.cscnt||$2.defcnt||$2.bcnt||$2.ccnt)
    { fatal=1;
      yyerror("a case, default, break and/or continue was in bad location");
    }
    a=strlen($1.nm)+1; b=a+2+(curfunctp==SPOINTER||curfunctp==SSTRUCT)*solong;
    RAL($2.d,$2.l+b+2,char);
    $2.l--; memmove($2.d+b,$2.d+1,$2.l); /* -1 to delete OBLOCK */
    *($2.d)=$1.t.scope==SCPSTATIC?OSTATFUNC:OFUNC;
    memcpy($2.d+1,$1.nm,a);
    $2.d[a+1]=curfunctp;
    if(curfunctp==SPOINTER||curfunctp==SSTRUCT)
    { SLDLONG($2.d+2+a,curfuncsz); }
    if(curfunctp==SSTRUCT&&curfuncsz>exttbl->size) exttbl->size=curfuncsz;
    $2.l+=b;
  /*MEREdelete  $2.d[$2.l++]=OENDBLCK;*/
    fwrite(&($2.l),sizeof($2.l),1,outfile);
    fwrite($2.d,1,$2.l,outfile);
    free($2.d);
    /* argvardefs may or may not exist */
    if(vdscnt!=2)
    { fatal=1; yyerror("internal error vdscnt"); }
    for(a=0;a<labelcnt;a++)
    { if(labelnum[a]<0)
      { sprintf(temp,"statement label \"%s:\" is not present",labelname[a]);
        fatal=1; yyerror(temp);
      }
      free(labelname[a]);
    }
    for(a=0;a<vds[1].vdcnt;a++) free(vds[1].vd[a].nm);
    labelcnt=nextaddress=totssn=0;
    vdscnt=1;
  }
 | vdef ';'
  { /* nothing */ }
;
Dids: ID
  { AL($$.args,1,struct namedtype);
    $$.args->nm=$1;
    typeinit(&($$.args->t));
    $$.argcnt=1;
    $$.only=0;
  }
 | Dids ',' ID
  { $$=$1;
    RAL($$.args,$$.argcnt+1,struct namedtype);
    $$.args[$$.argcnt].nm=$3;
    typeinit(&($$.args[$$.argcnt].t));
    $$.argcnt++;
  }
;
statement: expression ';'
  { $$=$1.p;
    if($1.tcnt||$1.fcnt)
    { yyerror("warning: comparison accomplishes nothing");
      $1=mkvalue($1);
    }
    RAL($$.d,$$.l+1,char); $$.d[$$.l++]=OPOP;
    zerotransfer(&($$));
    linetrack(&($$));
  }
 | ';'
  { zerotransfer(&($$));
    AL($$.d,1,char);
    $$.l=0;
    linetrack(&($$));
  }
 | compound_statement
  { $$=$1; }
 | CASE expression ':' statement
  { autoconvert(&($2));
    free($2.p.d);
    if(!$2.const)
    { fatal=1; yyerror("non-constant expession in case statement"); }
    a=$2.c.t;
    if($2.c.t!=SLONG)
    { fatal=1; yyerror("illegal type of constant for switch statement"); }
    a=$2.c.u.l;
    $$=$4;
    for(b=0;b<$$.cscnt;b++)
     if($$.csval[b]==a)
     { yyerror("warning: duplicate case statement being ignored"); }
    RAL($$.d,$$.l+(1+SAL),char);
    incindx(&($$),1+SAL);
    memmove($$.d+(1+SAL),$$.d,$$.l); $$.l+=1+SAL;
    *($$.d)=OLABEL;

    if($$.cscnt)
    { RAL($$.cspos,$$.cscnt+1,flong);
      RAL($$.csval,$$.cscnt+1,int);
    }
    else
    { AL($$.cspos,$$.cscnt+1,flong);
      AL($$.csval,$$.cscnt+1,int);
    }
    $$.cspos[$$.cscnt]=unique();
    $$.csval[$$.cscnt]=a;
    SLABELIT($$.d+1,$$.cspos[$$.cscnt]);
    $$.cscnt++;
    linetrack(&($$));
  }
 | DEFAULT ':' statement
  { $$=$3;
    incindx(&($$),SAL+1);
    if($$.defcnt)
    { fatal=1; yyerror("multiple default statements"); }
    $$.defpos=unique(); $$.defcnt=1;
    RAL($$.d,$$.l+SAL+1,char);
    memmove($$.d+(SAL+1),$$.d,$$.l); $$.l+=1+SAL;
    *($$.d)=OLABEL;
    SLABELIT($$.d+1,$$.defpos);
    linetrack(&($$));
  }
 | WHILE '(' expression ')' statement
  { /* LB NEW $3 LB TRUE $5 JMP NEW LB FALSE */
    $3=mkcompare($3);
    a=labeltruefalse(&($3));
    labelbreak((&($5)),(int)a+1);
    b=unique(); labelcontinue(&($5),(int)b);
    $$=$3.p;
    RAL($$.d,$$.l+$5.l+4+4*SAL,char);
    memmove($$.d+1+SAL,$$.d,$$.l);           /*make room for label NEW */
    *($$.d)=OLABEL; SLABELIT($$.d+1,b); $$.l+=1+SAL;
    $$.d[$$.l++]=OLABEL; SLABELIT($$.d+$$.l,a); $$.l+=SAL; /* label TRUE */
    memcpy($$.d+$$.l,$5.d,$5.l); $$.l+=$5.l; free($5.d);   /* $5 */
    $$.d[$$.l++]=OJMP; SLABELIT($$.d+$$.l,b); $$.l+=SAL;   /* jmp NEW */
    $$.d[$$.l++]=OLABEL; a++; SLABELIT($$.d+$$.l,a); $$.l+=SAL; /* label FS */
    $$.bcnt=$$.ccnt=0;
    $$.cspos=$5.cspos;   $$.cscnt=$5.cscnt;
    $$.defpos=$5.defpos; $$.defcnt=$5.defcnt;
    linetrack(&($$));
  }
 | GOTO ID ';'
  { AL($$.d,SAL+1,char); *($$.d)=OJMP; $$.l=SAL+1; $$.bcnt=$$.ccnt=0;
    for(a=0;a<labelcnt;a++)
      if(!strcmp($2,labelname[a]))
      { b=labelnum[a]<0?-labelnum[a]:labelnum[a];
        SLABELIT($$.d+1,b);
        free($2);
       break;
      }
    if(a==labelcnt)
    { RAL(labelname,labelcnt+1,char *);
      RAL(labelnum,labelcnt+1,int);
      b=unique();
      labelname[labelcnt]=$2; SLABELIT($$.d+1,b);
      labelnum[labelcnt++]=(-b);
    }
    zerotransfer(&($$));
    linetrack(&($$));
  }
 | FOR '(' expoblk ';' expoblk ';' expoblk ')' statement
  { /* e1 LB NEW e2 LB TR statement LB CONT e3 JMP NEW LB FS */
    int c;
    $$=$3.p;
    a=labeltruefalse(&($5));
    labelbreak(&($9),(int)a+1);
    c=unique(); labelcontinue(&($9),(int)c);
    if($7.tcnt||$7.fcnt)
    { yyerror("warning: comparison accomplishes nothing in 3rd for arg.");
      $7=mkvalue($7);
    }
    if($3.tcnt||$3.fcnt)
    { yyerror("warning: comparison accomplishes nothing in 1st for arg.");
      $3=mkvalue($3);
    }
    b=unique();
    if(!$$.l) AL($$.d,1,char);
    RAL($$.d,5*SAL+7+$$.l+$5.p.l+$7.p.l+$9.l,char);
    if($$.l) $$.d[$$.l++]=OPOP;                          /* 1st exp */
    $$.d[$$.l++]=OLABEL; SLABELIT($$.d+$$.l,b); $$.l+=SAL; /* LB NEW */
    memcpy($$.d+$$.l,$5.p.d,$5.p.l); $$.l+=$5.p.l; free($5.p.d); /* e2 */
    $$.d[$$.l++]=OLABEL; SLABELIT($$.d+$$.l,a); $$.l+=SAL; /* LB TR */
    memcpy($$.d+$$.l,$9.d,$9.l); $$.l+=$9.l; free($9.d);   /* statement */
    $$.d[$$.l++]=OLABEL; SLABELIT($$.d+$$.l,c); $$.l+=SAL; /* LB CONT */
    memcpy($$.d+$$.l,$7.p.d,$7.p.l); $$.l+=$7.p.l;         /* e3 */
    if($7.p.l) { free($7.p.d); $$.d[$$.l++]=OPOP; }
    $$.d[$$.l++]=OJMP; SLABELIT($$.d+$$.l,b); $$.l+=SAL;   /* JMP NEW */
    a++;
    $$.d[$$.l++]=OLABEL; SLABELIT($$.d+$$.l,a); $$.l+=SAL; /* LB FS */
    $$.bcnt=$$.ccnt=0;
    $$.cspos=$9.cspos;   $$.cscnt=$9.cscnt;
    $$.defpos=$9.defpos; $$.defcnt=$9.defcnt;
    linetrack(&($$));
  }
 | DO statement WHILE '(' expression ')' ';'
  { /* LB TR $2 LB CONT $5 LB FS */
    int c;
    $5=mkcompare($5); a=labeltruefalse(&($5));
    labelbreak(&($2),(int)a+1);
    c=unique(); labelcontinue(&($2),(int)c);
    $$=$2; RAL($$.d,3+3*SAL+$$.l+$5.p.l,char);
    memmove($$.d+1+SAL,$$.d,$$.l); $$.l+=1+SAL;   /* room for LB TR*/
    *($$.d)=OLABEL; SLABELIT($$.d+1,a);                        /*LB TR*/
    $$.d[$$.l++]=OLABEL; SLABELIT($$.d+$$.l,c); $$.l+=SAL;     /*LB CONT*/
    memcpy($$.d+$$.l,$5.p.d,$5.p.l); $$.l+=$5.p.l; free($5.p.d); /*expr.*/
    $$.d[$$.l++]=OLABEL; a++; SLABELIT($$.d+$$.l,a); $$.l+=SAL;/*LB FS*/
    $$.bcnt=$$.ccnt=0;
    linetrack(&($$));
  }
 | IF '(' expression ')' statement ELSE statement
  { flong new;
    etmp=mkcompare($3);
    a=labeltruefalse(&(etmp)); $$=etmp.p;
    /* expression LB TR statement JMP NEW LB FS statement LB NEW */
    RAL($$.d,$$.l+$5.l+$7.l+5+4*SAL,char);
    $$.d[$$.l++]=OLABEL; SLABELIT($$.d+$$.l,a); $$.l+=SAL;          /*LB TR*/

    indxcombine(&($5),&($7),2+2*SAL);
    incindx(&($5),$$.l);

    memcpy($$.d+$$.l,$5.d,$5.l); $$.l+=$5.l; free($5.d);            /*state1*/
    new=unique(); $$.d[$$.l++]=OJMP; SLABELIT($$.d+$$.l,new); $$.l+=SAL;/*NEW*/
    a++; $$.d[$$.l++]=OLABEL; SLABELIT($$.d+$$.l,a); $$.l+=SAL;     /*LB FS*/
    memcpy($$.d+$$.l,$7.d,$7.l); $$.l+=$7.l; free($7.d);            /*state2*/
    $$.d[$$.l++]=OLABEL; SLABELIT($$.d+$$.l,new); $$.l+=SAL;       /*LB NEW*/
  /* mix breaks and continues */
    $$.bcnt=$5.bcnt; $$.bd=$5.bd; $$.ccnt=$5.ccnt; $$.cd=$5.cd;
    $$.defcnt=$5.defcnt; $$.defpos=$5.defpos;
    $$.cscnt=$5.cscnt;   $$.cspos=$5.cspos;
    linetrack(&($$));
  }
 | IF '(' expression ')' statement
  { etmp=mkcompare($3); a=labeltruefalse(&(etmp)); $$=etmp.p;
    /* expression LB TR statement LB FS */
    RAL($$.d,$$.l+$5.l+2+2*SAL,char);
    $$.d[$$.l++]=OLABEL; SLABELIT($$.d+$$.l,a); $$.l+=SAL;          /*LB TR*/
    incindx(&($5),$$.l);
    memcpy($$.d+$$.l,$5.d,$5.l); $$.l+=$5.l; free($5.d);            /*state1*/
    a++; $$.d[$$.l++]=OLABEL; SLABELIT($$.d+$$.l,a); $$.l+=SAL;     /*LB FS*/
    $$.bcnt=$5.bcnt; $$.ccnt=$5.ccnt; $$.bd=$5.bd; $$.cd=$5.cd;
    $$.defcnt=$5.defcnt; $$.defpos=$5.defpos;
    $$.cscnt=$5.cscnt;   $$.cspos=$5.cspos;
    linetrack(&($$));
  }
 | BREAK ';'
  { zerotransfer(&($$));
    $$.bcnt=1; $$.l=1+SAL; AL($$.d,$$.l,char); *($$.d)=OJMP;
    AL($$.bd,1,flong); *($$.bd)=1;
    linetrack(&($$));
  }
 | CONTINUE ';'
  { zerotransfer(&($$));
    $$.ccnt=1; $$.l=1+SAL; AL($$.d,$$.l,char); *($$.d)=OJMP;
    AL($$.cd,1,flong); *($$.cd)=1;
    linetrack(&($$));
  }
 | RETURN ';'
  { zerotransfer(&($$));
    AL($$.d,1,char); *($$.d)=ORETURN; $$.l=1;
    linetrack(&($$));
  }
 | RETURN expression ';'
  { etmp=mkvalue($2); tpoftype(&(etmp.t)); $$=etmp.p; $$.bcnt=$$.ccnt=0;
    RAL($$.d,$$.l+3+solong,char);
    if(etmp.t.curtp!=curfunctp)
    { $$.d[$$.l++]=OCONVERT; $$.d[$$.l++]=curfunctp;
      if(curfunctp==SSTRUCT||curfunctp==SPOINTER)
      { SLDLONG($$.d+$$.l,curfuncsz); $$.l+=solong; }
       /* if tp is POINT, sz won't be used */
    }
    $$.d[$$.l++]=OVALRET;
    zerotransfer(&($$));
    linetrack(&($$));
  }
 | ID ':' statement
  { $$=$3;
    RAL($$.d,$$.l+(SAL+1),char);
    incindx(&($$),1+SAL);
    memmove($$.d+(SAL+1),$$.d,$$.l); $$.l+=1+SAL;
    *($$.d)=OLABEL;
    for(a=0;a<labelcnt;a++) if(!strcmp($1,labelname[a]))
     { if(labelnum[a]<0) labelnum[a]=(-labelnum[a]);
       else
       { sprintf(temp,"2 goto labels (%s:). using 1st",$1); yyerror(temp); }
       SLABELIT($$.d+1,labelnum[a]);
       free($1);
      break;
     }
    if(a==labelcnt)
    { RAL(labelname,labelcnt+1,char *);
      RAL(labelnum,labelcnt+1,int);
      b=unique();
      labelname[labelcnt]=$1; SLABELIT($$.d+1,b);
      labelnum[labelcnt++]=b;
    }
    linetrack(&($$));
  }
 | SWITCH '(' expression ')' statement
  { /* $6 $3 (created list of casejmps) JMP DEF $7 (DEF if no other)/*$$*/
    int label;
    label=unique();
    labelbreak(&($5),label); $5.bcnt=0;
    autoconvert(&($3));
    if($3.t.curtp%SUNSIGNED!=SINT)
    { fatal=1; yyerror("type of expression in switch statement must be int"); }
    RAL($5.d,$5.l+$3.p.l+(3+2*SAL)+$5.cscnt*(1+SAL+soint),char);
    memmove($5.d+$3.p.l+(1+SAL)+$5.cscnt*(1+SAL+soint),$5.d,$5.l);
    memcpy($5.d,$3.p.d,$3.p.l); a=$3.p.l; free($3.p.d);
    for(b=0;b<$5.cscnt;b++)
    { $5.d[a++]=OCASECMP;
      SLDINT($5.d+a,$5.csval[b]); a+=soint;
      SLABELIT($5.d+a,$5.cspos[b]); a+=SAL;
    }
    if($5.cscnt)
    { free($5.csval); free($5.cspos);
      $5.cscnt=0;
    }
    $5.d[a++]=OJMP; SLABELIT($5.d+a,$5.defcnt?$5.defpos:label); a+=SAL;
    $5.l+=a;  $5.defcnt=0;
    for(b=0;b<$5.ccnt;b++) $5.cd[b]+=a;
    $5.d[$5.l++]=OLABEL; SLABELIT($5.d+$5.l,label); $5.l+=SAL;/*LB DEF&|break*/
    $$=$5;
    linetrack(&($$));
  }
;
compound_statement: '{' allocvardefs statements '}'
  { $$=$3;
    RAL($$.d,$2.l+$$.l+1,char);
    incindx(&($$),$2.l);
    memmove($$.d+$2.l,$$.d,$$.l);
    memcpy($$.d,$2.d,$2.l); $$.l+=$2.l; free($2.d);
    $$.d[$$.l++]=OENDBLCK;
    totssn-=vds[--vdscnt].ssn;
    freeupvars(vds+vdscnt);
    linetrack(&($$));
  }
;
statements:
  { zerotransfer(&($$));
    $$.l=0; AL($$.d,1,char);
  }
 | Dstatements
  { $$=$1; }
;
Dstatements: statement
  { $$=$1; }
 | Dstatements statement
  { $$=$1;
    RAL($$.d,$$.l+$2.l,char);
    indxcombine(&($$),&($2),0);
    memcpy($$.d+$$.l,$2.d,$2.l); $$.l+=$2.l; free($2.d);
    for(a=0;a<elimcnt;a++) free(elimmods[a]);
    elimcnt=0;
  }
;
expoblk: expression
  { $$=$1; }
 |
  { typeinit(&($$.t)); $$.pconst=$$.const=$$.tcnt=$$.fcnt=$$.lval=$$.p.l=0; }
;
starttpdef:
  { /* for beginning of typedef command */
    int rtn;
    rtn=vldstack[vldscnt-1].rtn;
    if(rtn==VDRLVD||rtn==VDRTPARG||rtn==VDRTPDEF)
    { fatal=1; yyerror("illegal place for typedef"); }
    else if(rtn==VDRARG)
    { yyerror("warning: typedef in argument def is now global"); }
    startvdefs(VDTTPDEF,VDRTPDEF);
  }
;
startallocvardefs:
  { /* for beginning of compound statements */
    startvdefs(VDTVD,VDRALLOC);
    allocprecode.l=ssn=autincnt=0;
    AL(autin,1,char);
  }
;
startargvdefs:
  { startvdefs(VDTVD,VDRARG); }
;
startlimvardefs:
  { int rtn;
    rtn=vldstack[vldscnt-1].rtn;
/*MERE    if(rtn==VDRLVD)
    { fatal=1; yyerror("illegal place for struct def. list"); }
    else*/ if(rtn==VDRTPARG||rtn==VDRARG)
    { yyerror("warning: struct definition in arg def list is made global"); }
    startvdefs(VDTLOC,VDRLVD);
  }
;
starttpargvardefs:
  { int rtn;
    rtn=vldstack[vldscnt-1].rtn;
    if(rtn==VDRTPARG||rtn==VDRARG)
    { fatal=1; yyerror("illegal place for an argument list"); }
    startvdefs(VDTLOC,VDRTPARG);
  }
;
tpdefvardefs: TYPEDEF starttpdef vdef
  { vldscnt--;
if(vldstack[vldscnt].rtn!=VDRTPDEF)
{ fatal=1; yyerror("internal error typedef inconsistency"); }
  }
;
argvardefs: startargvdefs vardefs
  { vldscnt--;
if(vldstack[vldscnt].rtn!=VDRARG)
{ fatal=1; yyerror("internal error argument definition inconsistency"); }
    $$=$2;
  }
;
limvardefs: '{' startlimvardefs vardefs '}'
  { int lvdnm;
    vldscnt--;
if(vldstack[vldscnt].rtn!=VDRLVD)
{ fatal=1; yyerror("internal error limvardefs inconsistency"); }
    lvdnm=vds[vdscnt-1].lvdcnt++;
    if(lvdnm)
    { RAL(vds[vdscnt-1].lvd,lvdnm+1,struct vardefs); }
    else { AL(vds[vdscnt-1].lvd,1,struct vardefs); }
    vds[vdscnt-1].lvd[lvdnm]=vldstack[vldscnt].u.vdfs;
    $$=lvdnm;
  }
;
tpargvardefs: starttpargvardefs meatoftpargvardefs
  { $$=$2;
    $$.only=1;
     /* note: this thing spread apart like this just to make yacc happy. */
  }
;
meatoftpargvardefs: int_tpargvardefs
  { vldscnt--;
if(vldstack[vldscnt].rtn!=VDRTPARG)
{ fatal=1; yyerror("internal error (argdefs) inconsistency"); }
    $$.argcnt=vldstack[vldscnt].u.vdfs.cnt;
    $$.args=vldstack[vldscnt].u.vdfs.pt;
    argsalloc($$.args,$$.argcnt);
  }
 | VOIDSP
  { vldscnt--;
if(vldstack[vldscnt].rtn!=VDRTPARG)
{ fatal=1; yyerror("internal error argdefs (void) inconsistency"); }
    $$.argcnt=0;
  }
;
allocvardefs: startallocvardefs vardefs
  { int adjust;
    vldscnt--;
if(vldstack[vldscnt].rtn!=VDRALLOC)
{ fatal=1; yyerror("internal error limvardefs inconsistency"); }
    AL($$.d,1+2*solong+autincnt+allocprecode.l,char);
    *($$.d)=OBLOCK; $$.l=1;
    if(alignauto) adjust=((ssn+3)&0xfffffffc);
    else adjust=ssn;
    totssn+=adjust-ssn;
    vds[vdscnt-1].ssn=adjust;
    SLDLONG($$.d+$$.l,adjust); $$.l+=solong;
    SLDLONG($$.d+$$.l,autincnt); $$.l+=solong;
    memcpy($$.d+$$.l,autin,autincnt); $$.l+=autincnt;
    memcpy($$.d+$$.l,allocprecode.d,allocprecode.l); $$.l+=allocprecode.l;
    /* allocprecode.d is not being freed because its just RAL'd on next one */
    free(autin);
  }
;
int_tpargvardefs: tpargvdef
  { /* nothing */ }
 | int_tpargvardefs ',' tpargvdef
  { /* nothing */ }
;
tpargvdef: argtype varlist_ele
  { struct vardefs vdtmp;
    vdtmp.cnt=1;
    AL(vdtmp.pt,1,struct namedtype);
    *vdtmp.pt=$2;
if(vldstack[vldscnt-1].rtn!=VDRTPARG)
{ fatal=1; yyerror("internal errror argvdef"); }
    vdefsload(&vldstack[vldscnt-1].u.vdfs.pt,&vldstack[vldscnt-1].u.vdfs.cnt
      ,VDRTPARG,&($1),&(vdtmp));
  }
;
vardefs: vdefs
  { $$=1; }
 |
  { $$=0; }
;
vdefs: vdef ';'
  { /* do nothing */ }
 | vdefs vdef ';'
  { /* do nothing */ }
;
vdef: type varlist
  { /* for each var. in varlist, mix type in and put in tvds */
    int num;
    num=vldstack[vldscnt-1].u.num;
    /* may not be currently num, but in that case, it wont be used. */
    switch(vldstack[vldscnt-1].tp)
    { case VDTVD:
       vdefsload(&vds[num].vd,&vds[num].vdcnt,vldstack[vldscnt-1].rtn,&($1)
         ,&($2));
      break;
      case VDTLOC:
       vdefsload(&vldstack[vldscnt-1].u.vdfs.pt,&vldstack[vldscnt-1].u.vdfs.cnt
         ,vldstack[vldscnt-1].rtn,&($1),&($2));
      break;
      case VDTTPDEF:
       vdefsload(&vds[num].tpd,&vds[num].tpdcnt,vldstack[vldscnt-1].rtn,&($1)
         ,&($2));
      break;
      default:
       fatal=1; yyerror("internal error at vdef");
    }
  }
 | tpdefvardefs
  { /* nothing */ }
;
varlist:
  { $$.cnt=0; }
 | Dvarlist
  { $$=$1; }
;
Dvarlist: vle
  { AL($$.pt,1,struct namedtype); $$.cnt=1; *($$.pt)=$1; }
 | Dvarlist ',' vle
  { $$=$1; RAL($$.pt,$$.cnt+1,struct namedtype); $$.pt[$$.cnt++]=$3; }
;
vle: varlist_ele
  { $$=$1; $$.p.cnt=0; }
 | varlist_ele ':' exp2nd
  { if(vldstack[vldscnt-1].rtn!=VDRLVD)
    { fatal=1; yyerror("illegal place for bit field not struct"); }
    $$=$1;
    if($1.t.modlev) { fatal=1; yyerror("illegal type for bit fields"); }
    if(!$3.const||$3.c.t!=PRLONG)
     { fatal=1; yyerror("illegal bit field constant"); }
    else $$.t.field=$3.c.u.l;
  }
 | varlist_ele prevalues
  { int rtn;
    rtn=vldstack[vldscnt-1].rtn;
    if(rtn==VDRARG||rtn==VDRTPDEF||rtn==VDRTPARG||rtn==VDRLVD)
    { fatal=1; yyerror("illegal place for initialization"); }
    $$=$1; $$.p=$2;
  }
;
varlist_ele: ID
  { typeinit(&($$.t)); $$.nm=$1; }
 | varlist_ele '(' Dids ')'
  { $$=$1;
    if($$.t.modlev||vldstack[vldscnt-1].rtn==VDRTPARG)
    { yyerror("not much point in specifiing argument names without types");
      RAL($$.t.mod,$$.t.modlev+1,struct modstuff);
    }
    else { AL($$.t.mod,1,struct modstuff); }
    $$.t.mod[$$.t.modlev].mod=MFUNC;
    $$.t.mod[$$.t.modlev].null=1;
    $$.t.mod[$$.t.modlev++].u.fn=$3;
  }
 | varlist_ele '(' tpargvardefs ')'
  { $$=$1; /* tpargvardefs won't let nested funcs exist */
    if($$.t.modlev) { RAL($$.t.mod,$$.t.modlev+1,struct modstuff); }
    else { AL($$.t.mod,1,struct modstuff); }
    $$.t.mod[$$.t.modlev].mod=MFUNC;
    $$.t.mod[$$.t.modlev].null=0;
    $$.t.mod[$$.t.modlev++].u.fn=$3;
  }
 | varlist_ele '(' ')'
  { $$=$1;
    if($$.t.modlev) { RAL($$.t.mod,$$.t.modlev+1,struct modstuff); }
    else { AL($$.t.mod,1,struct modstuff); }
    $$.t.mod[$$.t.modlev].u.fn.argcnt=$$.t.mod[$$.t.modlev].u.fn.only=0;
    $$.t.mod[$$.t.modlev].null=0;
    $$.t.mod[$$.t.modlev++].mod=MFUNC;
  }
 | '(' varlist_ele ')'
  { $$=$2; }
 | '*' varlist_ele
  { $$=$2;
    if($$.t.modlev) { RAL($$.t.mod,$$.t.modlev+1,struct modstuff); }
    else { AL($$.t.mod,1,struct modstuff); }
    $$.t.mod[$$.t.modlev].null=0;
    $$.t.mod[$$.t.modlev++].mod=MSTAR;
  }
 | varlist_ele '[' ']'
  { $$=$1;
    if($$.t.modlev) { RAL($$.t.mod,$$.t.modlev+1,struct modstuff); }
    else { AL($$.t.mod,1,struct modstuff); }
    $$.t.mod[$$.t.modlev].null=1; $$.t.mod[$$.t.modlev].u.arr=0;
    $$.t.mod[$$.t.modlev++].mod=MAR_ELE;
  }
 | varlist_ele '[' exp2nd ']'
  { $$=$1;
    if($$.t.modlev) { RAL($$.t.mod,$$.t.modlev+1,struct modstuff); }
    else { AL($$.t.mod,1,struct modstuff); }
    $$.t.mod[$$.t.modlev].null=0;
    $$.t.mod[$$.t.modlev].mod=MAR_ELE;

    if(!$3.const||$3.c.t!=PRLONG)
    { fatal=1; yyerror("illegal array element constant"); }
    else $$.t.mod[$$.t.modlev].u.arr=$3.c.u.l;
    $$.t.modlev++;
  }
;
prevalues: '=' exp2nd
  { AL($$.s,1,struct intpval); $$.cnt=1; *($$.s)=$2.c;

    if(!($2.const||$2.pconst==1)||($2.pconst
        &&vldstack[vldscnt-1].rtn==VDRALLOC))
    { if(vldstack[vldscnt-1].rtn==VDREXTERN)
      { fatal=1; yyerror("illegal place for non-constant initialization"); }
      $$.s->t=PRCODE;
      stringstf(&($2));
      $$.s->u.cd.p=$2.p;
      $$.s->u.cd.t=$2.t;
    }
    else if($2.c.t!=PRSTRING) free($2.p.d);
  }
 | '=' braced_const
  { $$=$2; }
;
braced_const: '{' constlist '}'
  { $$=$2; }
 | '{' constlist ',' '}'
  { $$=$2; }
;
constlist: braced_const
  { AL($$.s,1,struct intpval); $$.cnt=1; $$.s->t=PRPREV;
    $$.s->u.p=$1; }
 | exp2nd
  { AL($$.s,1,struct intpval); $$.cnt=1; *($$.s)=$1.c;
    if($1.c.t!=PRSTRING) free($1.p.d);
    if(!($1.const||$1.pconst))
    { fatal=1; yyerror("non-constant constant expression"); }
  }
 | constlist ',' constlist
  { RAL($1.s,$1.cnt+$3.cnt,struct intpval);
    memcpy((char *)($1.s+$1.cnt),(char *)($3.s)
     ,(int)($3.cnt)*sizeof(struct intpval)); free($3.s);
    $$=$1; $$.cnt+=$3.cnt;
  }
;
argtype: REGISTERSP basictype
  { $$=$2;
    if($$.treg||$$.scope!=SCPDEFAULT)
    { yyerror("warning: bad scope specification (with register)"); }
    $$.treg=1;
  }
 | VOLATILESP basictype
  { $$=$2;
    if($$.tvolatile)
    { yyerror("warning: bad scope specification (with volatile)"); }
    $$.tvolatile=1;
  }
 | basictype
  { $$=$1; }
;
type: scope_specifier basictype
  { int rtn;
    rtn=vldstack[vldscnt-1].rtn;
    $$=$2;
    $$.treg|=$1.treg; $$.tvolatile|=$1.tvolatile; $$.scope|=$1.scope;
    if(($$.treg||$$.tvolatile||$$.scope!=SCPDEFAULT)
      &&rtn!=VDREXTERN&&rtn!=VDRALLOC)
    { fatal=1; yyerror("scope specified in illegal place"); }
  }
 | definite_scope
  { int rtn;
    rtn=vldstack[vldscnt-1].rtn;
    $$=$1;
    $$.u.tp=SINT;
    if(rtn!=VDREXTERN&&rtn!=VDRALLOC)
    { fatal=1; yyerror("scope specified in illegal place"); }
  }
;
scope_specifier:
  { typeinit(&($$)); }
 | definite_scope
  { $$=$1; }
;
definite_scope: REGISTERSP mainscope_specifier
  { $$=$2;
    if($$.treg||$$.scope!=SCPDEFAULT)
    { yyerror("warning: bad scope specification (with register)"); }
    $$.treg=1;
/*MEREfuture not here: restrict so void legal only as pointers or functions
 * (not as-is or as an array */
  }
 | VOLATILESP mainscope_specifier
  { $$=$2;
    if($$.tvolatile)
    { yyerror("warning: bad scope specification (with volatile)"); }
    $$.tvolatile=1;
  }
 | mainscope_specifier
  { $$=$1; }
;
mainscope_specifier: AUTOSP
  { typeinit(&($$)); }
 | EXTERNALSP
  { typeinit(&($$)); $$.scope=SCPEXTERN; }
 | STATICSP
  { typeinit(&($$)); $$.scope=SCPSTATIC; }
 | REGISTERSP
  { typeinit(&($$)); $$.treg=1; }
 | VOLATILESP
  { typeinit(&($$)); $$.tvolatile=1; }
;
basictype: DOUBLESP
  { typeinit(&($$)); $$.u.tp=SDOUBLE; }
 | FLOATSP
  { typeinit(&($$)); $$.u.tp=SFLOAT; }
 | LONGSP FLOATSP
  { typeinit(&($$)); $$.u.tp=SDOUBLE; }
 | integraltp
  { $$=$1; }
 | VOIDSP
  { typeinit(&($$)); $$.u.tp=SINT;/*MERE SVOID*/ }
 | UNSIGNSP integraltp
  { $$=$2; $$.u.tp+=SUNSIGNED; }
 | UNSIGNSP
  { typeinit(&($$)); $$.u.tp=SINT+SUNSIGNED; }
 | STRoUNION Sid limvardefs
  { typeinit(&($$));
    structalloc(vds[vdscnt-1].lvd+$3,$1==STRUCT);
    $$.size=vds[vdscnt-1].lvd[$3].size;
/* put $1,$3,$2 into a table somewhere and verify nothing else*/
    for(a=0;a<vds[vdscnt-1].soudcnt;a++)
      if(!strcmp($2,vds[vdscnt-1].soud[a].nm)) break;
    if(a<vds[vdscnt-1].soudcnt)
    { fatal=1; yyerror("illegal type: double definition of struct ID"); }
    $$.tp=$1; /* struct or union? */
    if(!$1) { fatal=1; yyerror("internal err:struct called etype"); }
    $$.u.p.l=vdscnt-1;
    $$.u.p.o=$3;
    if (vds[vdscnt-1].soudcnt) /* put copy in table */
    { RAL(vds[vdscnt-1].soud,vds[vdscnt-1].soudcnt+1,struct namedtype);
    } else AL(vds[vdscnt-1].soud,1,struct namedtype);
    vds[vdscnt-1].soud[vds[vdscnt-1].soudcnt].t=$$;
    vds[vdscnt-1].soud[vds[vdscnt-1].soudcnt++].nm=$2;
  }
 | STRoUNION limvardefs
  { typeinit(&($$));
 /* copy vardefs2 to **lvd in tvds, type=that with p=tvds.**lvd */
    structalloc(vds[vdscnt-1].lvd+$2,$1==STRUCT);
    $$.size=vds[vdscnt-1].lvd[$2].size;
    $$.tp=$1; /* struct or union? */
    $$.u.p.l=vdscnt-1;
    $$.u.p.o=$2;
  }
 | STRoUNION Sid
  { typeinit(&($$));
    for(a=vdscnt-1;a>=0;a--)
      for(b=0;b<vds[a].soudcnt;b++) /* scan vds */
       if(!strcmp($2,vds[a].soud[b].nm))
       { $$.tp=vds[a].soud[b].t.tp; $$.u=vds[a].soud[b].t.u;
         if($$.tp<NOTYPE&&$$.tp!=$1)
         { yyerror("illegal type:union ID refered to as struct ID or vice \
versa. assuming original");
         }
         free($2);
        goto breaktoend;
       }
/*MERE: findspec, by operating on COPIES, automatically corrects
 *for problems     $$.notypevdscnt=vdscnt;
 */
    $$.tp=NOTYPE+$1; /* not defined yet */
    $$.u.nm=$2;
   breaktoend: ;
  }
 | DTYPE
  { $$=$1.t;
    if($$.modlev)
    { AL($$.mod,$$.modlev,struct modstuff);
      memcpy((char *)($$.mod),(char *)($1.t.mod)
        ,(int)($$.modlev*sizeof(struct modstuff)));
      /*NOTE: lists of arguments are ignored when duplicating or freeing */
    }
    if($$.tp>NOTYPE) findspec(&($$));
    if($$.tp>NOTYPE&&$$.tp<=NOTYPE+2) Scp(&($$.u.nm),$1.t.u.nm);
  }
;
Sid: DTYPE
  { Scp(&($$),$1.nm); }
 | ID
  { $$=$1; }
;
integraltp: INTSP
  { typeinit(&($$)); $$.u.tp=SINT; }
 | CHARSP
  { typeinit(&($$)); $$.u.tp=SCHAR; }
 | LONGSP optionalint
  { typeinit(&($$)); $$.u.tp=SLONG; }
 | SHORTSP optionalint
  { typeinit(&($$)); $$.u.tp=SSHORT; }
;
optionalint:
  { /* nothing */ }
 | INTSP
  { /* nothing */ }
;
exphigh: '(' expression ')'
  { $$=$2; }
;
exp0: ID
  { for(a=vdscnt-1;a>=0;a--)
     for(b=0;b<vds[a].vdcnt;b++) if(!strcmp($1,vds[a].vd[b].nm))
       { free($1); goto idout; }
    fatal=1; sprintf(temp,"identifier not found: %s",$1); yyerror(temp);
    b--; a++; /* these enable fallowing to have label values */
    if(b<0||a>=vdscnt) exit(-1);
   idout:
    $$.t=vds[a].vd[b].t;
    if($$.t.tp>NOTYPE) findspec(&($$.t));
    if($$.t.tp>NOTYPE)
    { fatal=1; yyerror("unknown size"); }
    $$.pconst=$$.const=$$.tcnt=$$.fcnt=$$.t.modpos=0; $$.lval=1;
    $$.t.ptr=0;
    tpoftype(&($$.t));

    AL($$.p.d,4+2*solong,char);
    *($$.p.d)=ORECOG; $$.p.l=1;
    $$.p.d[$$.p.l++]=$$.t.curtp;
    if($$.t.curtp==SPOINTER||$$.t.curtp==SSTRUCT)
    { SLDLONG($$.p.d+$$.p.l,$$.t.curtp==SSTRUCT?variablesize($$.t)
        :objectsize($$.t));
      $$.p.l+=solong;
    }
    $$.pconst=2;
    if($$.t.curtp==SFUNC||($$.t.curtp==SPOINTER&&$$.t.modlev
        &&$$.t.mod->mod==MAR_ELE))
      $$.pconst=1;
    $$.c.t=PRPOINTER; $$.c.u.ptr.boff=0;
    $$.c.u.ptr.sect=vds[a].vd[b].sect; $$.c.u.ptr.off=vds[a].vd[b].off;

    $$.p.d[$$.p.l++]=vds[a].vd[b].sect;
    SLDLONG($$.p.d+$$.p.l,vds[a].vd[b].off); $$.p.l+=solong;
    if($$.t.curtp==SPOINTER&&$$.t.mod->mod==MAR_ELE)
      $$.p.d[$$.p.l++]=OSTOPTR;
  }
 | INUM
  { typeinit(&($$.t)); $$.t.u.tp=$$.t.curtp=SINT; $$.pconst=0;
    $$.const=1; $$.tcnt=$$.fcnt=$$.lval=0; $$.c.t=PRLONG; $$.c.u.l=$1;
    AL($$.p.d,soint+1,char); *($$.p.d)=OLCINT; SLDINT($$.p.d+1,$1);
    $$.p.l=soint+1;
  }
 | LNUM
  { typeinit(&($$.t)); $$.t.u.tp=$$.t.curtp=SLONG;
    $$.const=1; $$.tcnt=$$.fcnt=$$.lval=0; $$.c.t=PRLONG; $$.c.u.l=$1;
    AL($$.p.d,solong+1,char); *($$.p.d)=OLCLONG; SLDLONG($$.p.d+1,$1);
    $$.p.l=solong+1; $$.pconst=0;
  }
 | FNUM
  { typeinit(&($$.t)); $$.t.u.tp=$$.t.curtp=SDOUBLE;
    $$.const=1; $$.tcnt=$$.fcnt=$$.lval=0; $$.c.t=PRDOUBLE; $$.c.u.d=$1;
    AL($$.p.d,sodouble+1,char); *($$.p.d)=OLCDOUBLE; SLDDOUBLE($$.p.d+1,$1);
    $$.p.l=sodouble+1; $$.pconst=0;
  }
 | CHRCONST
  { typeinit(&($$.t)); $$.t.u.tp=$$.t.curtp=SINT; $$.pconst=0;
    $$.const=1; $$.tcnt=$$.fcnt=$$.lval=0; $$.c.t=PRLONG; $$.c.u.l=$1;
    AL($$.p.d,soint+1,char); *($$.p.d)=OLCINT; SLDINT($$.p.d+1,$1);
    $$.p.l=soint+1;
/*MEREfuture: drop CHRCONST from possibilities. */
  }
 | STRCONST
  { typeinit(&($$.t)); $$.t.u.tp=SCHAR; $$.t.ptr=1; $$.t.curtp=SPOINTER;
    $$.pconst=1; $$.const=$$.tcnt=$$.fcnt=$$.lval=0; $$.c.t=PRSTRING;
    $$.c.u.s=$1;
  }
 | exphigh
  { $$=$1; }
 | exphigh '(' Lexplist ')'
  { struct namedtype *nptr;
    $$=$1; $$.pconst=$$.const=0;
    AL($$.p.d,1,char);
    *($$.p.d)=OSTCLL; $$.p.l=1;
    tpoftype(&($$.t));
    if($$.t.curtp!=SFUNC) { fatal=1; yyerror("1illegal function call"); }
    b=$$.t.mod[$$.t.modpos].u.fn.only;
    if(b)
    { if($3.cnt!=$$.t.mod[$$.t.modpos].u.fn.argcnt)
      { fatal=1; yyerror("argument count mismatch"); b=0; }
    }
    nptr=$$.t.mod[$$.t.modpos].u.fn.args;
    for(a=$3.cnt-1;a>=0;a--)
    { if(b)
      { $3.exp[a]=mkvalue($3.exp[a]);
        tpoftype($3.exp+a);
        tpoftype(&nptr[a].t);
        if($3.exp[a].t.curtp!=nptr[a].t.curtp)
           stdconvert($3.exp+a,(int)nptr[a].t.curtp,nptr[a].t);
      }
      else autoconvert($3.exp+a);
      RAL($$.p.d,$$.p.l+$3.exp[a].p.l+1,char);
      memcpy($$.p.d+$$.p.l,$3.exp[a].p.d,$3.exp[a].p.l);
      $$.p.l+=$3.exp[a].p.l; free($3.exp[a].p.d);
      $$.p.d[$$.p.l++]=OLDFNCARG;
    }
    free($3.exp);
    $$.t.modpos++; tpoftype(&($$.t));
    RAL($$.p.d,2+$1.p.l+solong+$$.p.l,char);
    memcpy($$.p.d+$$.p.l,$1.p.d,$1.p.l); free($1.p.d);
    $$.p.l+=$1.p.l; $$.p.d[$$.p.l++]=OCALL;
    $$.p.d[$$.p.l++]=$$.t.curtp;
    if($$.t.curtp==SSTRUCT)
    { a=variablesize($$.t);
      SLDLONG($$.p.d+$$.p.l,a);
      $$.p.l+=solong;
      if(a>exttbl->size) exttbl->size=a;
    }
    else if($$.t.curtp==SPOINTER)
    { SLDLONG($$.p.d+$$.p.l,objectsize($$.t));
      $$.p.l+=solong;
    }
  }
 | exphigh '(' ')'
  { /* $1 OCALL0 */
    if($1.t.curtp!=SFUNC) { fatal=1; yyerror("2illegal function call"); }
    $$=$1; $$.pconst=$$.const=0;
    $$.t.modpos++; tpoftype(&($$.t));
    RAL($$.p.d,2+solong+$$.p.l,char);
    $$.p.d[$$.p.l++]=OCALL0;
    $$.p.d[$$.p.l++]=$$.t.curtp;
    if($$.t.curtp==SSTRUCT)
    { a=variablesize($$.t);
      SLDLONG($$.p.d+$$.p.l,a);
      $$.p.l+=solong;
      if(a>exttbl->size) exttbl->size=a;
    }
    else if($$.t.curtp==SPOINTER)
    { SLDLONG($$.p.d+$$.p.l,objectsize($$.t));
      $$.p.l+=solong;
    }
  }
 | ID '(' ')'
  { /* check vds if not there allocate space in vds and call it */
    for(a=vdscnt-1;a>=0;a--)
     for(b=0;b<vds[a].vdcnt;b++) if(!strcmp($1,vds[a].vd[b].nm))
     { free($1); goto idout2; }
    createintfunc(&a,&b,$1);
   idout2:
    /* OFUNCREC pub_stat nm \0 OCALL0 */
    $$.t=vds[a].vd[b].t;
    $$.pconst=$$.const=$$.tcnt=$$.fcnt=$$.t.modpos=0; $$.lval=1;
    tpoftype(&($$.t));
    AL($$.p.d,5+2*solong,char);
    *($$.p.d)=ORECOG; $$.p.l=1;
    $$.p.d[$$.p.l++]=$$.t.curtp;
    $$.p.d[$$.p.l++]=vds[a].vd[b].sect;
    SLDLONG($$.p.d+$$.p.l,vds[a].vd[b].off); $$.p.l+=solong;
    if($$.t.curtp!=SFUNC) { fatal=1; yyerror("3illegal function call"); }
    $$.p.d[$$.p.l++]=OCALL0;
    $$.t.modpos++; tpoftype(&($$.t)); $$.p.d[$$.p.l++]=$$.t.curtp;
    if($$.t.curtp==SSTRUCT)
    { a=variablesize($$.t);
      SLDLONG($$.p.d+$$.p.l,a);
      $$.p.l+=solong;
      if(a>exttbl->size) exttbl->size=a;
    }
    else if($$.t.curtp==SPOINTER)
    { SLDLONG($$.p.d+$$.p.l,objectsize($$.t));
      $$.p.l+=solong;
    }
  }
 | ID '(' Lexplist ')'
  { struct namedtype *nptr;
    int vda,vdb;
   /* check vds if not there allocate space in vds and call it */
    for(vda=vdscnt-1;vda>=0;vda--)
     for(vdb=0;vdb<vds[vda].vdcnt;vdb++) if(!strcmp($1,vds[vda].vd[vdb].nm))
     { free($1); goto idout3; }
    createintfunc(&vda,&vdb,$1);
   idout3:
    $$.t=vds[vda].vd[vdb].t;
    $$.pconst=$$.const=$$.tcnt=$$.fcnt=$$.t.modpos=$$.lval=0;
    AL($$.p.d,1,char);
    *($$.p.d)=OSTCLL; $$.p.l=1;
    tpoftype(&($$.t));
    if($$.t.curtp!=SFUNC) { fatal=1; yyerror("1illegal function call"); }
    b=$$.t.mod[$$.t.modpos].u.fn.only;
    if(b)
    { if($3.cnt!=$$.t.mod[$$.t.modpos].u.fn.argcnt)
      { fatal=1; yyerror("argument count mismatch"); b=0; }
    }
    nptr=$$.t.mod[$$.t.modpos].u.fn.args;
    for(a=$3.cnt-1;a>=0;a--)
    { if(b)
      { $3.exp[a]=mkvalue($3.exp[a]);
        tpoftype($3.exp+a);
        tpoftype(&nptr[a].t);
        if($3.exp[a].t.curtp!=nptr[a].t.curtp)
           stdconvert($3.exp+a,(int)nptr[a].t.curtp,nptr[a].t);
      }
      else autoconvert($3.exp+a);
      RAL($$.p.d,$$.p.l+$3.exp[a].p.l+1,char);
      memcpy($$.p.d+$$.p.l,$3.exp[a].p.d,$3.exp[a].p.l); free($3.exp[a].p.d);
      $$.p.l+=$3.exp[a].p.l;
      $$.p.d[$$.p.l++]=OLDFNCARG;
    }
    free($3.exp);
    RAL($$.p.d,5+$$.p.l+2*solong,char);
    $$.p.d[$$.p.l++]=ORECOG;
    $$.p.d[$$.p.l++]=$$.t.curtp;
    $$.p.d[$$.p.l++]=vds[vda].vd[vdb].sect;
    SLDLONG($$.p.d+$$.p.l,vds[vda].vd[vdb].off); $$.p.l+=solong;

    $$.t.modpos++; tpoftype(&($$.t));
    $$.p.d[$$.p.l++]=OCALL;
    $$.p.d[$$.p.l++]=$$.t.curtp;
    if($$.t.curtp==SSTRUCT)
    { a=variablesize($$.t);
      SLDLONG($$.p.d+$$.p.l,a);
      $$.p.l+=solong;
      if(a>exttbl->size) exttbl->size=a;
    }
    else if($$.t.curtp==SPOINTER)
    { SLDLONG($$.p.d+$$.p.l,objectsize($$.t));
      $$.p.l+=solong;
    }
  }
 | exp0 '[' expression ']'
  { /*$1 $3 OSUBSCRPT*/
    stringstf(&($1));
/*MORE?: constant pointer */
    if($1.t.curtp!=SPOINTER) { etmp=$1; $1=$3; $3=etmp; }
    if($1.t.curtp!=SPOINTER)
    { fatal=1; yyerror("illegal subscripting: no pointer"); }
    autoconvert(&($3));
    if($3.t.curtp%SUNSIGNED!=SINT&&$3.t.curtp%SUNSIGNED!=SLONG)
    { fatal=1; yyerror("illegal subscripting: no integer"); }
    $$=$1;
/*doneHERE: potentially still constant*/
    if($$.pconst&&$3.const&&$3.c.t==PRLONG)
    { $$.pconst=2;
      $$.c.u.ptr.boff+=objectsize($$.t)*$3.c.u.l;
    }
    else $$.pconst=$$.const=0;
    if($$.t.ptr) $$.t.ptr=0;
    $$.t.modpos++;
    tpoftype(&($$.t));
    RAL($$.p.d,$$.p.l+$3.p.l+3+solong,char);
    memcpy($$.p.d+$$.p.l,$3.p.d,$3.p.l); $$.p.l+=$3.p.l; free($3.p.d);
    $$.p.d[$$.p.l++]=OSUBSCRPT; $$.p.d[$$.p.l++]=$$.t.curtp;
    if($$.t.curtp==SPOINTER)
    { SLDLONG($$.p.d+$$.p.l,objectsize($$.t)); $$.p.l+=solong;
      if($$.t.modpos<$$.t.modlev&&$$.t.mod[$$.t.modpos].mod!=MSTAR)
        $$.p.d[$$.p.l++]=OSTOPTR;
    }
    else if($$.t.curtp==SSTRUCT)
    { SLDLONG($$.p.d+$$.p.l,variablesize($$.t)); $$.p.l+=solong; }
    $$.lval=1;
  }
 | exp0 ARROW ID
  { /*$1 OARROW offset type */
    struct vardefs tvd2;
    stringstf(&($1));
    if($1.t.curtp!=SPOINTER||!$1.t.tp)
    { fatal=1; yyerror("illegal type for ->"); DONE; }
    tvd2=vds[$1.t.u.p.l].lvd[$1.t.u.p.o];
    for(a=0;a<tvd2.cnt;a++)
     if(!strcmp($3,tvd2.pt[a].nm)) break;
    if(a>=tvd2.cnt)
    { fatal=1; sprintf(temp,"unknown struct elem. \"%s\"",$3);
      yyerror(temp); free($3);
    }
    else
    { free($3);
      $1.t=tvd2.pt[a].t; $1.t.modpos=0; tpoftype(&($1.t));
      findspec(&($1.t));
      if($1.t.tp>NOTYPE)
      { fatal=1; yyerror("unknown size"); }
      if(tvd2.pt[a].t.tp||!tvd2.pt[a].t.field)
      { /* use OARROW */
        if($1.pconst)
        { $1.pconst=2; $1.c.u.ptr.boff+=tvd2.pt[a].byteoff; }
        RAL($1.p.d,$1.p.l+2+solong,char); $1.p.d[$1.p.l++]=OARROW;
        SLDLONG($1.p.d+$1.p.l,tvd2.pt[a].byteoff); $1.p.l+=solong;
      }
      else
      { /* use OFARROW */
        RAL($1.p.d,$1.p.l+2+solong+2*sochar,char); $1.p.d[$1.p.l++]=OFARROW;
        SLDLONG($1.p.d+$1.p.l,tvd2.pt[a].byteoff); $1.p.l+=solong;
        $1.p.d[$1.p.l++]=tvd2.pt[a].bitoff;
        $1.p.d[$1.p.l++]=tvd2.pt[a].t.field;
      }
      $1.p.d[$1.p.l++]=$1.t.curtp;
      if($1.t.curtp==SPOINTER)
      { RAL($1.p.d,$1.p.l+1+solong,char);
        SLDLONG($1.p.d+$1.p.l,objectsize($1.t));
        $1.p.l+=solong;
        if($1.t.modpos<$1.t.modlev&&$1.t.mod[$1.t.modpos].mod!=MSTAR)
          $1.p.d[$1.p.l++]=OSTOPTR;
      }
      else if($1.t.curtp==SSTRUCT)
      { RAL($1.p.d,$1.p.l+solong,char);
        SLDLONG($1.p.d+$1.p.l,variablesize($1.t));
        $1.p.l+=solong;
      }
    }
    $$=$1;
    $$.lval=1;
  }
 | exp0 '.' ID
  { /*$1 OPOINT offset type */
    struct vardefs tvd2;
if(!$1.lval) { fatal=1; yyerror("internal error '.'"); }
    stringstf(&($1));
    if($1.t.curtp!=SSTRUCT||!$1.t.tp)
    { fatal=1; yyerror("illegal type for ."); DONE; }
    tvd2=vds[$1.t.u.p.l].lvd[$1.t.u.p.o];
    for(a=0;a<tvd2.cnt;a++)
     if(!strcmp($3,tvd2.pt[a].nm)) break;
    if(a>=tvd2.cnt)
    { fatal=1; sprintf(temp,"unknown struct elem. \"%s\"",$3);
      yyerror(temp); free($3);
    }
    else
    { free($3);
      $1.t=tvd2.pt[a].t; $1.t.modpos=0; tpoftype(&($1.t));
      findspec(&($1.t));
      if($1.t.tp>NOTYPE)
      { fatal=1; yyerror("unknown size"); }
      if(tvd2.pt[a].t.tp||!tvd2.pt[a].t.field)
      { /* use OPOINT */
        if($$.pconst)
        { $$.pconst=2; $$.c.u.ptr.boff+=tvd2.pt[a].byteoff; }
        RAL($1.p.d,$1.p.l+2+solong,char); $1.p.d[$1.p.l++]=OPOINT;
        SLDLONG($1.p.d+$1.p.l,tvd2.pt[a].byteoff); $1.p.l+=solong;
      }
      else
      { /* use OFPOINT */
        RAL($1.p.d,$1.p.l+2+solong+2*sochar,char); $1.p.d[$1.p.l++]=OFPOINT;
        SLDLONG($1.p.d+$1.p.l,tvd2.pt[a].byteoff); $1.p.l+=solong;
        $1.p.d[$1.p.l++]=tvd2.pt[a].bitoff;
        $1.p.d[$1.p.l++]=tvd2.pt[a].t.field;
      }
      $1.p.d[$1.p.l++]=$1.t.curtp;
      if($1.t.curtp==SPOINTER)
      { RAL($1.p.d,$1.p.l+1+solong,char);
        SLDLONG($1.p.d+$1.p.l,objectsize($1.t));
        $1.p.l+=solong;
        if($1.t.modpos<$1.t.modlev&&$1.t.mod[$1.t.modpos].mod!=MSTAR)
          $1.p.d[$1.p.l++]=OSTOPTR;
      }
      else if($1.t.curtp==SSTRUCT)
      { RAL($1.p.d,$1.p.l+solong,char);
        SLDLONG($1.p.d+$1.p.l,variablesize($1.t));
        $1.p.l+=solong;
      }
    }
    $$=$1;
  }
;
exp1st: exp0
  { $$=$1; }
 | SIZEOF exp1st
  { stringstf(&($2));
    $2.t.size=variablesize($2.t);
    typeinit(&($$.t)); $$.t.u.tp=SINT; $$.const=1;
    $$.pconst=$$.lval=$$.tcnt=$$.fcnt=0;
    $$.c.t=PRLONG; $$.c.u.l=$2.t.size; $$.t.curtp=SINT;
    AL($$.p.d,1+soint,char); $$.p.l=1+soint;
    *($$.p.d)=OLCINT; SLDINT($$.p.d+1,$2.t.size);
    free($2.p.d);
  }
 | '*' exp1st %prec PP
  { stringstf(&($2));
    $$=$2; $$.const=$$.pconst=0;
    if($$.t.curtp!=SPOINTER)
    { fatal=1; yyerror("operand of unary * is not a pointer"); }
    if($$.t.ptr) $$.t.ptr=0;
    else $$.t.modpos++;
    tpoftype(&($$.t));
    RAL($$.p.d,$$.p.l+3+solong,char);
    $$.p.d[$$.p.l++]=OPTRCONVERT; $$.p.d[$$.p.l++]=$$.t.curtp;
    if($$.t.curtp==SSTRUCT||$$.t.curtp==SPOINTER)
    { SLDLONG($$.p.d+$$.p.l,$$.t.curtp==SSTRUCT?variablesize($$.t)
        :objectsize($$.t));
      $$.p.l+=solong;
      if($$.t.curtp==SPOINTER&&$$.t.modpos<$$.t.modlev
        &&$$.t.mod[$$.t.modpos].mod!=MSTAR) $$.p.d[$$.p.l++]=OSTOPTR;
    }
    $$.lval=1;
  }
 | '&' exp1st %prec PP
  { stringstf(&($2));
    $$=$2;
    if($$.pconst==2) $$.pconst=1;
    if(!$$.lval||$$.t.ptr)
    { fatal=1; yyerror("illegal type for unary & operator: not a lvalue"); }
    $$.t.ptr=1;
    $$.const=$$.lval=0;
    RAL($$.p.d,$$.p.l+1,char);
    $$.p.d[$$.p.l++]=OTOPTR; $$.t.curtp=SPOINTER;
  }
 | SIZEOF typemods
  { typeinit(&($$.t)); $$.t.u.tp=$$.t.curtp=SINT; $$.const=1;
    $2.size=variablesize($2);
    $$.pconst=$$.tcnt=$$.fcnt=$$.lval=0; $$.c.t=PRLONG; $$.c.u.l=$2.size;
    AL($$.p.d,soint+1,char); *($$.p.d)=OLCINT; SLDINT($$.p.d+1,$2.size);
    $$.p.l=soint+1;
  }
 | '!' exp1st
  { flong *tpt;
    stringstf(&($2));
    $$=mkcompare($2);
    a=$$.tcnt; $$.tcnt=$$.fcnt; $$.fcnt=a;
    tpt=$$.tpoint; $$.tpoint=$$.fpoint; $$.fpoint=tpt;
  }
 | '~' exp1st
  { stringstf(&($2));
    $$=$2; monop(&($$),ONOT); }
 | PP exp1st
  { stringstf(&($2));
    $$=$2; monop(&($$),OINCV); }
 | MM exp1st
  { stringstf(&($2));
    $$=$2; monop(&($$),ODECV); }
 | exp1st PP
  { stringstf(&($1));
    $$=$1; monop(&($$),OVINC); }
 | exp1st MM
  { stringstf(&($1));
    $$=$1; monop(&($$),OVDEC); }
 | '-' exp1st %prec PP
  { stringstf(&($2));
    $$=$2; monop(&($$),OCHS); }
 | typemods exp1st %prec PP
  { stringstf(&($2));
    $$.t=$1; tpoftype(&($$.t));
    stdconvert(&($2),(int)$$.t.curtp,$1);
    $$=$2;
  }
 | exp1st '*' exp1st
  { stringstf(&($1)); stringstf(&($3));
    genop(&($$),$1,'*',$3); }
 | exp1st '%' exp1st
  { stringstf(&($1)); stringstf(&($3));
    intop(&($$),$1,'%',$3); }
 | exp1st '/' exp1st
  { stringstf(&($1)); stringstf(&($3));
    genop(&($$),$1,'/',$3); }
 | exp1st '+' exp1st
  { stringstf(&($1)); stringstf(&($3));
    genop(&($$),$1,'+',$3); }
 | exp1st '-' exp1st
  { stringstf(&($1)); stringstf(&($3));
    genop(&($$),$1,'-',$3); }
 | exp1st RSHFT exp1st
  { stringstf(&($1)); stringstf(&($3));
    intop(&($$),$1,RSHFT,$3); }
 | exp1st LSHFT exp1st
  { stringstf(&($1)); stringstf(&($3));
    intop(&($$),$1,LSHFT,$3); }
 | exp1st LE exp1st
  { stringstf(&($1)); stringstf(&($3));
    cmpop(&($$),$1,LE,$3); }
 | exp1st GE exp1st
  { stringstf(&($1)); stringstf(&($3));
    cmpop(&($$),$1,GE,$3); }
 | exp1st '<' exp1st
  { stringstf(&($1)); stringstf(&($3));
    cmpop(&($$),$1,'<',$3); }
 | exp1st '>' exp1st
  { stringstf(&($1)); stringstf(&($3));
    cmpop(&($$),$1,'>',$3); }
 | exp1st NE exp1st
  { stringstf(&($1)); stringstf(&($3));
    cmpop(&($$),$1,NE,$3); }
 | exp1st EQ exp1st
  { stringstf(&($1)); stringstf(&($3));
    cmpop(&($$),$1,EQ,$3); }
 | exp1st '&' exp1st
  { stringstf(&($1)); stringstf(&($3));
    intop(&($$),$1,'&',$3); }
 | exp1st '^' exp1st
  { stringstf(&($1)); stringstf(&($3));
    intop(&($$),$1,'^',$3); }
 | exp1st '|' exp1st
  { stringstf(&($1)); stringstf(&($3));
    intop(&($$),$1,'|',$3); }
 | exp1st CAND exp1st
  { /* $1 LB 1TR $3 # LB 3TR:TR LB 1FS LB 3FS:FS */
    stringstf(&($1)); stringstf(&($3));
    computeandor(&($$),&($1),&($3),&($$.tcnt),&($3.tcnt),&($$.tpoint)
       ,&($3.tpoint),&($$.fcnt),&($3.fcnt),&($$.fpoint),&($3.fpoint));
  }
 | exp1st COR exp1st
  { /* $1 LB 1FS $3 LB 3FS:FS LB 1TR LB 3TR:TR */
    stringstf(&($1)); stringstf(&($3));
    computeandor(&($$),&($1),&($3),&($$.fcnt),&($3.fcnt),&($$.fpoint)
       ,&($3.fpoint),&($$.tcnt),&($3.tcnt),&($$.tpoint),&($3.tpoint));
  }
;
typemods: '(' type ')'
  { $$=$2; $$.modpos=0;
    findspec(&($$));
    if($$.tp>NOTYPE)
    { fatal=1; yyerror("unknown size"); }
    $$.size=variablesize($$);
  }
 | '(' type modifiers ')'
  { $$=$2;
    if($2.modlev)
    { if($3.modlev)
      { RAL($3.mod,$2.modlev+$3.modlev,struct modstuff); }
      else AL($3.mod,$2.modlev,struct modstuff);
      memcpy((char *)($3.mod+$3.modlev)
       ,(char *)($2.mod),(int)($2.modlev)*sizeof(struct modstuff));
     /*MORE: lowpriority: free this stuff */
      $3.modlev+=$2.modlev;
    }
    if($3.modlev)
    { RAL(elimmods,elimcnt+1,char *);
      elimmods[elimcnt++]=(char *)$3.mod;
    }
    $$.mod=$3.mod; $$.modlev=$3.modlev;
    $$.modpos=0;
    $$.size=variablesize($$);
    findspec(&($$));
    if($$.tp>NOTYPE)
    { fatal=1; yyerror("unknown size"); }
    modtypeverify($$);
  }
;
modifiers: '(' ')'
  { AL($$.mod,1,struct modstuff);
    $$.modlev=1; $$.mod->mod=MFUNC; $$.mod->null=0;
  }
 | '[' ']'
  { AL($$.mod,1,struct modstuff);
    $$.modlev=1; $$.mod->mod=MAR_ELE; $$.mod->null=1; $$.mod->u.arr=0;
  }
 | '[' exp2nd ']'
  { AL($$.mod,1,struct modstuff); $$.modlev=1;
    if($2.c.t!=PRSTRING) free($2.p.d);
    if(!$2.const||$2.c.t!=PRLONG)
    { fatal=1; yyerror("illegal type: non-constant in declarator"); }
    else $$.mod->u.arr=$2.c.u.l;
    $$.mod->mod=MAR_ELE; $$.mod->null=0;
  }
 | '*'
  { AL($$.mod,1,struct modstuff); $$.modlev=1; $$.mod->mod=MSTAR; }
 | '(' modifiers ')'
  { $$=$2; }
 | '*' modifiers
  { RAL($2.mod,$2.modlev+1,struct modstuff);
    $2.mod[$2.modlev++].mod=MSTAR;
    $$=$2;
  }
 | modifiers '(' ')'
  { RAL($1.mod,$1.modlev+1,struct modstuff);
    $1.mod[$1.modlev].null=0; $1.mod[$1.modlev++].mod=MFUNC;
    $$=$1;
  }
 | modifiers '[' ']'
  { RAL($1.mod,$1.modlev+1,struct modstuff);
    $1.mod[$1.modlev].null=1; $1.mod[$1.modlev].u.arr=0;
    $1.mod[$1.modlev++].mod=MAR_ELE;
    $$=$1;
  }
 | modifiers '[' exp2nd ']'
  { RAL($1.mod,$1.modlev+1,struct modstuff);
    $1.mod[$1.modlev].null=0; $1.mod[$1.modlev].mod=MAR_ELE;
    if($3.c.t!=PRSTRING) free($3.p.d);
    if(!$3.const||$3.c.t!=PRLONG)
    { fatal=1; yyerror("illegal type: non-constant in declarator"); }
    else $1.mod[$1.modlev].u.arr=$3.c.u.l;
    $1.modlev++;
    $$=$1;
  }
;
exp2nd: exp1st
  { $$=$1; }
 | exp1st '?' exp2nd ':' exp2nd
  { /* OSTARTQ $1 LB TR $3 JMP NEW LB FS $5 LB NEW OENDQ */
    questcollonop(&($$),&($1),&($3),&($5));
  }
;
Lexpression: exp2nd
  { stringstf(&($1)); $$=$1; }
 | exp2nd '=' Lexpression
  { stringstf(&($1));
    assignop(&($$),&($1),&($3));
  }
 | exp2nd COMPLEX_E Lexpression
  { /*[+\-/*%^&|]"=" */
    complexassignop(&($$),&($1),$2,&($3));
  }
;
expression: Lexpression
  { $$=$1; }
 | expression ',' Lexpression
  { $$=$3;
    $$.p=$1.p;
    if($1.tcnt||$1.fcnt)
    { yyerror("warning: comparison accomplishes nothing in , operator");
      $1=mkvalue($1);
    }
    b=$1.p.l+2;
    for(a=0;a<$$.tcnt;a++) $$.tpoint[a]+=b;
    for(a=0;a<$$.fcnt;a++) $$.fpoint[a]+=b;
    RAL($$.p.d,$$.p.l+$3.p.l+3,char);
    memmove($$.p.d+1,$$.p.d,$$.p.l); *($$.p.d)=OSTARTCOMMA; $$.p.l++;
    $$.p.d[$$.p.l++]=OPOP;
    memcpy($$.p.d+$$.p.l,$3.p.d,$3.p.l); $$.p.l+=$3.p.l;
    $$.p.d[$$.p.l++]=OENDCOMMA;
    $$.const=0; /* if needed as constant, why the heck a comma operator?
                 * also prevents erasure of 1st something useful */
  }
;
Lexplist: Lexpression
  { AL($$.exp,1,struct expr);
    *($$.exp)=$1;
    $$.cnt=1;
  }
 | Lexplist ',' Lexpression
  { $$=$1;
    RAL($$.exp,$$.cnt+1,struct expr);
    $$.exp[$$.cnt++]=$3;
  }
;
